#line 1 "C:/Users/Public/Projects/ARM/Projects/WiFiClick/WiFiTEst_Code/mikroC PRO for ARM/Timer0.c"
#line 1 "c:/users/public/projects/arm/projects/wificlick/wifitest_code/mikroc pro for arm/timer0.h"
#line 9 "c:/users/public/projects/arm/projects/wificlick/wifitest_code/mikroc pro for arm/timer0.h"
void TimerInit();
void TimerCheck();
#line 31 "c:/users/public/projects/arm/projects/wificlick/wifitest_code/mikroc pro for arm/timer0.h"
struct timers {
 unsigned long int TimerField;
 unsigned short int Free;
};
#line 43 "c:/users/public/projects/arm/projects/wificlick/wifitest_code/mikroc pro for arm/timer0.h"
void init_timerpool(void);
#line 52 "c:/users/public/projects/arm/projects/wificlick/wifitest_code/mikroc pro for arm/timer0.h"
unsigned short int get_timer(void);
#line 61 "c:/users/public/projects/arm/projects/wificlick/wifitest_code/mikroc pro for arm/timer0.h"
void free_timer(unsigned short int nbr);
#line 71 "c:/users/public/projects/arm/projects/wificlick/wifitest_code/mikroc pro for arm/timer0.h"
void set_timer(unsigned short int nbr, unsigned long int tout);
#line 80 "c:/users/public/projects/arm/projects/wificlick/wifitest_code/mikroc pro for arm/timer0.h"
unsigned long int check_timer(unsigned short int nbr);
#line 89 "c:/users/public/projects/arm/projects/wificlick/wifitest_code/mikroc pro for arm/timer0.h"
void irqhandler_timer(void);
#line 1 "c:/users/public/projects/arm/projects/wificlick/wifitest_code/mikroc pro for arm/__time.h"
#line 27 "c:/users/public/projects/arm/projects/wificlick/wifitest_code/mikroc pro for arm/__time.h"
typedef struct
 {
 unsigned char ss ;
 unsigned char mn ;
 unsigned char hh ;
 unsigned char md ;
 unsigned char wd ;
 unsigned char mo ;
 unsigned int yy ;
 } TimeStruct ;
#line 41 "c:/users/public/projects/arm/projects/wificlick/wifitest_code/mikroc pro for arm/__time.h"
extern long Time_jd1970 ;
#line 46 "c:/users/public/projects/arm/projects/wificlick/wifitest_code/mikroc pro for arm/__time.h"
long Time_dateToEpoch(TimeStruct *ts) ;
long Time_dateDiff(TimeStruct *t1, TimeStruct *t2);
void Time_epochToDate(long e, TimeStruct *ts) ;
#line 1 "c:/users/public/projects/arm/projects/wificlick/wifitest_code/mikroc pro for arm/common.h"
#line 1 "c:/users/public/projects/arm/projects/wificlick/wifitest_code/mikroc pro for arm/usb_driver.h"
#line 11 "c:/users/public/projects/arm/projects/wificlick/wifitest_code/mikroc pro for arm/usb_driver.h"
typedef char *pnt;


typedef struct tx_q0_struct {
 unsigned int in;
 unsigned int out;
 pnt q[ 32 ];
}tx_q0_struct;



void USB_Init(void);
void USB_TxQueueInit(void);
void USB_PutQueue(char *msg);
void USB_CheckOut(void);
void USB_CheckIn(void);
#line 10 "C:/Users/Public/Projects/ARM/Projects/WiFiClick/WiFiTEst_Code/mikroC PRO for ARM/Timer0.c"
int TimerFlag = 0;
TimeStruct ts1;
long Epoch;




void Timer0A_interrupt() iv IVT_INT_TIMER0A {
 TIMER_ICR_TATOCINT_bit = 1;
 Epoch += 1;
 TimerFlag = 1;

}


void TimerInit() {

 SYSCTL_RCGC1_TIMER0_bit = 1;

 TIMER_CTL_TAEN_bit = 0;
 TIMER0_CFG = 0;
 TIMER0_TAMR |= 2;
 TIMER0_TAILR = Get_Fosc_kHz()*1000;
 NVIC_IntEnable(IVT_INT_TIMER0A);
 TIMER_IMR_TATOIM_bit = 1;
 TIMER_CTL_TAEN_bit = 1;

 ts1.ss = 0;
 ts1.mn = 0;
 ts1.hh = 0;
 ts1.md = 28;
 ts1.wd = 3;
 ts1.mo = 6;
 ts1.yy = 2012;

 Epoch = Time_dateToEpoch(&ts1);
}


void TimerCheck() {
 if (TimerFlag == 1) {
 TimerFlag = 0;
 Time_epochToDate(Epoch, &ts1);

 irqhandler_timer();
#line 64 "C:/Users/Public/Projects/ARM/Projects/WiFiClick/WiFiTEst_Code/mikroC PRO for ARM/Timer0.c"
 }
}
#line 82 "C:/Users/Public/Projects/ARM/Projects/WiFiClick/WiFiTEst_Code/mikroC PRO for ARM/Timer0.c"
struct timers TimerPool[ 10 ];
#line 91 "C:/Users/Public/Projects/ARM/Projects/WiFiClick/WiFiTEst_Code/mikroC PRO for ARM/Timer0.c"
void init_timerpool(void) {
 unsigned short int i;

 for (i=0; i <  10 ; i++) {
 TimerPool[i].TimerField = 0;
 TimerPool[i].Free =  1 ;
 }
}
#line 106 "C:/Users/Public/Projects/ARM/Projects/WiFiClick/WiFiTEst_Code/mikroC PRO for ARM/Timer0.c"
unsigned short int get_timer(void) {
 unsigned short int i;


 for (i=0; i <  10 ; i++) {
 if (TimerPool[i].Free ==  1 ) {


 TimerPool[i].Free =  0 ;


 return i;
 }
 }




 return (0);
}
#line 133 "C:/Users/Public/Projects/ARM/Projects/WiFiClick/WiFiTEst_Code/mikroC PRO for ARM/Timer0.c"
void free_timer(unsigned short int nbr) {

 if (nbr > ( 10 -1))
 return;

 TimerPool[nbr].Free =  1 ;
}
#line 148 "C:/Users/Public/Projects/ARM/Projects/WiFiClick/WiFiTEst_Code/mikroC PRO for ARM/Timer0.c"
void set_timer(unsigned short int nbr, unsigned long int tout) {



 if (nbr > ( 10 -1))
 return;

 if (TimerPool[nbr].Free ==  1 )
 return;






 TimerPool[nbr].TimerField = tout;
}
#line 172 "C:/Users/Public/Projects/ARM/Projects/WiFiClick/WiFiTEst_Code/mikroC PRO for ARM/Timer0.c"
unsigned long int check_timer(unsigned short int nbr) {
 return TimerPool[nbr].TimerField;
}
#line 182 "C:/Users/Public/Projects/ARM/Projects/WiFiClick/WiFiTEst_Code/mikroC PRO for ARM/Timer0.c"
void irqhandler_timer(void) {
 unsigned short int i;

 for (i=0; i< 10 ; i++) {
 if (TimerPool[i].Free ==  0  && TimerPool[i].TimerField != 0)
 TimerPool[i].TimerField--;
 }
}
