_UART0Init:
;UART0.c,78 :: 		void UART0Init(void) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;UART0.c,79 :: 		UART0_RxQueueInit();
BL	_UART0_RxQueueInit+0
;UART0.c,80 :: 		UART0_TxQueueInit();
BL	_UART0_TxQueueInit+0
;UART0.c,82 :: 		UART0_Initialize();     // Use library routine
BL	_UART0_Initialize+0
;UART0.c,83 :: 		}
L_end_UART0Init:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _UART0Init
_UART0_Initialize:
;UART0.c,87 :: 		void UART0_Initialize(void) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;UART0.c,90 :: 		_UART_HIGH_SPEED, &_GPIO_MODULE_UART0_A01);
MOVW	R2, #lo_addr(__GPIO_MODULE_UART0_A01+0)
MOVT	R2, #hi_addr(__GPIO_MODULE_UART0_A01+0)
MOVW	R1, #32
;UART0.c,89 :: 		UART0_Init_Advanced(9600, 80000, _UART_8_BIT_DATA, _UART_NOPARITY, _UART_TWO_STOPBITS,
MOVW	R0, #8
;UART0.c,90 :: 		_UART_HIGH_SPEED, &_GPIO_MODULE_UART0_A01);
PUSH	(R2)
PUSH	(R1)
;UART0.c,89 :: 		UART0_Init_Advanced(9600, 80000, _UART_8_BIT_DATA, _UART_NOPARITY, _UART_TWO_STOPBITS,
PUSH	(R0)
MOVW	R3, #0
MOVW	R2, #96
MOVW	R1, #14464
MOVT	R1, #1
MOVW	R0, #9600
;UART0.c,90 :: 		_UART_HIGH_SPEED, &_GPIO_MODULE_UART0_A01);
;UART0.c,89 :: 		UART0_Init_Advanced(9600, 80000, _UART_8_BIT_DATA, _UART_NOPARITY, _UART_TWO_STOPBITS,
;UART0.c,90 :: 		_UART_HIGH_SPEED, &_GPIO_MODULE_UART0_A01);
BL	_UART0_Init_Advanced+0
ADD	SP, SP, #12
;UART0.c,92 :: 		Delay_ms(1000);
MOVW	R7, #13823
MOVT	R7, #366
NOP
NOP
L_UART0_Initialize0:
SUBS	R7, R7, #1
BNE	L_UART0_Initialize0
NOP
NOP
;UART0.c,93 :: 		}
L_end_UART0_Initialize:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _UART0_Initialize
_UART0_RxQueueInit:
;UART0.c,100 :: 		void UART0_RxQueueInit(void) {
;UART0.c,101 :: 		RxIn = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_RxIn+0)
MOVT	R0, #hi_addr(_RxIn+0)
STRB	R1, [R0, #0]
;UART0.c,102 :: 		RxOut = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_RxOut+0)
MOVT	R0, #hi_addr(_RxOut+0)
STRB	R1, [R0, #0]
;UART0.c,103 :: 		RcvBufPtr = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_RcvBufPtr+0)
MOVT	R0, #hi_addr(_RcvBufPtr+0)
STRH	R1, [R0, #0]
;UART0.c,104 :: 		}
L_end_UART0_RxQueueInit:
BX	LR
; end of _UART0_RxQueueInit
_UART0_Receive_Char:
;UART0.c,108 :: 		void UART0_Receive_Char(void) {
SUB	SP, SP, #12
STR	LR, [SP, #0]
;UART0.c,109 :: 		if  (UART0_Data_Ready()) {
BL	_UART0_Data_Ready+0
CMP	R0, #0
IT	EQ
BEQ	L_UART0_Receive_Char2
;UART0.c,110 :: 		RxQueue[RxIn++] = UART0_Read();
MOVW	R0, #lo_addr(_RxIn+0)
MOVT	R0, #hi_addr(_RxIn+0)
STR	R0, [SP, #8]
LDRB	R1, [R0, #0]
MOVW	R0, #lo_addr(_RxQueue+0)
MOVT	R0, #hi_addr(_RxQueue+0)
ADDS	R0, R0, R1
STR	R0, [SP, #4]
BL	_UART0_Read+0
LDR	R1, [SP, #4]
STRB	R0, [R1, #0]
LDR	R1, [SP, #8]
MOV	R0, R1
LDRB	R0, [R0, #0]
ADDS	R0, R0, #1
UXTB	R0, R0
STRB	R0, [R1, #0]
;UART0.c,111 :: 		if (RxIn > (rxqsize-1)) {
CMP	R0, #255
IT	LS
BLS	L_UART0_Receive_Char3
;UART0.c,112 :: 		RxIn = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_RxIn+0)
MOVT	R0, #hi_addr(_RxIn+0)
STRB	R1, [R0, #0]
;UART0.c,113 :: 		}
L_UART0_Receive_Char3:
;UART0.c,114 :: 		}
L_UART0_Receive_Char2:
;UART0.c,115 :: 		}
L_end_UART0_Receive_Char:
LDR	LR, [SP, #0]
ADD	SP, SP, #12
BX	LR
; end of _UART0_Receive_Char
_UART0_GetChar:
;UART0.c,121 :: 		char UART0_GetChar(char *rxbyte) {
;UART0.c,122 :: 		if (RxIn != RxOut){
MOVW	R1, #lo_addr(_RxOut+0)
MOVT	R1, #hi_addr(_RxOut+0)
LDRB	R2, [R1, #0]
MOVW	R1, #lo_addr(_RxIn+0)
MOVT	R1, #hi_addr(_RxIn+0)
LDRB	R1, [R1, #0]
CMP	R1, R2
IT	EQ
BEQ	L_UART0_GetChar4
;UART0.c,123 :: 		*rxbyte = RxQueue[RxOut++];
MOVW	R3, #lo_addr(_RxOut+0)
MOVT	R3, #hi_addr(_RxOut+0)
LDRB	R2, [R3, #0]
MOVW	R1, #lo_addr(_RxQueue+0)
MOVT	R1, #hi_addr(_RxQueue+0)
ADDS	R1, R1, R2
LDRB	R1, [R1, #0]
STRB	R1, [R0, #0]
MOV	R1, R3
LDRB	R1, [R1, #0]
ADDS	R1, R1, #1
UXTB	R1, R1
STRB	R1, [R3, #0]
;UART0.c,124 :: 		if (RxOut > (rxqsize-1))
CMP	R1, #255
IT	LS
BLS	L_UART0_GetChar5
;UART0.c,125 :: 		RxOut = 0;
MOVS	R2, #0
MOVW	R1, #lo_addr(_RxOut+0)
MOVT	R1, #hi_addr(_RxOut+0)
STRB	R2, [R1, #0]
L_UART0_GetChar5:
;UART0.c,126 :: 		return 1;
MOVS	R0, #1
IT	AL
BAL	L_end_UART0_GetChar
;UART0.c,127 :: 		}else{
L_UART0_GetChar4:
;UART0.c,128 :: 		return 0;
MOVS	R0, #0
;UART0.c,130 :: 		}
L_end_UART0_GetChar:
BX	LR
; end of _UART0_GetChar
_UART0_Rx:
;UART0.c,134 :: 		void UART0_Rx(void) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;UART0.c,135 :: 		UART0_RxFuncPtr();    // Use the function pointer to go to a state
MOVW	R4, #lo_addr(_UART0_RxFuncPtr+0)
MOVT	R4, #hi_addr(_UART0_RxFuncPtr+0)
LDR	R4, [R4, #0]
BLX	R4
;UART0.c,136 :: 		}
L_end_UART0_Rx:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _UART0_Rx
_UART0_Rx1:
;UART0.c,140 :: 		void UART0_Rx1(void) {
SUB	SP, SP, #12
STR	LR, [SP, #0]
;UART0.c,145 :: 		if  (UART0_GetChar(&rxchar)) {
ADD	R0, SP, #8
BL	_UART0_GetChar+0
CMP	R0, #0
IT	EQ
BEQ	L_UART0_Rx17
;UART0.c,148 :: 		switch (RxState) {
IT	AL
BAL	L_UART0_Rx18
;UART0.c,149 :: 		case 0: // Looking for header0 character
L_UART0_Rx110:
;UART0.c,150 :: 		if (rxchar == 0x55)
LDRB	R0, [SP, #8]
CMP	R0, #85
IT	NE
BNE	L_UART0_Rx111
;UART0.c,151 :: 		RxState = 1;
MOVS	R1, #1
MOVW	R0, #lo_addr(_RxState+0)
MOVT	R0, #hi_addr(_RxState+0)
STRB	R1, [R0, #0]
IT	AL
BAL	L_UART0_Rx112
L_UART0_Rx111:
;UART0.c,153 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
; BufNum start address is: 12 (R3)
MOV	R3, R0
;UART0.c,154 :: 		sprintf(BufNum,"Extra char: %02X\r\n",rxchar);
LDRB	R2, [SP, #8]
MOVW	R1, #lo_addr(?lstr_1_UART0+0)
MOVT	R1, #hi_addr(?lstr_1_UART0+0)
STR	R3, [SP, #4]
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
LDR	R3, [SP, #4]
;UART0.c,155 :: 		USB_PutQueue(BufNum);
MOV	R0, R3
; BufNum end address is: 12 (R3)
BL	_USB_PutQueue+0
;UART0.c,156 :: 		}
L_UART0_Rx112:
;UART0.c,157 :: 		break;
IT	AL
BAL	L_UART0_Rx19
;UART0.c,158 :: 		case 1: // Looking for header1 character
L_UART0_Rx113:
;UART0.c,159 :: 		if (rxchar == 0xAA)
LDRB	R0, [SP, #8]
CMP	R0, #170
IT	NE
BNE	L_UART0_Rx114
;UART0.c,160 :: 		RxState = 2; // Expected
MOVS	R1, #2
MOVW	R0, #lo_addr(_RxState+0)
MOVT	R0, #hi_addr(_RxState+0)
STRB	R1, [R0, #0]
IT	AL
BAL	L_UART0_Rx115
L_UART0_Rx114:
;UART0.c,162 :: 		USB_PutQueue("Incorrect header 1 character\r\n");
MOVW	R0, #lo_addr(?lstr2_UART0+0)
MOVT	R0, #hi_addr(?lstr2_UART0+0)
BL	_USB_PutQueue+0
;UART0.c,163 :: 		RxState = 0; // Unexpected
MOVS	R1, #0
MOVW	R0, #lo_addr(_RxState+0)
MOVT	R0, #hi_addr(_RxState+0)
STRB	R1, [R0, #0]
;UART0.c,164 :: 		}
L_UART0_Rx115:
;UART0.c,165 :: 		break;
IT	AL
BAL	L_UART0_Rx19
;UART0.c,166 :: 		case 2: // Looking for message type 0 character (little-endian)
L_UART0_Rx116:
;UART0.c,167 :: 		MsgType0 = rxchar;
LDRB	R1, [SP, #8]
MOVW	R0, #lo_addr(_MsgType0+0)
MOVT	R0, #hi_addr(_MsgType0+0)
STRB	R1, [R0, #0]
;UART0.c,168 :: 		RxState = 3;
MOVS	R1, #3
MOVW	R0, #lo_addr(_RxState+0)
MOVT	R0, #hi_addr(_RxState+0)
STRB	R1, [R0, #0]
;UART0.c,169 :: 		break;
IT	AL
BAL	L_UART0_Rx19
;UART0.c,170 :: 		case 3: // Looking for message type 1 character (little-endian)
L_UART0_Rx117:
;UART0.c,171 :: 		MsgType1 = rxchar;
LDRB	R1, [SP, #8]
MOVW	R0, #lo_addr(_MsgType1+0)
MOVT	R0, #hi_addr(_MsgType1+0)
STRB	R1, [R0, #0]
;UART0.c,172 :: 		RxState = 4;
MOVS	R1, #4
MOVW	R0, #lo_addr(_RxState+0)
MOVT	R0, #hi_addr(_RxState+0)
STRB	R1, [R0, #0]
;UART0.c,173 :: 		break;
IT	AL
BAL	L_UART0_Rx19
;UART0.c,174 :: 		case 4: // Looking for message data length 0 character (little-endian)
L_UART0_Rx118:
;UART0.c,175 :: 		MsgDL0 = rxchar;
LDRB	R1, [SP, #8]
MOVW	R0, #lo_addr(_MsgDL0+0)
MOVT	R0, #hi_addr(_MsgDL0+0)
STRB	R1, [R0, #0]
;UART0.c,176 :: 		RxState = 5;
MOVS	R1, #5
MOVW	R0, #lo_addr(_RxState+0)
MOVT	R0, #hi_addr(_RxState+0)
STRB	R1, [R0, #0]
;UART0.c,177 :: 		break;
IT	AL
BAL	L_UART0_Rx19
;UART0.c,178 :: 		case 5: // Looking for message data length 1 character (little-endian)
L_UART0_Rx119:
;UART0.c,179 :: 		MsgDL1 = rxchar;
LDRB	R1, [SP, #8]
MOVW	R0, #lo_addr(_MsgDL1+0)
MOVT	R0, #hi_addr(_MsgDL1+0)
STRB	R1, [R0, #0]
;UART0.c,181 :: 		RxMsgLength = MsgDL0; // Compute message length
MOVW	R0, #lo_addr(_MsgDL0+0)
MOVT	R0, #hi_addr(_MsgDL0+0)
LDRB	R0, [R0, #0]
MOVW	R2, #lo_addr(_RxMsgLength+0)
MOVT	R2, #hi_addr(_RxMsgLength+0)
STRH	R0, [R2, #0]
;UART0.c,182 :: 		RxMsgLength |= (MsgDL1 << 8);
LDRB	R0, [SP, #8]
LSLS	R1, R0, #8
UXTH	R1, R1
MOV	R0, R2
LDRH	R0, [R0, #0]
ORRS	R0, R1
UXTH	R0, R0
STRH	R0, [R2, #0]
;UART0.c,184 :: 		if (RxMsgLength == 0) {
CMP	R0, #0
IT	NE
BNE	L_UART0_Rx120
;UART0.c,185 :: 		if ((MsgType0 == 0) && (MsgType1 == 128))
MOVW	R0, #lo_addr(_MsgType0+0)
MOVT	R0, #hi_addr(_MsgType0+0)
LDRB	R0, [R0, #0]
CMP	R0, #0
IT	NE
BNE	L__UART0_Rx1130
MOVW	R0, #lo_addr(_MsgType1+0)
MOVT	R0, #hi_addr(_MsgType1+0)
LDRB	R0, [R0, #0]
CMP	R0, #128
IT	NE
BNE	L__UART0_Rx1129
L__UART0_Rx1128:
;UART0.c,186 :: 		RxState = 8; // ACK has no trailer according to the manual ??????
MOVS	R1, #8
MOVW	R0, #lo_addr(_RxState+0)
MOVT	R0, #hi_addr(_RxState+0)
STRB	R1, [R0, #0]
IT	AL
BAL	L_UART0_Rx124
;UART0.c,185 :: 		if ((MsgType0 == 0) && (MsgType1 == 128))
L__UART0_Rx1130:
L__UART0_Rx1129:
;UART0.c,188 :: 		RxState = 7; // No data field
MOVS	R1, #7
MOVW	R0, #lo_addr(_RxState+0)
MOVT	R0, #hi_addr(_RxState+0)
STRB	R1, [R0, #0]
L_UART0_Rx124:
;UART0.c,189 :: 		} else {
IT	AL
BAL	L_UART0_Rx125
L_UART0_Rx120:
;UART0.c,190 :: 		RcvBufPtr = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_RcvBufPtr+0)
MOVT	R0, #hi_addr(_RcvBufPtr+0)
STRH	R1, [R0, #0]
;UART0.c,191 :: 		RxState = 6; // Some data
MOVS	R1, #6
MOVW	R0, #lo_addr(_RxState+0)
MOVT	R0, #hi_addr(_RxState+0)
STRB	R1, [R0, #0]
;UART0.c,192 :: 		}
L_UART0_Rx125:
;UART0.c,193 :: 		break;
IT	AL
BAL	L_UART0_Rx19
;UART0.c,195 :: 		case 6: // Get the data
L_UART0_Rx126:
;UART0.c,196 :: 		RcvBuf[RcvBufPtr++] = rxchar;
MOVW	R2, #lo_addr(_RcvBufPtr+0)
MOVT	R2, #hi_addr(_RcvBufPtr+0)
LDRH	R1, [R2, #0]
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
ADDS	R1, R0, R1
LDRB	R0, [SP, #8]
STRB	R0, [R1, #0]
MOV	R0, R2
LDRH	R0, [R0, #0]
ADDS	R1, R0, #1
UXTH	R1, R1
STRH	R1, [R2, #0]
;UART0.c,197 :: 		if (RcvBufPtr == RxMsgLength)
MOVW	R0, #lo_addr(_RxMsgLength+0)
MOVT	R0, #hi_addr(_RxMsgLength+0)
LDRH	R0, [R0, #0]
CMP	R1, R0
IT	NE
BNE	L_UART0_Rx127
;UART0.c,198 :: 		RxState = 7;
MOVS	R1, #7
MOVW	R0, #lo_addr(_RxState+0)
MOVT	R0, #hi_addr(_RxState+0)
STRB	R1, [R0, #0]
L_UART0_Rx127:
;UART0.c,199 :: 		break;
IT	AL
BAL	L_UART0_Rx19
;UART0.c,201 :: 		case 7: // Looking for trailer
L_UART0_Rx128:
;UART0.c,202 :: 		if (rxchar == 0x45) {
LDRB	R0, [SP, #8]
CMP	R0, #69
IT	NE
BNE	L_UART0_Rx129
;UART0.c,204 :: 		UART0_RxFuncPtr = UART0_Rx2; // Go to Rx2 to process message
MOVW	R1, #lo_addr(_UART0_Rx2+0)
MOVT	R1, #hi_addr(_UART0_Rx2+0)
MOVW	R0, #lo_addr(_UART0_RxFuncPtr+0)
MOVT	R0, #hi_addr(_UART0_RxFuncPtr+0)
STR	R1, [R0, #0]
;UART0.c,205 :: 		} else {
IT	AL
BAL	L_UART0_Rx130
L_UART0_Rx129:
;UART0.c,206 :: 		USB_PutQueue("Missing trailer character\r\n");
MOVW	R0, #lo_addr(?lstr3_UART0+0)
MOVT	R0, #hi_addr(?lstr3_UART0+0)
BL	_USB_PutQueue+0
;UART0.c,207 :: 		}
L_UART0_Rx130:
;UART0.c,208 :: 		RxState = 0; // Finished receiving the packet
MOVS	R1, #0
MOVW	R0, #lo_addr(_RxState+0)
MOVT	R0, #hi_addr(_RxState+0)
STRB	R1, [R0, #0]
;UART0.c,209 :: 		break;
IT	AL
BAL	L_UART0_Rx19
;UART0.c,211 :: 		case 8: // ACK received
L_UART0_Rx131:
;UART0.c,212 :: 		ACK_Received = TRUE;
MOVS	R1, #1
MOVW	R0, #lo_addr(_ACK_Received+0)
MOVT	R0, #hi_addr(_ACK_Received+0)
STRB	R1, [R0, #0]
;UART0.c,213 :: 		USB_PutQueue("ACK received\r\n");
MOVW	R0, #lo_addr(?lstr4_UART0+0)
MOVT	R0, #hi_addr(?lstr4_UART0+0)
BL	_USB_PutQueue+0
;UART0.c,214 :: 		RxState = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_RxState+0)
MOVT	R0, #hi_addr(_RxState+0)
STRB	R1, [R0, #0]
;UART0.c,215 :: 		break;
IT	AL
BAL	L_UART0_Rx19
;UART0.c,216 :: 		}
L_UART0_Rx18:
MOVW	R0, #lo_addr(_RxState+0)
MOVT	R0, #hi_addr(_RxState+0)
LDRB	R0, [R0, #0]
CMP	R0, #0
IT	EQ
BEQ	L_UART0_Rx110
MOVW	R0, #lo_addr(_RxState+0)
MOVT	R0, #hi_addr(_RxState+0)
LDRB	R0, [R0, #0]
CMP	R0, #1
IT	EQ
BEQ	L_UART0_Rx113
MOVW	R0, #lo_addr(_RxState+0)
MOVT	R0, #hi_addr(_RxState+0)
LDRB	R0, [R0, #0]
CMP	R0, #2
IT	EQ
BEQ	L_UART0_Rx116
MOVW	R0, #lo_addr(_RxState+0)
MOVT	R0, #hi_addr(_RxState+0)
LDRB	R0, [R0, #0]
CMP	R0, #3
IT	EQ
BEQ	L_UART0_Rx117
MOVW	R0, #lo_addr(_RxState+0)
MOVT	R0, #hi_addr(_RxState+0)
LDRB	R0, [R0, #0]
CMP	R0, #4
IT	EQ
BEQ	L_UART0_Rx118
MOVW	R0, #lo_addr(_RxState+0)
MOVT	R0, #hi_addr(_RxState+0)
LDRB	R0, [R0, #0]
CMP	R0, #5
IT	EQ
BEQ	L_UART0_Rx119
MOVW	R0, #lo_addr(_RxState+0)
MOVT	R0, #hi_addr(_RxState+0)
LDRB	R0, [R0, #0]
CMP	R0, #6
IT	EQ
BEQ	L_UART0_Rx126
MOVW	R0, #lo_addr(_RxState+0)
MOVT	R0, #hi_addr(_RxState+0)
LDRB	R0, [R0, #0]
CMP	R0, #7
IT	EQ
BEQ	L_UART0_Rx128
MOVW	R0, #lo_addr(_RxState+0)
MOVT	R0, #hi_addr(_RxState+0)
LDRB	R0, [R0, #0]
CMP	R0, #8
IT	EQ
BEQ	L_UART0_Rx131
L_UART0_Rx19:
;UART0.c,217 :: 		}
L_UART0_Rx17:
;UART0.c,218 :: 		}
L_end_UART0_Rx1:
LDR	LR, [SP, #0]
ADD	SP, SP, #12
BX	LR
; end of _UART0_Rx1
_UART0_Rx2:
;UART0.c,222 :: 		void UART0_Rx2(void) {
SUB	SP, SP, #12
STR	LR, [SP, #0]
;UART0.c,229 :: 		USB_PutQueue("\r\nWiFi message received\r\n");
MOVW	R0, #lo_addr(?lstr5_UART0+0)
MOVT	R0, #hi_addr(?lstr5_UART0+0)
BL	_USB_PutQueue+0
;UART0.c,231 :: 		MT0 = MsgType0;
MOVW	R0, #lo_addr(_MsgType0+0)
MOVT	R0, #hi_addr(_MsgType0+0)
; MT0 start address is: 24 (R6)
LDRB	R6, [R0, #0]
;UART0.c,232 :: 		MT1 = MsgType1;
MOVW	R0, #lo_addr(_MsgType1+0)
MOVT	R0, #hi_addr(_MsgType1+0)
; MT1 start address is: 28 (R7)
LDRB	R7, [R0, #0]
;UART0.c,233 :: 		DL0 = MsgDL0;
MOVW	R0, #lo_addr(_MsgDL0+0)
MOVT	R0, #hi_addr(_MsgDL0+0)
; DL0 start address is: 4 (R1)
LDRB	R1, [R0, #0]
;UART0.c,234 :: 		DL1 = MsgDL1;
MOVW	R0, #lo_addr(_MsgDL1+0)
MOVT	R0, #hi_addr(_MsgDL1+0)
; DL1 start address is: 8 (R2)
LDRB	R2, [R0, #0]
;UART0.c,235 :: 		BufNum = GetBuffer();         // Get a free buffer
STRH	R2, [SP, #4]
STRH	R1, [SP, #6]
STRH	R7, [SP, #8]
STRH	R6, [SP, #10]
BL	_GetBuffer+0
LDRH	R6, [SP, #10]
LDRH	R7, [SP, #8]
LDRH	R1, [SP, #6]
LDRH	R2, [SP, #4]
; BufNum start address is: 32 (R8)
MOV	R8, R0
;UART0.c,236 :: 		sprintf(BufNum,"MT0: %u, MT1: %u, DL0: %u, DL1: %u\r\n",MT0,MT1,DL0,DL1);
UXTH	R5, R2
; DL1 end address is: 8 (R2)
UXTH	R4, R1
; DL0 end address is: 4 (R1)
UXTH	R3, R7
UXTH	R2, R6
MOVW	R1, #lo_addr(?lstr_6_UART0+0)
MOVT	R1, #hi_addr(?lstr_6_UART0+0)
STR	R8, [SP, #4]
STRH	R7, [SP, #8]
STRH	R6, [SP, #10]
PUSH	(R5)
PUSH	(R4)
PUSH	(R3)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #24
LDRH	R6, [SP, #10]
LDRH	R7, [SP, #8]
LDR	R8, [SP, #4]
;UART0.c,237 :: 		USB_PutQueue(BufNum);         // Send the buffer out USB port
STRH	R7, [SP, #4]
; BufNum end address is: 32 (R8)
STRH	R6, [SP, #6]
MOV	R0, R8
BL	_USB_PutQueue+0
LDRH	R6, [SP, #6]
LDRH	R7, [SP, #4]
;UART0.c,239 :: 		switch(MT0) {
IT	AL
BAL	L_UART0_Rx232
; MT0 end address is: 24 (R6)
; MT1 end address is: 28 (R7)
;UART0.c,240 :: 		case 0x01: // EVENT_MSG
L_UART0_Rx234:
;UART0.c,241 :: 		switch (RcvBuf[0]) {
IT	AL
BAL	L_UART0_Rx235
;UART0.c,242 :: 		case 0x08: // Event Type: Wi-Fi Connection Status Changed Event = 8
L_UART0_Rx237:
;UART0.c,243 :: 		WiFiEvents.ConStatChng = TRUE;  // Post event
MOVS	R1, #1
MOVW	R0, #lo_addr(_WiFiEvents+0)
MOVT	R0, #hi_addr(_WiFiEvents+0)
STRB	R1, [R0, #0]
;UART0.c,244 :: 		ConnectStatus = RcvBuf[1];
MOVW	R0, #lo_addr(_RcvBuf+1)
MOVT	R0, #hi_addr(_RcvBuf+1)
LDRB	R1, [R0, #0]
MOVW	R0, #lo_addr(_ConnectStatus+0)
MOVT	R0, #hi_addr(_ConnectStatus+0)
STRB	R1, [R0, #0]
;UART0.c,245 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
;UART0.c,246 :: 		switch (RcvBuf[1]) {
IT	AL
BAL	L_UART0_Rx238
;UART0.c,247 :: 		case 0x01: USB_PutQueue("Connection attempt succeeded\r\n"); break;
L_UART0_Rx240:
MOVW	R0, #lo_addr(?lstr7_UART0+0)
MOVT	R0, #hi_addr(?lstr7_UART0+0)
BL	_USB_PutQueue+0
IT	AL
BAL	L_UART0_Rx239
;UART0.c,248 :: 		case 0x02: USB_PutQueue("Connection attempt failed\r\n"); break;
L_UART0_Rx241:
MOVW	R0, #lo_addr(?lstr8_UART0+0)
MOVT	R0, #hi_addr(?lstr8_UART0+0)
BL	_USB_PutQueue+0
IT	AL
BAL	L_UART0_Rx239
;UART0.c,249 :: 		case 0x03: USB_PutQueue("Connection temporarily lost\r\n"); break;
L_UART0_Rx242:
MOVW	R0, #lo_addr(?lstr9_UART0+0)
MOVT	R0, #hi_addr(?lstr9_UART0+0)
BL	_USB_PutQueue+0
IT	AL
BAL	L_UART0_Rx239
;UART0.c,250 :: 		case 0x04: USB_PutQueue("Connection reestablished\r\n"); break;
L_UART0_Rx243:
MOVW	R0, #lo_addr(?lstr10_UART0+0)
MOVT	R0, #hi_addr(?lstr10_UART0+0)
BL	_USB_PutQueue+0
IT	AL
BAL	L_UART0_Rx239
;UART0.c,251 :: 		case 0x05: USB_PutQueue("Connection permanently lost\r\n"); break;
L_UART0_Rx244:
MOVW	R0, #lo_addr(?lstr11_UART0+0)
MOVT	R0, #hi_addr(?lstr11_UART0+0)
BL	_USB_PutQueue+0
IT	AL
BAL	L_UART0_Rx239
;UART0.c,252 :: 		}
L_UART0_Rx238:
MOVW	R0, #lo_addr(_RcvBuf+1)
MOVT	R0, #hi_addr(_RcvBuf+1)
LDRB	R0, [R0, #0]
CMP	R0, #1
IT	EQ
BEQ	L_UART0_Rx240
MOVW	R0, #lo_addr(_RcvBuf+1)
MOVT	R0, #hi_addr(_RcvBuf+1)
LDRB	R0, [R0, #0]
CMP	R0, #2
IT	EQ
BEQ	L_UART0_Rx241
MOVW	R0, #lo_addr(_RcvBuf+1)
MOVT	R0, #hi_addr(_RcvBuf+1)
LDRB	R0, [R0, #0]
CMP	R0, #3
IT	EQ
BEQ	L_UART0_Rx242
MOVW	R0, #lo_addr(_RcvBuf+1)
MOVT	R0, #hi_addr(_RcvBuf+1)
LDRB	R0, [R0, #0]
CMP	R0, #4
IT	EQ
BEQ	L_UART0_Rx243
MOVW	R0, #lo_addr(_RcvBuf+1)
MOVT	R0, #hi_addr(_RcvBuf+1)
LDRB	R0, [R0, #0]
CMP	R0, #5
IT	EQ
BEQ	L_UART0_Rx244
L_UART0_Rx239:
;UART0.c,253 :: 		break;
IT	AL
BAL	L_UART0_Rx236
;UART0.c,254 :: 		case 0x09: // Event Type: Wi-Fi Scan Results Ready Event = 9
L_UART0_Rx245:
;UART0.c,255 :: 		WiFiEvents.ScnRsltRdy = TRUE;  // Post event
MOVS	R1, #1
MOVW	R0, #lo_addr(_WiFiEvents+1)
MOVT	R0, #hi_addr(_WiFiEvents+1)
STRB	R1, [R0, #0]
;UART0.c,256 :: 		NumScanRslts = RcvBuf[1];  // Save number of scan results
MOVW	R0, #lo_addr(_RcvBuf+1)
MOVT	R0, #hi_addr(_RcvBuf+1)
LDRB	R1, [R0, #0]
MOVW	R0, #lo_addr(_NumScanRslts+0)
MOVT	R0, #hi_addr(_NumScanRslts+0)
STRB	R1, [R0, #0]
;UART0.c,257 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
; BufNum start address is: 12 (R3)
MOV	R3, R0
;UART0.c,258 :: 		sprintf(BufNum,"Number of scan results: %02X\r\n",RcvBuf[1]);
MOVW	R1, #lo_addr(_RcvBuf+1)
MOVT	R1, #hi_addr(_RcvBuf+1)
LDRB	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_12_UART0+0)
MOVT	R1, #hi_addr(?lstr_12_UART0+0)
STR	R3, [SP, #4]
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
LDR	R3, [SP, #4]
;UART0.c,259 :: 		USB_PutQueue(BufNum);
MOV	R0, R3
; BufNum end address is: 12 (R3)
BL	_USB_PutQueue+0
;UART0.c,260 :: 		break;
IT	AL
BAL	L_UART0_Rx236
;UART0.c,261 :: 		case 0x10: // Event Type: IP Address Assigned Event = 16
L_UART0_Rx246:
;UART0.c,262 :: 		WiFiEvents.IPAddrAss = TRUE;
MOVS	R1, #1
MOVW	R0, #lo_addr(_WiFiEvents+2)
MOVT	R0, #hi_addr(_WiFiEvents+2)
STRB	R1, [R0, #0]
;UART0.c,263 :: 		AssignedIP[0] = RcvBuf[2];
MOVW	R0, #lo_addr(_RcvBuf+2)
MOVT	R0, #hi_addr(_RcvBuf+2)
LDRB	R1, [R0, #0]
MOVW	R0, #lo_addr(_AssignedIP+0)
MOVT	R0, #hi_addr(_AssignedIP+0)
STRB	R1, [R0, #0]
;UART0.c,264 :: 		AssignedIP[1] = RcvBuf[3];
MOVW	R0, #lo_addr(_RcvBuf+3)
MOVT	R0, #hi_addr(_RcvBuf+3)
LDRB	R1, [R0, #0]
MOVW	R0, #lo_addr(_AssignedIP+1)
MOVT	R0, #hi_addr(_AssignedIP+1)
STRB	R1, [R0, #0]
;UART0.c,265 :: 		AssignedIP[2] = RcvBuf[4];
MOVW	R0, #lo_addr(_RcvBuf+4)
MOVT	R0, #hi_addr(_RcvBuf+4)
LDRB	R1, [R0, #0]
MOVW	R0, #lo_addr(_AssignedIP+2)
MOVT	R0, #hi_addr(_AssignedIP+2)
STRB	R1, [R0, #0]
;UART0.c,266 :: 		AssignedIP[3] = RcvBuf[5];
MOVW	R0, #lo_addr(_RcvBuf+5)
MOVT	R0, #hi_addr(_RcvBuf+5)
LDRB	R1, [R0, #0]
MOVW	R0, #lo_addr(_AssignedIP+3)
MOVT	R0, #hi_addr(_AssignedIP+3)
STRB	R1, [R0, #0]
;UART0.c,267 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
; BufNum start address is: 24 (R6)
MOV	R6, R0
;UART0.c,268 :: 		sprintf(BufNum,"IP address assigned: %u.%u.%u.%u\r\n",RcvBuf[2],RcvBuf[3],RcvBuf[4],RcvBuf[5]);
MOVW	R1, #lo_addr(_RcvBuf+5)
MOVT	R1, #hi_addr(_RcvBuf+5)
LDRB	R5, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+4)
MOVT	R1, #hi_addr(_RcvBuf+4)
LDRB	R4, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+3)
MOVT	R1, #hi_addr(_RcvBuf+3)
LDRB	R3, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+2)
MOVT	R1, #hi_addr(_RcvBuf+2)
LDRB	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_13_UART0+0)
MOVT	R1, #hi_addr(?lstr_13_UART0+0)
STR	R6, [SP, #4]
PUSH	(R5)
PUSH	(R4)
PUSH	(R3)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #24
LDR	R6, [SP, #4]
;UART0.c,269 :: 		USB_PutQueue(BufNum);
MOV	R0, R6
; BufNum end address is: 24 (R6)
BL	_USB_PutQueue+0
;UART0.c,270 :: 		break;
IT	AL
BAL	L_UART0_Rx236
;UART0.c,271 :: 		case 0x1A: // Event Type: Ping Response Event = 26
L_UART0_Rx247:
;UART0.c,272 :: 		WiFiEvents.PingResp = TRUE;
MOVS	R1, #1
MOVW	R0, #lo_addr(_WiFiEvents+3)
MOVT	R0, #hi_addr(_WiFiEvents+3)
STRB	R1, [R0, #0]
;UART0.c,273 :: 		if (RcvBuf[1] == 0)
MOVW	R0, #lo_addr(_RcvBuf+1)
MOVT	R0, #hi_addr(_RcvBuf+1)
LDRB	R0, [R0, #0]
CMP	R0, #0
IT	NE
BNE	L_UART0_Rx248
;UART0.c,274 :: 		USB_PutQueue("Valid ping response was received\r\n");
MOVW	R0, #lo_addr(?lstr14_UART0+0)
MOVT	R0, #hi_addr(?lstr14_UART0+0)
BL	_USB_PutQueue+0
IT	AL
BAL	L_UART0_Rx249
L_UART0_Rx248:
;UART0.c,275 :: 		else if (RcvBuf[1] == 1)
MOVW	R0, #lo_addr(_RcvBuf+1)
MOVT	R0, #hi_addr(_RcvBuf+1)
LDRB	R0, [R0, #0]
CMP	R0, #1
IT	NE
BNE	L_UART0_Rx250
;UART0.c,276 :: 		USB_PutQueue("Ping response time out\r\n");
MOVW	R0, #lo_addr(?lstr15_UART0+0)
MOVT	R0, #hi_addr(?lstr15_UART0+0)
BL	_USB_PutQueue+0
L_UART0_Rx250:
L_UART0_Rx249:
;UART0.c,277 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
; BufNum start address is: 16 (R4)
MOV	R4, R0
;UART0.c,278 :: 		sprintf(BufNum,"Response time: %02X %02X\r\n",RcvBuf[2],RcvBuf[3]);
MOVW	R1, #lo_addr(_RcvBuf+3)
MOVT	R1, #hi_addr(_RcvBuf+3)
LDRB	R3, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+2)
MOVT	R1, #hi_addr(_RcvBuf+2)
LDRB	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_16_UART0+0)
MOVT	R1, #hi_addr(?lstr_16_UART0+0)
STR	R4, [SP, #4]
PUSH	(R3)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #16
LDR	R4, [SP, #4]
;UART0.c,279 :: 		USB_PutQueue(BufNum);
MOV	R0, R4
; BufNum end address is: 16 (R4)
BL	_USB_PutQueue+0
;UART0.c,280 :: 		break;
IT	AL
BAL	L_UART0_Rx236
;UART0.c,281 :: 		case 0x1B: // Event Type: Startup Event = 27
L_UART0_Rx251:
;UART0.c,282 :: 		WiFiEvents.StartUp = TRUE;
MOVS	R1, #1
MOVW	R0, #lo_addr(_WiFiEvents+4)
MOVT	R0, #hi_addr(_WiFiEvents+4)
STRB	R1, [R0, #0]
;UART0.c,283 :: 		if ((RcvBuf[1] & 0x01) != 0)
MOVW	R0, #lo_addr(_RcvBuf+1)
MOVT	R0, #hi_addr(_RcvBuf+1)
LDRB	R0, [R0, #0]
AND	R0, R0, #1
UXTB	R0, R0
CMP	R0, #0
IT	EQ
BEQ	L_UART0_Rx252
;UART0.c,284 :: 		USB_PutQueue("Power on reset\r\n");
MOVW	R0, #lo_addr(?lstr17_UART0+0)
MOVT	R0, #hi_addr(?lstr17_UART0+0)
BL	_USB_PutQueue+0
L_UART0_Rx252:
;UART0.c,285 :: 		if ((RcvBuf[1] & 0x02) != 0)
MOVW	R0, #lo_addr(_RcvBuf+1)
MOVT	R0, #hi_addr(_RcvBuf+1)
LDRB	R0, [R0, #0]
AND	R0, R0, #2
UXTB	R0, R0
CMP	R0, #0
IT	EQ
BEQ	L_UART0_Rx253
;UART0.c,286 :: 		USB_PutQueue("Brown out reset\r\n");
MOVW	R0, #lo_addr(?lstr18_UART0+0)
MOVT	R0, #hi_addr(?lstr18_UART0+0)
BL	_USB_PutQueue+0
L_UART0_Rx253:
;UART0.c,287 :: 		if ((RcvBuf[1] & 0x04) != 0)
MOVW	R0, #lo_addr(_RcvBuf+1)
MOVT	R0, #hi_addr(_RcvBuf+1)
LDRB	R0, [R0, #0]
AND	R0, R0, #4
UXTB	R0, R0
CMP	R0, #0
IT	EQ
BEQ	L_UART0_Rx254
;UART0.c,288 :: 		USB_PutQueue("Idle reset\r\n");
MOVW	R0, #lo_addr(?lstr19_UART0+0)
MOVT	R0, #hi_addr(?lstr19_UART0+0)
BL	_USB_PutQueue+0
L_UART0_Rx254:
;UART0.c,289 :: 		if ((RcvBuf[1] & 0x08) != 0)
MOVW	R0, #lo_addr(_RcvBuf+1)
MOVT	R0, #hi_addr(_RcvBuf+1)
LDRB	R0, [R0, #0]
AND	R0, R0, #8
UXTB	R0, R0
CMP	R0, #0
IT	EQ
BEQ	L_UART0_Rx255
;UART0.c,290 :: 		USB_PutQueue("Sleep reset\r\n");
MOVW	R0, #lo_addr(?lstr20_UART0+0)
MOVT	R0, #hi_addr(?lstr20_UART0+0)
BL	_USB_PutQueue+0
L_UART0_Rx255:
;UART0.c,291 :: 		if ((RcvBuf[1] & 0x10) != 0)
MOVW	R0, #lo_addr(_RcvBuf+1)
MOVT	R0, #hi_addr(_RcvBuf+1)
LDRB	R0, [R0, #0]
AND	R0, R0, #16
UXTB	R0, R0
CMP	R0, #0
IT	EQ
BEQ	L_UART0_Rx256
;UART0.c,292 :: 		USB_PutQueue("Watchdog reset\r\n");
MOVW	R0, #lo_addr(?lstr21_UART0+0)
MOVT	R0, #hi_addr(?lstr21_UART0+0)
BL	_USB_PutQueue+0
L_UART0_Rx256:
;UART0.c,293 :: 		if ((RcvBuf[1] & 0x40) != 0)
MOVW	R0, #lo_addr(_RcvBuf+1)
MOVT	R0, #hi_addr(_RcvBuf+1)
LDRB	R0, [R0, #0]
AND	R0, R0, #64
UXTB	R0, R0
CMP	R0, #0
IT	EQ
BEQ	L_UART0_Rx257
;UART0.c,294 :: 		USB_PutQueue("Software reset\r\n");
MOVW	R0, #lo_addr(?lstr22_UART0+0)
MOVT	R0, #hi_addr(?lstr22_UART0+0)
BL	_USB_PutQueue+0
L_UART0_Rx257:
;UART0.c,295 :: 		if ((RcvBuf[1] & 0x80) != 0)
MOVW	R0, #lo_addr(_RcvBuf+1)
MOVT	R0, #hi_addr(_RcvBuf+1)
LDRB	R0, [R0, #0]
AND	R0, R0, #128
UXTB	R0, R0
CMP	R0, #0
IT	EQ
BEQ	L_UART0_Rx258
;UART0.c,296 :: 		USB_PutQueue("External reset\r\n");
MOVW	R0, #lo_addr(?lstr23_UART0+0)
MOVT	R0, #hi_addr(?lstr23_UART0+0)
BL	_USB_PutQueue+0
L_UART0_Rx258:
;UART0.c,297 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
; BufNum start address is: 16 (R4)
MOV	R4, R0
;UART0.c,298 :: 		sprintf(BufNum,"WiComm-socket version: %02X %02X\r\n",RcvBuf[2],RcvBuf[3]);
MOVW	R1, #lo_addr(_RcvBuf+3)
MOVT	R1, #hi_addr(_RcvBuf+3)
LDRB	R3, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+2)
MOVT	R1, #hi_addr(_RcvBuf+2)
LDRB	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_24_UART0+0)
MOVT	R1, #hi_addr(?lstr_24_UART0+0)
STR	R4, [SP, #4]
PUSH	(R3)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #16
LDR	R4, [SP, #4]
;UART0.c,299 :: 		USB_PutQueue(BufNum);
MOV	R0, R4
; BufNum end address is: 16 (R4)
BL	_USB_PutQueue+0
;UART0.c,300 :: 		break;
IT	AL
BAL	L_UART0_Rx236
;UART0.c,301 :: 		case 0xFF: // Event Type: Error Event = 255
L_UART0_Rx259:
;UART0.c,302 :: 		WiFiEvents.Error = TRUE;
MOVS	R1, #1
MOVW	R0, #lo_addr(_WiFiEvents+5)
MOVT	R0, #hi_addr(_WiFiEvents+5)
STRB	R1, [R0, #0]
;UART0.c,303 :: 		ErrorType[0] = RcvBuf[2];
MOVW	R0, #lo_addr(_RcvBuf+2)
MOVT	R0, #hi_addr(_RcvBuf+2)
LDRB	R1, [R0, #0]
MOVW	R0, #lo_addr(_ErrorType+0)
MOVT	R0, #hi_addr(_ErrorType+0)
STRB	R1, [R0, #0]
;UART0.c,304 :: 		ErrorType[1] = RcvBuf[3];
MOVW	R0, #lo_addr(_RcvBuf+3)
MOVT	R0, #hi_addr(_RcvBuf+3)
LDRB	R1, [R0, #0]
MOVW	R0, #lo_addr(_ErrorType+1)
MOVT	R0, #hi_addr(_ErrorType+1)
STRB	R1, [R0, #0]
;UART0.c,305 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
; BufNum start address is: 24 (R6)
MOV	R6, R0
;UART0.c,306 :: 		sprintf(BufNum,"Error event type: %02X %02X, Error data: %02X %02X\r\n",RcvBuf[2],RcvBuf[3],RcvBuf[4],RcvBuf[5]);
MOVW	R1, #lo_addr(_RcvBuf+5)
MOVT	R1, #hi_addr(_RcvBuf+5)
LDRB	R5, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+4)
MOVT	R1, #hi_addr(_RcvBuf+4)
LDRB	R4, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+3)
MOVT	R1, #hi_addr(_RcvBuf+3)
LDRB	R3, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+2)
MOVT	R1, #hi_addr(_RcvBuf+2)
LDRB	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_25_UART0+0)
MOVT	R1, #hi_addr(?lstr_25_UART0+0)
STR	R6, [SP, #4]
PUSH	(R5)
PUSH	(R4)
PUSH	(R3)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #24
LDR	R6, [SP, #4]
;UART0.c,307 :: 		USB_PutQueue(BufNum);
MOV	R0, R6
; BufNum end address is: 24 (R6)
BL	_USB_PutQueue+0
;UART0.c,308 :: 		break;
IT	AL
BAL	L_UART0_Rx236
;UART0.c,309 :: 		default:   // In case there is some event not described in the manual
L_UART0_Rx260:
;UART0.c,310 :: 		WiFiEvents.Unknown = TRUE;
MOVS	R1, #1
MOVW	R0, #lo_addr(_WiFiEvents+6)
MOVT	R0, #hi_addr(_WiFiEvents+6)
STRB	R1, [R0, #0]
;UART0.c,311 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
; BufNum start address is: 12 (R3)
MOV	R3, R0
;UART0.c,312 :: 		sprintf(BufNum,"Unknown event: %u\r\n",RcvBuf[0]);
MOVW	R1, #lo_addr(_RcvBuf+0)
MOVT	R1, #hi_addr(_RcvBuf+0)
LDRB	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_26_UART0+0)
MOVT	R1, #hi_addr(?lstr_26_UART0+0)
STR	R3, [SP, #4]
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
LDR	R3, [SP, #4]
;UART0.c,313 :: 		USB_PutQueue(BufNum);
MOV	R0, R3
; BufNum end address is: 12 (R3)
BL	_USB_PutQueue+0
;UART0.c,314 :: 		break;
IT	AL
BAL	L_UART0_Rx236
;UART0.c,315 :: 		}
L_UART0_Rx235:
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #8
IT	EQ
BEQ	L_UART0_Rx237
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #9
IT	EQ
BEQ	L_UART0_Rx245
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #16
IT	EQ
BEQ	L_UART0_Rx246
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #26
IT	EQ
BEQ	L_UART0_Rx247
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #27
IT	EQ
BEQ	L_UART0_Rx251
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #255
IT	EQ
BEQ	L_UART0_Rx259
IT	AL
BAL	L_UART0_Rx260
L_UART0_Rx236:
;UART0.c,316 :: 		break;
IT	AL
BAL	L_UART0_Rx233
;UART0.c,318 :: 		case 0x16: // SCAN_RESULT_MSG (22 RESPONSE)
L_UART0_Rx261:
;UART0.c,319 :: 		WiFiEvents.ScnRsltMsg = TRUE;
MOVS	R1, #1
MOVW	R0, #lo_addr(_WiFiEvents+7)
MOVT	R0, #hi_addr(_WiFiEvents+7)
STRB	R1, [R0, #0]
;UART0.c,321 :: 		LengthSSID = RcvBuf[6];
MOVW	R0, #lo_addr(_RcvBuf+6)
MOVT	R0, #hi_addr(_RcvBuf+6)
; LengthSSID start address is: 16 (R4)
LDRB	R4, [R0, #0]
;UART0.c,322 :: 		for (i=0;i<LengthSSID;i++)
; i start address is: 12 (R3)
MOVS	R3, #0
; LengthSSID end address is: 16 (R4)
; i end address is: 12 (R3)
L_UART0_Rx262:
; i start address is: 12 (R3)
; LengthSSID start address is: 16 (R4)
CMP	R3, R4
IT	CS
BCS	L_UART0_Rx263
;UART0.c,323 :: 		CurrentSSID[i] = RcvBuf[i+7];
MOVW	R0, #lo_addr(_CurrentSSID+0)
MOVT	R0, #hi_addr(_CurrentSSID+0)
ADDS	R2, R0, R3
ADDS	R1, R3, #7
UXTH	R1, R1
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
ADDS	R0, R0, R1
LDRB	R0, [R0, #0]
STRB	R0, [R2, #0]
;UART0.c,322 :: 		for (i=0;i<LengthSSID;i++)
ADDS	R3, R3, #1
UXTH	R3, R3
;UART0.c,323 :: 		CurrentSSID[i] = RcvBuf[i+7];
; LengthSSID end address is: 16 (R4)
IT	AL
BAL	L_UART0_Rx262
L_UART0_Rx263:
;UART0.c,324 :: 		CurrentSSID[i] = 0;
MOVW	R0, #lo_addr(_CurrentSSID+0)
MOVT	R0, #hi_addr(_CurrentSSID+0)
ADDS	R1, R0, R3
; i end address is: 12 (R3)
MOVS	R0, #0
STRB	R0, [R1, #0]
;UART0.c,325 :: 		sprintf(ChanNumStr,"%02X",RcvBuf[56]);
MOVW	R0, #lo_addr(_RcvBuf+56)
MOVT	R0, #hi_addr(_RcvBuf+56)
LDRB	R2, [R0, #0]
MOVW	R1, #lo_addr(?lstr_27_UART0+0)
MOVT	R1, #hi_addr(?lstr_27_UART0+0)
MOVW	R0, #lo_addr(_ChanNumStr+0)
MOVT	R0, #hi_addr(_ChanNumStr+0)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
;UART0.c,326 :: 		if ((RcvBuf[39] & 0x80) != 0) strcpy(Config,"WPA2");
MOVW	R0, #lo_addr(_RcvBuf+39)
MOVT	R0, #hi_addr(_RcvBuf+39)
LDRB	R0, [R0, #0]
AND	R0, R0, #128
UXTB	R0, R0
CMP	R0, #0
IT	EQ
BEQ	L_UART0_Rx265
MOVW	R0, #lo_addr(?lstr28_UART0+0)
MOVT	R0, #hi_addr(?lstr28_UART0+0)
MOV	R1, R0
MOVW	R0, #lo_addr(_Config+0)
MOVT	R0, #hi_addr(_Config+0)
BL	_strcpy+0
IT	AL
BAL	L_UART0_Rx266
L_UART0_Rx265:
;UART0.c,327 :: 		else if ((RcvBuf[39] & 0x40) != 0) strcpy(Config,"WPA");
MOVW	R0, #lo_addr(_RcvBuf+39)
MOVT	R0, #hi_addr(_RcvBuf+39)
LDRB	R0, [R0, #0]
AND	R0, R0, #64
UXTB	R0, R0
CMP	R0, #0
IT	EQ
BEQ	L_UART0_Rx267
MOVW	R0, #lo_addr(?lstr29_UART0+0)
MOVT	R0, #hi_addr(?lstr29_UART0+0)
MOV	R1, R0
MOVW	R0, #lo_addr(_Config+0)
MOVT	R0, #hi_addr(_Config+0)
BL	_strcpy+0
L_UART0_Rx267:
L_UART0_Rx266:
;UART0.c,329 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
; BufNum start address is: 32 (R8)
MOV	R8, R0
;UART0.c,330 :: 		sprintf(BufNum,"BSSID: %02X %02X %02X %02X %02X %02X\r\n",RcvBuf[0],RcvBuf[1],RcvBuf[2],RcvBuf[3],RcvBuf[4],RcvBuf[5]);
MOVW	R1, #lo_addr(_RcvBuf+5)
MOVT	R1, #hi_addr(_RcvBuf+5)
LDRB	R7, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+4)
MOVT	R1, #hi_addr(_RcvBuf+4)
LDRB	R6, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+3)
MOVT	R1, #hi_addr(_RcvBuf+3)
LDRB	R5, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+2)
MOVT	R1, #hi_addr(_RcvBuf+2)
LDRB	R4, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+1)
MOVT	R1, #hi_addr(_RcvBuf+1)
LDRB	R3, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+0)
MOVT	R1, #hi_addr(_RcvBuf+0)
LDRB	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_30_UART0+0)
MOVT	R1, #hi_addr(?lstr_30_UART0+0)
STR	R8, [SP, #4]
PUSH	(R7)
PUSH	(R6)
PUSH	(R5)
PUSH	(R4)
PUSH	(R3)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #32
LDR	R8, [SP, #4]
;UART0.c,331 :: 		USB_PutQueue(BufNum);
MOV	R0, R8
; BufNum end address is: 32 (R8)
BL	_USB_PutQueue+0
;UART0.c,333 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
; BufNum start address is: 12 (R3)
MOV	R3, R0
;UART0.c,334 :: 		LengthSSID = RcvBuf[6];
MOVW	R0, #lo_addr(_RcvBuf+6)
MOVT	R0, #hi_addr(_RcvBuf+6)
; LengthSSID start address is: 20 (R5)
LDRB	R5, [R0, #0]
;UART0.c,335 :: 		for (i=0;i<LengthSSID;i++)
; i start address is: 16 (R4)
MOVS	R4, #0
; LengthSSID end address is: 20 (R5)
; i end address is: 16 (R4)
; BufNum end address is: 12 (R3)
L_UART0_Rx268:
; i start address is: 16 (R4)
; LengthSSID start address is: 20 (R5)
; BufNum start address is: 12 (R3)
CMP	R4, R5
IT	CS
BCS	L_UART0_Rx269
;UART0.c,336 :: 		BufNum[i] = RcvBuf[i+7];
ADDS	R2, R3, R4
ADDS	R1, R4, #7
UXTH	R1, R1
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
ADDS	R0, R0, R1
LDRB	R0, [R0, #0]
STRB	R0, [R2, #0]
;UART0.c,335 :: 		for (i=0;i<LengthSSID;i++)
ADDS	R4, R4, #1
UXTH	R4, R4
;UART0.c,336 :: 		BufNum[i] = RcvBuf[i+7];
; LengthSSID end address is: 20 (R5)
IT	AL
BAL	L_UART0_Rx268
L_UART0_Rx269:
;UART0.c,337 :: 		BufNum[i] = 0;
ADDS	R1, R3, R4
; i end address is: 16 (R4)
MOVS	R0, #0
STRB	R0, [R1, #0]
;UART0.c,338 :: 		strcat(BufNum,"\r\n");
MOVW	R0, #lo_addr(?lstr31_UART0+0)
MOVT	R0, #hi_addr(?lstr31_UART0+0)
STR	R3, [SP, #4]
MOV	R1, R0
MOV	R0, R3
BL	_strcat+0
LDR	R3, [SP, #4]
;UART0.c,339 :: 		USB_PutQueue(BufNum);
MOV	R0, R3
; BufNum end address is: 12 (R3)
BL	_USB_PutQueue+0
;UART0.c,341 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
; BufNum start address is: 12 (R3)
MOV	R3, R0
;UART0.c,342 :: 		sprintf(BufNum,"AP configuration: %02X\r\n",RcvBuf[39]);
MOVW	R1, #lo_addr(_RcvBuf+39)
MOVT	R1, #hi_addr(_RcvBuf+39)
LDRB	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_32_UART0+0)
MOVT	R1, #hi_addr(?lstr_32_UART0+0)
STR	R3, [SP, #4]
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
LDR	R3, [SP, #4]
;UART0.c,343 :: 		USB_PutQueue(BufNum);
MOV	R0, R3
; BufNum end address is: 12 (R3)
BL	_USB_PutQueue+0
;UART0.c,345 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
; BufNum start address is: 12 (R3)
MOV	R3, R0
;UART0.c,346 :: 		sprintf(BufNum,"Channel number: %02X\r\n",RcvBuf[56]);
MOVW	R1, #lo_addr(_RcvBuf+56)
MOVT	R1, #hi_addr(_RcvBuf+56)
LDRB	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_33_UART0+0)
MOVT	R1, #hi_addr(?lstr_33_UART0+0)
STR	R3, [SP, #4]
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
LDR	R3, [SP, #4]
;UART0.c,347 :: 		USB_PutQueue(BufNum);
MOV	R0, R3
; BufNum end address is: 12 (R3)
BL	_USB_PutQueue+0
;UART0.c,348 :: 		break;
IT	AL
BAL	L_UART0_Rx233
;UART0.c,350 :: 		case 0x17: // SOCKET_CREATE_RESPONSE_MSG (23 RESPONSE)
L_UART0_Rx271:
;UART0.c,351 :: 		WiFiEvents.SockCreaResp = TRUE;
MOVS	R1, #1
MOVW	R0, #lo_addr(_WiFiEvents+8)
MOVT	R0, #hi_addr(_WiFiEvents+8)
STRB	R1, [R0, #0]
;UART0.c,352 :: 		SocketHandle = RcvBuf[0];
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R1, [R0, #0]
MOVW	R0, #lo_addr(_SocketHandle+0)
MOVT	R0, #hi_addr(_SocketHandle+0)
STRB	R1, [R0, #0]
;UART0.c,353 :: 		switch (RcvBuf[0]) {
IT	AL
BAL	L_UART0_Rx272
;UART0.c,354 :: 		case 254: USB_PutQueue("Invalid socket\r\n"); break;
L_UART0_Rx274:
MOVW	R0, #lo_addr(?lstr34_UART0+0)
MOVT	R0, #hi_addr(?lstr34_UART0+0)
BL	_USB_PutQueue+0
IT	AL
BAL	L_UART0_Rx273
;UART0.c,355 :: 		case 255: USB_PutQueue("Unknown socket type\r\n"); break;
L_UART0_Rx275:
MOVW	R0, #lo_addr(?lstr35_UART0+0)
MOVT	R0, #hi_addr(?lstr35_UART0+0)
BL	_USB_PutQueue+0
IT	AL
BAL	L_UART0_Rx273
;UART0.c,356 :: 		default:
L_UART0_Rx276:
;UART0.c,357 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
; BufNum start address is: 12 (R3)
MOV	R3, R0
;UART0.c,358 :: 		sprintf(BufNum,"Valid socket handle: %u\r\n",RcvBuf[0]);
MOVW	R1, #lo_addr(_RcvBuf+0)
MOVT	R1, #hi_addr(_RcvBuf+0)
LDRB	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_36_UART0+0)
MOVT	R1, #hi_addr(?lstr_36_UART0+0)
STR	R3, [SP, #4]
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
LDR	R3, [SP, #4]
;UART0.c,359 :: 		USB_PutQueue(BufNum);
MOV	R0, R3
; BufNum end address is: 12 (R3)
BL	_USB_PutQueue+0
;UART0.c,360 :: 		break;
IT	AL
BAL	L_UART0_Rx273
;UART0.c,361 :: 		}
L_UART0_Rx272:
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #254
IT	EQ
BEQ	L_UART0_Rx274
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #255
IT	EQ
BEQ	L_UART0_Rx275
IT	AL
BAL	L_UART0_Rx276
L_UART0_Rx273:
;UART0.c,362 :: 		break;
IT	AL
BAL	L_UART0_Rx233
;UART0.c,364 :: 		case 0x18: // SOCKET_BIND_RESPONSE_MSG (24 RESPONSE)
L_UART0_Rx277:
;UART0.c,365 :: 		WiFiEvents.SockBindResp = TRUE;
MOVS	R1, #1
MOVW	R0, #lo_addr(_WiFiEvents+9)
MOVT	R0, #hi_addr(_WiFiEvents+9)
STRB	R1, [R0, #0]
;UART0.c,366 :: 		BindResult = RcvBuf[2];
MOVW	R0, #lo_addr(_RcvBuf+2)
MOVT	R0, #hi_addr(_RcvBuf+2)
LDRB	R1, [R0, #0]
MOVW	R0, #lo_addr(_BindResult+0)
MOVT	R0, #hi_addr(_BindResult+0)
STRB	R1, [R0, #0]
;UART0.c,367 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
; BufNum start address is: 20 (R5)
MOV	R5, R0
;UART0.c,368 :: 		sprintf(BufNum,"Local port: %02X %02X, Bind result: %02X\r\n",RcvBuf[0],RcvBuf[1],RcvBuf[2]);
MOVW	R1, #lo_addr(_RcvBuf+2)
MOVT	R1, #hi_addr(_RcvBuf+2)
LDRB	R4, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+1)
MOVT	R1, #hi_addr(_RcvBuf+1)
LDRB	R3, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+0)
MOVT	R1, #hi_addr(_RcvBuf+0)
LDRB	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_37_UART0+0)
MOVT	R1, #hi_addr(?lstr_37_UART0+0)
STR	R5, [SP, #4]
PUSH	(R4)
PUSH	(R3)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #20
LDR	R5, [SP, #4]
;UART0.c,369 :: 		USB_PutQueue(BufNum);
MOV	R0, R5
; BufNum end address is: 20 (R5)
BL	_USB_PutQueue+0
;UART0.c,370 :: 		break;
IT	AL
BAL	L_UART0_Rx233
;UART0.c,372 :: 		case 0x19: // SOCKET_CONNECT_RESPONSE_MSG (25 RESPONSE)
L_UART0_Rx278:
;UART0.c,373 :: 		WiFiEvents.SockConnResp = TRUE;
MOVS	R1, #1
MOVW	R0, #lo_addr(_WiFiEvents+10)
MOVT	R0, #hi_addr(_WiFiEvents+10)
STRB	R1, [R0, #0]
;UART0.c,374 :: 		ConnectResult = RcvBuf[0];
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R1, [R0, #0]
MOVW	R0, #lo_addr(_ConnectResult+0)
MOVT	R0, #hi_addr(_ConnectResult+0)
STRB	R1, [R0, #0]
;UART0.c,375 :: 		switch (RcvBuf[0]) {
IT	AL
BAL	L_UART0_Rx279
;UART0.c,376 :: 		case 0: USB_PutQueue("Success\r\n"); break;
L_UART0_Rx281:
MOVW	R0, #lo_addr(?lstr38_UART0+0)
MOVT	R0, #hi_addr(?lstr38_UART0+0)
BL	_USB_PutQueue+0
IT	AL
BAL	L_UART0_Rx280
;UART0.c,377 :: 		case 254: USB_PutQueue("Socket connect in process\r\n"); break;
L_UART0_Rx282:
MOVW	R0, #lo_addr(?lstr39_UART0+0)
MOVT	R0, #hi_addr(?lstr39_UART0+0)
BL	_USB_PutQueue+0
IT	AL
BAL	L_UART0_Rx280
;UART0.c,378 :: 		case 255: USB_PutQueue("Socket connect failed\r\n"); break;
L_UART0_Rx283:
MOVW	R0, #lo_addr(?lstr40_UART0+0)
MOVT	R0, #hi_addr(?lstr40_UART0+0)
BL	_USB_PutQueue+0
IT	AL
BAL	L_UART0_Rx280
;UART0.c,379 :: 		}
L_UART0_Rx279:
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #0
IT	EQ
BEQ	L_UART0_Rx281
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #254
IT	EQ
BEQ	L_UART0_Rx282
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #255
IT	EQ
BEQ	L_UART0_Rx283
L_UART0_Rx280:
;UART0.c,380 :: 		break;
IT	AL
BAL	L_UART0_Rx233
;UART0.c,382 :: 		case 0x1A: // SOCKET_LISTEN_RESPONSE_MSG (26 RESPONSE)
L_UART0_Rx284:
;UART0.c,383 :: 		WiFiEvents.SockListenResp = TRUE;
MOVS	R1, #1
MOVW	R0, #lo_addr(_WiFiEvents+11)
MOVT	R0, #hi_addr(_WiFiEvents+11)
STRB	R1, [R0, #0]
;UART0.c,384 :: 		ConnectResult = RcvBuf[0];
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R1, [R0, #0]
MOVW	R0, #lo_addr(_ConnectResult+0)
MOVT	R0, #hi_addr(_ConnectResult+0)
STRB	R1, [R0, #0]
;UART0.c,385 :: 		BacklogCount = RcvBuf[1];
MOVW	R0, #lo_addr(_RcvBuf+1)
MOVT	R0, #hi_addr(_RcvBuf+1)
LDRB	R1, [R0, #0]
MOVW	R0, #lo_addr(_BacklogCount+0)
MOVT	R0, #hi_addr(_BacklogCount+0)
STRB	R1, [R0, #0]
;UART0.c,386 :: 		switch (RcvBuf[0]) {
IT	AL
BAL	L_UART0_Rx285
;UART0.c,387 :: 		case 0: USB_PutQueue("Success\r\n"); break;
L_UART0_Rx287:
MOVW	R0, #lo_addr(?lstr41_UART0+0)
MOVT	R0, #hi_addr(?lstr41_UART0+0)
BL	_USB_PutQueue+0
IT	AL
BAL	L_UART0_Rx286
;UART0.c,388 :: 		case 254: USB_PutQueue("Socket connect in process\r\n"); break;
L_UART0_Rx288:
MOVW	R0, #lo_addr(?lstr42_UART0+0)
MOVT	R0, #hi_addr(?lstr42_UART0+0)
BL	_USB_PutQueue+0
IT	AL
BAL	L_UART0_Rx286
;UART0.c,389 :: 		case 255: USB_PutQueue("Socket connect failed\r\n"); break;
L_UART0_Rx289:
MOVW	R0, #lo_addr(?lstr43_UART0+0)
MOVT	R0, #hi_addr(?lstr43_UART0+0)
BL	_USB_PutQueue+0
IT	AL
BAL	L_UART0_Rx286
;UART0.c,390 :: 		}
L_UART0_Rx285:
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #0
IT	EQ
BEQ	L_UART0_Rx287
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #254
IT	EQ
BEQ	L_UART0_Rx288
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #255
IT	EQ
BEQ	L_UART0_Rx289
L_UART0_Rx286:
;UART0.c,391 :: 		break;
IT	AL
BAL	L_UART0_Rx233
;UART0.c,393 :: 		case 0x1B: // SOCKET_ACCEPT_RESPONSE_MSG (27 RESPONSE)
L_UART0_Rx290:
;UART0.c,394 :: 		WiFiEvents.SockAccptResp = TRUE;
MOVS	R1, #1
MOVW	R0, #lo_addr(_WiFiEvents+12)
MOVT	R0, #hi_addr(_WiFiEvents+12)
STRB	R1, [R0, #0]
;UART0.c,396 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
; BufNum start address is: 12 (R3)
MOV	R3, R0
;UART0.c,397 :: 		sprintf(BufNum,"Socket handle: %u\r\n",RcvBuf[0]);
MOVW	R1, #lo_addr(_RcvBuf+0)
MOVT	R1, #hi_addr(_RcvBuf+0)
LDRB	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_44_UART0+0)
MOVT	R1, #hi_addr(?lstr_44_UART0+0)
STR	R3, [SP, #4]
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
LDR	R3, [SP, #4]
;UART0.c,398 :: 		USB_PutQueue(BufNum);
MOV	R0, R3
; BufNum end address is: 12 (R3)
BL	_USB_PutQueue+0
;UART0.c,400 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
; BufNum start address is: 16 (R4)
MOV	R4, R0
;UART0.c,401 :: 		sprintf(BufNum,"Remote port: %02X %02X\r\n",RcvBuf[2],RcvBuf[3]);
MOVW	R1, #lo_addr(_RcvBuf+3)
MOVT	R1, #hi_addr(_RcvBuf+3)
LDRB	R3, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+2)
MOVT	R1, #hi_addr(_RcvBuf+2)
LDRB	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_45_UART0+0)
MOVT	R1, #hi_addr(?lstr_45_UART0+0)
STR	R4, [SP, #4]
PUSH	(R3)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #16
LDR	R4, [SP, #4]
;UART0.c,402 :: 		USB_PutQueue(BufNum);
MOV	R0, R4
; BufNum end address is: 16 (R4)
BL	_USB_PutQueue+0
;UART0.c,404 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
; BufNum start address is: 24 (R6)
MOV	R6, R0
;UART0.c,405 :: 		sprintf(BufNum,"Remote IP address: %u.%u.%u.%u\r\n",RcvBuf[4],RcvBuf[5],RcvBuf[6],RcvBuf[7]);
MOVW	R1, #lo_addr(_RcvBuf+7)
MOVT	R1, #hi_addr(_RcvBuf+7)
LDRB	R5, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+6)
MOVT	R1, #hi_addr(_RcvBuf+6)
LDRB	R4, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+5)
MOVT	R1, #hi_addr(_RcvBuf+5)
LDRB	R3, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+4)
MOVT	R1, #hi_addr(_RcvBuf+4)
LDRB	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_46_UART0+0)
MOVT	R1, #hi_addr(?lstr_46_UART0+0)
STR	R6, [SP, #4]
PUSH	(R5)
PUSH	(R4)
PUSH	(R3)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #24
LDR	R6, [SP, #4]
;UART0.c,406 :: 		USB_PutQueue(BufNum);
MOV	R0, R6
; BufNum end address is: 24 (R6)
BL	_USB_PutQueue+0
;UART0.c,407 :: 		break;
IT	AL
BAL	L_UART0_Rx233
;UART0.c,409 :: 		case 0x1C: // SOCKET_SEND_RESPONSE_MSG (28 RESPONSE)
L_UART0_Rx291:
;UART0.c,410 :: 		WiFiEvents.SockSendResp = TRUE;
MOVS	R1, #1
MOVW	R0, #lo_addr(_WiFiEvents+13)
MOVT	R0, #hi_addr(_WiFiEvents+13)
STRB	R1, [R0, #0]
;UART0.c,412 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
; BufNum start address is: 16 (R4)
MOV	R4, R0
;UART0.c,413 :: 		sprintf(BufNum,"Socket byte count sent: %02X %02X\r\n",RcvBuf[0],RcvBuf[1]);
MOVW	R1, #lo_addr(_RcvBuf+1)
MOVT	R1, #hi_addr(_RcvBuf+1)
LDRB	R3, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+0)
MOVT	R1, #hi_addr(_RcvBuf+0)
LDRB	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_47_UART0+0)
MOVT	R1, #hi_addr(?lstr_47_UART0+0)
STR	R4, [SP, #4]
PUSH	(R3)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #16
LDR	R4, [SP, #4]
;UART0.c,414 :: 		USB_PutQueue(BufNum);
MOV	R0, R4
; BufNum end address is: 16 (R4)
BL	_USB_PutQueue+0
;UART0.c,415 :: 		break;
IT	AL
BAL	L_UART0_Rx233
;UART0.c,417 :: 		case 0x1D: // SOCKET_RECEIVE_RESPONSE_MSG (29 RESPONSE)
L_UART0_Rx292:
;UART0.c,418 :: 		WiFiEvents.SockRcvResp = TRUE;
MOVS	R1, #1
MOVW	R0, #lo_addr(_WiFiEvents+14)
MOVT	R0, #hi_addr(_WiFiEvents+14)
STRB	R1, [R0, #0]
;UART0.c,419 :: 		UDP_RemoteHandle = RcvBuf[0];     // Destination socket handle
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R1, [R0, #0]
MOVW	R0, #lo_addr(_UDP_RemoteHandle+0)
MOVT	R0, #hi_addr(_UDP_RemoteHandle+0)
STRB	R1, [R0, #0]
;UART0.c,420 :: 		UDP_RemPort = RcvBuf[2];          // Remote port
MOVW	R0, #lo_addr(_RcvBuf+2)
MOVT	R0, #hi_addr(_RcvBuf+2)
LDRB	R0, [R0, #0]
MOVW	R2, #lo_addr(_UDP_RemPort+0)
MOVT	R2, #hi_addr(_UDP_RemPort+0)
STRH	R0, [R2, #0]
;UART0.c,421 :: 		UDP_RemPort |= (RcvBuf[3] << 8);
MOVW	R0, #lo_addr(_RcvBuf+3)
MOVT	R0, #hi_addr(_RcvBuf+3)
LDRB	R0, [R0, #0]
LSLS	R1, R0, #8
UXTH	R1, R1
MOV	R0, R2
LDRH	R0, [R0, #0]
ORRS	R0, R1
STRH	R0, [R2, #0]
;UART0.c,423 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
; BufNum start address is: 12 (R3)
MOV	R3, R0
;UART0.c,424 :: 		sprintf(BufNum,"Socket handle: %u\r\n",RcvBuf[0]);
MOVW	R1, #lo_addr(_RcvBuf+0)
MOVT	R1, #hi_addr(_RcvBuf+0)
LDRB	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_48_UART0+0)
MOVT	R1, #hi_addr(?lstr_48_UART0+0)
STR	R3, [SP, #4]
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
LDR	R3, [SP, #4]
;UART0.c,425 :: 		USB_PutQueue(BufNum);
MOV	R0, R3
; BufNum end address is: 12 (R3)
BL	_USB_PutQueue+0
;UART0.c,427 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
; BufNum start address is: 16 (R4)
MOV	R4, R0
;UART0.c,428 :: 		sprintf(BufNum,"Receive byte count: %02X %02X\r\n",RcvBuf[2],RcvBuf[3]);
MOVW	R1, #lo_addr(_RcvBuf+3)
MOVT	R1, #hi_addr(_RcvBuf+3)
LDRB	R3, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+2)
MOVT	R1, #hi_addr(_RcvBuf+2)
LDRB	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_49_UART0+0)
MOVT	R1, #hi_addr(?lstr_49_UART0+0)
STR	R4, [SP, #4]
PUSH	(R3)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #16
LDR	R4, [SP, #4]
;UART0.c,429 :: 		USB_PutQueue(BufNum);
MOV	R0, R4
; BufNum end address is: 16 (R4)
BL	_USB_PutQueue+0
;UART0.c,430 :: 		break;
IT	AL
BAL	L_UART0_Rx233
;UART0.c,432 :: 		case 0x1E: // SOCKET_SEND_TO_RESPONSE_MSG (30 RESPONSE)
L_UART0_Rx293:
;UART0.c,433 :: 		WiFiEvents.SockSendToResp = TRUE;
MOVS	R1, #1
MOVW	R0, #lo_addr(_WiFiEvents+15)
MOVT	R0, #hi_addr(_WiFiEvents+15)
STRB	R1, [R0, #0]
;UART0.c,435 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
; BufNum start address is: 12 (R3)
MOV	R3, R0
;UART0.c,436 :: 		sprintf(BufNum,"Byte count sent: %u\r\n",RcvBuf[0]);
MOVW	R1, #lo_addr(_RcvBuf+0)
MOVT	R1, #hi_addr(_RcvBuf+0)
LDRB	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_50_UART0+0)
MOVT	R1, #hi_addr(?lstr_50_UART0+0)
STR	R3, [SP, #4]
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
LDR	R3, [SP, #4]
;UART0.c,437 :: 		USB_PutQueue(BufNum);
MOV	R0, R3
; BufNum end address is: 12 (R3)
BL	_USB_PutQueue+0
;UART0.c,438 :: 		break;
IT	AL
BAL	L_UART0_Rx233
;UART0.c,440 :: 		case 0x1F: // SOCKET_RECV_FROM_RESPONSE_MSG (31 RESPONSE)
L_UART0_Rx294:
;UART0.c,441 :: 		WiFiEvents.SockRcvFromResp = TRUE;
MOVS	R1, #1
MOVW	R0, #lo_addr(_WiFiEvents+16)
MOVT	R0, #hi_addr(_WiFiEvents+16)
STRB	R1, [R0, #0]
;UART0.c,442 :: 		UDP_RemoteHandle = RcvBuf[0];     // Destination socket handle
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R1, [R0, #0]
MOVW	R0, #lo_addr(_UDP_RemoteHandle+0)
MOVT	R0, #hi_addr(_UDP_RemoteHandle+0)
STRB	R1, [R0, #0]
;UART0.c,443 :: 		UDP_RemPort = RcvBuf[2];          // Remote port
MOVW	R0, #lo_addr(_RcvBuf+2)
MOVT	R0, #hi_addr(_RcvBuf+2)
LDRB	R0, [R0, #0]
MOVW	R2, #lo_addr(_UDP_RemPort+0)
MOVT	R2, #hi_addr(_UDP_RemPort+0)
STRH	R0, [R2, #0]
;UART0.c,444 :: 		UDP_RemPort |= (RcvBuf[3] << 8);
MOVW	R0, #lo_addr(_RcvBuf+3)
MOVT	R0, #hi_addr(_RcvBuf+3)
LDRB	R0, [R0, #0]
LSLS	R1, R0, #8
UXTH	R1, R1
MOV	R0, R2
LDRH	R0, [R0, #0]
ORRS	R0, R1
STRH	R0, [R2, #0]
;UART0.c,445 :: 		UDP_RemoteIP[0] = RcvBuf[4];
MOVW	R0, #lo_addr(_RcvBuf+4)
MOVT	R0, #hi_addr(_RcvBuf+4)
LDRB	R1, [R0, #0]
MOVW	R0, #lo_addr(_UDP_RemoteIP+0)
MOVT	R0, #hi_addr(_UDP_RemoteIP+0)
STRB	R1, [R0, #0]
;UART0.c,446 :: 		UDP_RemoteIP[1] = RcvBuf[5];
MOVW	R0, #lo_addr(_RcvBuf+5)
MOVT	R0, #hi_addr(_RcvBuf+5)
LDRB	R1, [R0, #0]
MOVW	R0, #lo_addr(_UDP_RemoteIP+1)
MOVT	R0, #hi_addr(_UDP_RemoteIP+1)
STRB	R1, [R0, #0]
;UART0.c,447 :: 		UDP_RemoteIP[2] = RcvBuf[6];
MOVW	R0, #lo_addr(_RcvBuf+6)
MOVT	R0, #hi_addr(_RcvBuf+6)
LDRB	R1, [R0, #0]
MOVW	R0, #lo_addr(_UDP_RemoteIP+2)
MOVT	R0, #hi_addr(_UDP_RemoteIP+2)
STRB	R1, [R0, #0]
;UART0.c,448 :: 		UDP_RemoteIP[3] = RcvBuf[7];
MOVW	R0, #lo_addr(_RcvBuf+7)
MOVT	R0, #hi_addr(_RcvBuf+7)
LDRB	R1, [R0, #0]
MOVW	R0, #lo_addr(_UDP_RemoteIP+3)
MOVT	R0, #hi_addr(_UDP_RemoteIP+3)
STRB	R1, [R0, #0]
;UART0.c,449 :: 		UDP_RemByteCount = RcvBuf[20];    // Message byte count
MOVW	R0, #lo_addr(_RcvBuf+20)
MOVT	R0, #hi_addr(_RcvBuf+20)
LDRB	R0, [R0, #0]
MOVW	R2, #lo_addr(_UDP_RemByteCount+0)
MOVT	R2, #hi_addr(_UDP_RemByteCount+0)
STRH	R0, [R2, #0]
;UART0.c,450 :: 		UDP_RemByteCount |= (RcvBuf[21] << 8);
MOVW	R0, #lo_addr(_RcvBuf+21)
MOVT	R0, #hi_addr(_RcvBuf+21)
LDRB	R0, [R0, #0]
LSLS	R1, R0, #8
UXTH	R1, R1
MOV	R0, R2
LDRH	R0, [R0, #0]
ORRS	R0, R1
STRH	R0, [R2, #0]
;UART0.c,451 :: 		for (i=0;i<UDP_RemByteCount;i++)
; i start address is: 12 (R3)
MOVS	R3, #0
; i end address is: 12 (R3)
L_UART0_Rx295:
; i start address is: 12 (R3)
MOVW	R0, #lo_addr(_UDP_RemByteCount+0)
MOVT	R0, #hi_addr(_UDP_RemByteCount+0)
LDRH	R0, [R0, #0]
CMP	R3, R0
IT	CS
BCS	L_UART0_Rx296
;UART0.c,452 :: 		UDP_Buf[i] = RcvBuf[i+22];
MOVW	R0, #lo_addr(_UDP_Buf+0)
MOVT	R0, #hi_addr(_UDP_Buf+0)
ADDS	R2, R0, R3
ADDW	R1, R3, #22
UXTH	R1, R1
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
ADDS	R0, R0, R1
LDRB	R0, [R0, #0]
STRB	R0, [R2, #0]
;UART0.c,451 :: 		for (i=0;i<UDP_RemByteCount;i++)
ADDS	R3, R3, #1
UXTH	R3, R3
;UART0.c,452 :: 		UDP_Buf[i] = RcvBuf[i+22];
IT	AL
BAL	L_UART0_Rx295
L_UART0_Rx296:
;UART0.c,453 :: 		UDP_Buf[i] = 0;
MOVW	R0, #lo_addr(_UDP_Buf+0)
MOVT	R0, #hi_addr(_UDP_Buf+0)
ADDS	R1, R0, R3
; i end address is: 12 (R3)
MOVS	R0, #0
STRB	R0, [R1, #0]
;UART0.c,455 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
; BufNum start address is: 12 (R3)
MOV	R3, R0
;UART0.c,456 :: 		sprintf(BufNum,"Socket handle: %u\r\n",RcvBuf[0]);
MOVW	R1, #lo_addr(_RcvBuf+0)
MOVT	R1, #hi_addr(_RcvBuf+0)
LDRB	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_51_UART0+0)
MOVT	R1, #hi_addr(?lstr_51_UART0+0)
STR	R3, [SP, #4]
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
LDR	R3, [SP, #4]
;UART0.c,457 :: 		USB_PutQueue(BufNum);   // Display the socket handle
MOV	R0, R3
; BufNum end address is: 12 (R3)
BL	_USB_PutQueue+0
;UART0.c,459 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
; BufNum start address is: 16 (R4)
MOV	R4, R0
;UART0.c,460 :: 		sprintf(BufNum,"Port number of sender: %02X %02X\r\n",RcvBuf[2],RcvBuf[3]);
MOVW	R1, #lo_addr(_RcvBuf+3)
MOVT	R1, #hi_addr(_RcvBuf+3)
LDRB	R3, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+2)
MOVT	R1, #hi_addr(_RcvBuf+2)
LDRB	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_52_UART0+0)
MOVT	R1, #hi_addr(?lstr_52_UART0+0)
STR	R4, [SP, #4]
PUSH	(R3)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #16
LDR	R4, [SP, #4]
;UART0.c,461 :: 		USB_PutQueue(BufNum);   // Display sender's port number
MOV	R0, R4
; BufNum end address is: 16 (R4)
BL	_USB_PutQueue+0
;UART0.c,463 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
; BufNum start address is: 24 (R6)
MOV	R6, R0
;UART0.c,464 :: 		sprintf(BufNum,"IP address of sender: %u.%u.%u.%u\r\n",RcvBuf[4],RcvBuf[5],RcvBuf[6],RcvBuf[7]);
MOVW	R1, #lo_addr(_RcvBuf+7)
MOVT	R1, #hi_addr(_RcvBuf+7)
LDRB	R5, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+6)
MOVT	R1, #hi_addr(_RcvBuf+6)
LDRB	R4, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+5)
MOVT	R1, #hi_addr(_RcvBuf+5)
LDRB	R3, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+4)
MOVT	R1, #hi_addr(_RcvBuf+4)
LDRB	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_53_UART0+0)
MOVT	R1, #hi_addr(?lstr_53_UART0+0)
STR	R6, [SP, #4]
PUSH	(R5)
PUSH	(R4)
PUSH	(R3)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #24
LDR	R6, [SP, #4]
;UART0.c,465 :: 		USB_PutQueue(BufNum);   // Display sender's IP address
MOV	R0, R6
; BufNum end address is: 24 (R6)
BL	_USB_PutQueue+0
;UART0.c,467 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
; BufNum start address is: 16 (R4)
MOV	R4, R0
;UART0.c,468 :: 		sprintf(BufNum,"Byte count received: %02X %02X\r\n",RcvBuf[20],RcvBuf[21]);
MOVW	R1, #lo_addr(_RcvBuf+21)
MOVT	R1, #hi_addr(_RcvBuf+21)
LDRB	R3, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+20)
MOVT	R1, #hi_addr(_RcvBuf+20)
LDRB	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_54_UART0+0)
MOVT	R1, #hi_addr(?lstr_54_UART0+0)
STR	R4, [SP, #4]
PUSH	(R3)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #16
LDR	R4, [SP, #4]
;UART0.c,469 :: 		USB_PutQueue(BufNum);   // Display the byte count
MOV	R0, R4
; BufNum end address is: 16 (R4)
BL	_USB_PutQueue+0
;UART0.c,471 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
; BufNum start address is: 24 (R6)
MOV	R6, R0
;UART0.c,472 :: 		sprintf(BufNum,"%02X%02X%02X%02X",UDP_Buf[0],UDP_Buf[1],UDP_Buf[2],UDP_Buf[3]);
MOVW	R1, #lo_addr(_UDP_Buf+3)
MOVT	R1, #hi_addr(_UDP_Buf+3)
LDRB	R5, [R1, #0]
MOVW	R1, #lo_addr(_UDP_Buf+2)
MOVT	R1, #hi_addr(_UDP_Buf+2)
LDRB	R4, [R1, #0]
MOVW	R1, #lo_addr(_UDP_Buf+1)
MOVT	R1, #hi_addr(_UDP_Buf+1)
LDRB	R3, [R1, #0]
MOVW	R1, #lo_addr(_UDP_Buf+0)
MOVT	R1, #hi_addr(_UDP_Buf+0)
LDRB	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_55_UART0+0)
MOVT	R1, #hi_addr(?lstr_55_UART0+0)
STR	R6, [SP, #4]
PUSH	(R5)
PUSH	(R4)
PUSH	(R3)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #24
LDR	R6, [SP, #4]
;UART0.c,473 :: 		USB_PutQueue(BufNum);   // Display the 1st 4 bytes of UDP buffer in hex
MOV	R0, R6
; BufNum end address is: 24 (R6)
BL	_USB_PutQueue+0
;UART0.c,474 :: 		USB_PutQueue(UDP_Buf);  // Display the UDP buffer directly
MOVW	R0, #lo_addr(_UDP_Buf+0)
MOVT	R0, #hi_addr(_UDP_Buf+0)
BL	_USB_PutQueue+0
;UART0.c,475 :: 		break;
IT	AL
BAL	L_UART0_Rx233
;UART0.c,477 :: 		case 0x20: // SOCKET_ALLOCATE_RESPONSE_MSG (32 RESPONSE)
L_UART0_Rx298:
;UART0.c,478 :: 		WiFiEvents.SockAllocResp = TRUE;
MOVS	R1, #1
MOVW	R0, #lo_addr(_WiFiEvents+17)
MOVT	R0, #hi_addr(_WiFiEvents+17)
STRB	R1, [R0, #0]
;UART0.c,480 :: 		switch (RcvBuf[0]) {
IT	AL
BAL	L_UART0_Rx299
;UART0.c,481 :: 		case 0: USB_PutQueue("Socket allocation successful\r\n"); break;
L_UART0_Rx2101:
MOVW	R0, #lo_addr(?lstr56_UART0+0)
MOVT	R0, #hi_addr(?lstr56_UART0+0)
BL	_USB_PutQueue+0
IT	AL
BAL	L_UART0_Rx2100
;UART0.c,482 :: 		case 254: USB_PutQueue("Total buffer allocation size exceeded\r\n"); break;
L_UART0_Rx2102:
MOVW	R0, #lo_addr(?lstr57_UART0+0)
MOVT	R0, #hi_addr(?lstr57_UART0+0)
BL	_USB_PutQueue+0
IT	AL
BAL	L_UART0_Rx2100
;UART0.c,483 :: 		case 255: USB_PutQueue("Maximum number of sockets exceeded\r\n"); break;
L_UART0_Rx2103:
MOVW	R0, #lo_addr(?lstr58_UART0+0)
MOVT	R0, #hi_addr(?lstr58_UART0+0)
BL	_USB_PutQueue+0
IT	AL
BAL	L_UART0_Rx2100
;UART0.c,484 :: 		}
L_UART0_Rx299:
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #0
IT	EQ
BEQ	L_UART0_Rx2101
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #254
IT	EQ
BEQ	L_UART0_Rx2102
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #255
IT	EQ
BEQ	L_UART0_Rx2103
L_UART0_Rx2100:
;UART0.c,485 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
; BufNum start address is: 12 (R3)
MOV	R3, R0
;UART0.c,486 :: 		sprintf(BufNum,"Allocated socket count: %02X\r\n",RcvBuf[1]);
MOVW	R1, #lo_addr(_RcvBuf+1)
MOVT	R1, #hi_addr(_RcvBuf+1)
LDRB	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_59_UART0+0)
MOVT	R1, #hi_addr(?lstr_59_UART0+0)
STR	R3, [SP, #4]
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
LDR	R3, [SP, #4]
;UART0.c,487 :: 		USB_PutQueue(BufNum);
MOV	R0, R3
; BufNum end address is: 12 (R3)
BL	_USB_PutQueue+0
;UART0.c,488 :: 		break;
IT	AL
BAL	L_UART0_Rx233
;UART0.c,490 :: 		case 0x30: // NETWORK_STATUS_RESPONSE_MSG (48 RESPONSE)
L_UART0_Rx2104:
;UART0.c,491 :: 		WiFiEvents.NetStatResp = TRUE;  // Set network response flag
MOVS	R1, #1
MOVW	R0, #lo_addr(_WiFiEvents+18)
MOVT	R0, #hi_addr(_WiFiEvents+18)
STRB	R1, [R0, #0]
;UART0.c,492 :: 		for (i=0;i<6;i++)
; i start address is: 12 (R3)
MOVS	R3, #0
; i end address is: 12 (R3)
L_UART0_Rx2105:
; i start address is: 12 (R3)
CMP	R3, #6
IT	CS
BCS	L_UART0_Rx2106
;UART0.c,493 :: 		WiFiParam.MACAddress[i] = RcvBuf[i+1];
MOVW	R0, #lo_addr(_WiFiParam+0)
MOVT	R0, #hi_addr(_WiFiParam+0)
ADDS	R2, R0, R3
ADDS	R1, R3, #1
UXTH	R1, R1
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
ADDS	R0, R0, R1
LDRB	R0, [R0, #0]
STRB	R0, [R2, #0]
;UART0.c,492 :: 		for (i=0;i<6;i++)
ADDS	R3, R3, #1
UXTH	R3, R3
;UART0.c,493 :: 		WiFiParam.MACAddress[i] = RcvBuf[i+1];
; i end address is: 12 (R3)
IT	AL
BAL	L_UART0_Rx2105
L_UART0_Rx2106:
;UART0.c,494 :: 		for (i=0;i<4;i++)
; i start address is: 12 (R3)
MOVS	R3, #0
; i end address is: 12 (R3)
L_UART0_Rx2108:
; i start address is: 12 (R3)
CMP	R3, #4
IT	CS
BCS	L_UART0_Rx2109
;UART0.c,495 :: 		WiFiParam.IPAddress[i] = RcvBuf[i+7];
MOVW	R0, #lo_addr(_WiFiParam+6)
MOVT	R0, #hi_addr(_WiFiParam+6)
ADDS	R2, R0, R3
ADDS	R1, R3, #7
UXTH	R1, R1
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
ADDS	R0, R0, R1
LDRB	R0, [R0, #0]
STRB	R0, [R2, #0]
;UART0.c,494 :: 		for (i=0;i<4;i++)
ADDS	R3, R3, #1
UXTH	R3, R3
;UART0.c,495 :: 		WiFiParam.IPAddress[i] = RcvBuf[i+7];
; i end address is: 12 (R3)
IT	AL
BAL	L_UART0_Rx2108
L_UART0_Rx2109:
;UART0.c,496 :: 		for (i=0;i<4;i++)
; i start address is: 12 (R3)
MOVS	R3, #0
; i end address is: 12 (R3)
L_UART0_Rx2111:
; i start address is: 12 (R3)
CMP	R3, #4
IT	CS
BCS	L_UART0_Rx2112
;UART0.c,497 :: 		WiFiParam.NetworkMask[i] = RcvBuf[i+23];
MOVW	R0, #lo_addr(_WiFiParam+10)
MOVT	R0, #hi_addr(_WiFiParam+10)
ADDS	R2, R0, R3
ADDW	R1, R3, #23
UXTH	R1, R1
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
ADDS	R0, R0, R1
LDRB	R0, [R0, #0]
STRB	R0, [R2, #0]
;UART0.c,496 :: 		for (i=0;i<4;i++)
ADDS	R3, R3, #1
UXTH	R3, R3
;UART0.c,497 :: 		WiFiParam.NetworkMask[i] = RcvBuf[i+23];
; i end address is: 12 (R3)
IT	AL
BAL	L_UART0_Rx2111
L_UART0_Rx2112:
;UART0.c,498 :: 		for (i=0;i<4;i++)
; i start address is: 12 (R3)
MOVS	R3, #0
; i end address is: 12 (R3)
L_UART0_Rx2114:
; i start address is: 12 (R3)
CMP	R3, #4
IT	CS
BCS	L_UART0_Rx2115
;UART0.c,499 :: 		WiFiParam.GatewayAddress[i] = RcvBuf[i+39];
MOVW	R0, #lo_addr(_WiFiParam+14)
MOVT	R0, #hi_addr(_WiFiParam+14)
ADDS	R2, R0, R3
ADDW	R1, R3, #39
UXTH	R1, R1
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
ADDS	R0, R0, R1
LDRB	R0, [R0, #0]
STRB	R0, [R2, #0]
;UART0.c,498 :: 		for (i=0;i<4;i++)
ADDS	R3, R3, #1
UXTH	R3, R3
;UART0.c,499 :: 		WiFiParam.GatewayAddress[i] = RcvBuf[i+39];
; i end address is: 12 (R3)
IT	AL
BAL	L_UART0_Rx2114
L_UART0_Rx2115:
;UART0.c,500 :: 		WiFiParam.NetworkStatus = RcvBuf[55];
MOVW	R0, #lo_addr(_RcvBuf+55)
MOVT	R0, #hi_addr(_RcvBuf+55)
LDRB	R1, [R0, #0]
MOVW	R0, #lo_addr(_WiFiParam+18)
MOVT	R0, #hi_addr(_WiFiParam+18)
STRB	R1, [R0, #0]
;UART0.c,502 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
; BufNum start address is: 12 (R3)
MOV	R3, R0
;UART0.c,503 :: 		sprintf(BufNum,"Reserved: %02X\r\n",RcvBuf[0]); // Reserved
MOVW	R1, #lo_addr(_RcvBuf+0)
MOVT	R1, #hi_addr(_RcvBuf+0)
LDRB	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_60_UART0+0)
MOVT	R1, #hi_addr(?lstr_60_UART0+0)
STR	R3, [SP, #4]
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
LDR	R3, [SP, #4]
;UART0.c,504 :: 		USB_PutQueue(BufNum);
MOV	R0, R3
; BufNum end address is: 12 (R3)
BL	_USB_PutQueue+0
;UART0.c,506 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
; BufNum start address is: 32 (R8)
MOV	R8, R0
;UART0.c,508 :: 		RcvBuf[3],RcvBuf[4],RcvBuf[5],RcvBuf[6]); // MAC address (6 bytes)
MOVW	R1, #lo_addr(_RcvBuf+6)
MOVT	R1, #hi_addr(_RcvBuf+6)
LDRB	R7, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+5)
MOVT	R1, #hi_addr(_RcvBuf+5)
LDRB	R6, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+4)
MOVT	R1, #hi_addr(_RcvBuf+4)
LDRB	R5, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+3)
MOVT	R1, #hi_addr(_RcvBuf+3)
LDRB	R4, [R1, #0]
;UART0.c,507 :: 		sprintf(BufNum,"MAC address: %02X %02X %02X %02X %02X %02X\r\n",RcvBuf[1],RcvBuf[2],
MOVW	R1, #lo_addr(_RcvBuf+2)
MOVT	R1, #hi_addr(_RcvBuf+2)
LDRB	R3, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+1)
MOVT	R1, #hi_addr(_RcvBuf+1)
LDRB	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_61_UART0+0)
MOVT	R1, #hi_addr(?lstr_61_UART0+0)
;UART0.c,508 :: 		RcvBuf[3],RcvBuf[4],RcvBuf[5],RcvBuf[6]); // MAC address (6 bytes)
STR	R8, [SP, #4]
PUSH	(R7)
PUSH	(R6)
PUSH	(R5)
PUSH	(R4)
;UART0.c,507 :: 		sprintf(BufNum,"MAC address: %02X %02X %02X %02X %02X %02X\r\n",RcvBuf[1],RcvBuf[2],
PUSH	(R3)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
;UART0.c,508 :: 		RcvBuf[3],RcvBuf[4],RcvBuf[5],RcvBuf[6]); // MAC address (6 bytes)
BL	_sprintf+0
ADD	SP, SP, #32
LDR	R8, [SP, #4]
;UART0.c,509 :: 		USB_PutQueue(BufNum);
MOV	R0, R8
; BufNum end address is: 32 (R8)
BL	_USB_PutQueue+0
;UART0.c,511 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
; BufNum start address is: 40 (R10)
MOV	R10, R0
;UART0.c,513 :: 		RcvBuf[7],RcvBuf[8],RcvBuf[9],RcvBuf[10],RcvBuf[11],RcvBuf[12],RcvBuf[13],RcvBuf[14]); // IP address (first 8 bytes)
MOVW	R1, #lo_addr(_RcvBuf+14)
MOVT	R1, #hi_addr(_RcvBuf+14)
LDRB	R9, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+13)
MOVT	R1, #hi_addr(_RcvBuf+13)
LDRB	R8, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+12)
MOVT	R1, #hi_addr(_RcvBuf+12)
LDRB	R7, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+11)
MOVT	R1, #hi_addr(_RcvBuf+11)
LDRB	R6, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+10)
MOVT	R1, #hi_addr(_RcvBuf+10)
LDRB	R5, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+9)
MOVT	R1, #hi_addr(_RcvBuf+9)
LDRB	R4, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+8)
MOVT	R1, #hi_addr(_RcvBuf+8)
LDRB	R3, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+7)
MOVT	R1, #hi_addr(_RcvBuf+7)
LDRB	R2, [R1, #0]
;UART0.c,512 :: 		sprintf(BufNum,"IP address: %02X%02X%02X%02X%02X%02X%02X%02X",
MOVW	R1, #lo_addr(?lstr_62_UART0+0)
MOVT	R1, #hi_addr(?lstr_62_UART0+0)
;UART0.c,513 :: 		RcvBuf[7],RcvBuf[8],RcvBuf[9],RcvBuf[10],RcvBuf[11],RcvBuf[12],RcvBuf[13],RcvBuf[14]); // IP address (first 8 bytes)
STR	R10, [SP, #4]
PUSH	36
PUSH	32
PUSH	(R7)
PUSH	(R6)
PUSH	(R5)
PUSH	(R4)
PUSH	(R3)
PUSH	(R2)
;UART0.c,512 :: 		sprintf(BufNum,"IP address: %02X%02X%02X%02X%02X%02X%02X%02X",
PUSH	(R1)
PUSH	(R0)
;UART0.c,513 :: 		RcvBuf[7],RcvBuf[8],RcvBuf[9],RcvBuf[10],RcvBuf[11],RcvBuf[12],RcvBuf[13],RcvBuf[14]); // IP address (first 8 bytes)
BL	_sprintf+0
ADD	SP, SP, #40
LDR	R10, [SP, #4]
;UART0.c,514 :: 		USB_PutQueue(BufNum);
MOV	R0, R10
; BufNum end address is: 40 (R10)
BL	_USB_PutQueue+0
;UART0.c,516 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
; BufNum start address is: 40 (R10)
MOV	R10, R0
;UART0.c,518 :: 		RcvBuf[15],RcvBuf[16],RcvBuf[17],RcvBuf[18],RcvBuf[19],RcvBuf[20],RcvBuf[21],RcvBuf[22]); // IP address (last 8 bytes)
MOVW	R1, #lo_addr(_RcvBuf+22)
MOVT	R1, #hi_addr(_RcvBuf+22)
LDRB	R9, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+21)
MOVT	R1, #hi_addr(_RcvBuf+21)
LDRB	R8, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+20)
MOVT	R1, #hi_addr(_RcvBuf+20)
LDRB	R7, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+19)
MOVT	R1, #hi_addr(_RcvBuf+19)
LDRB	R6, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+18)
MOVT	R1, #hi_addr(_RcvBuf+18)
LDRB	R5, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+17)
MOVT	R1, #hi_addr(_RcvBuf+17)
LDRB	R4, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+16)
MOVT	R1, #hi_addr(_RcvBuf+16)
LDRB	R3, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+15)
MOVT	R1, #hi_addr(_RcvBuf+15)
LDRB	R2, [R1, #0]
;UART0.c,517 :: 		sprintf(BufNum,"%02X%02X%02X%02X%02X%02X%02X%02X\r\n",
MOVW	R1, #lo_addr(?lstr_63_UART0+0)
MOVT	R1, #hi_addr(?lstr_63_UART0+0)
;UART0.c,518 :: 		RcvBuf[15],RcvBuf[16],RcvBuf[17],RcvBuf[18],RcvBuf[19],RcvBuf[20],RcvBuf[21],RcvBuf[22]); // IP address (last 8 bytes)
STR	R10, [SP, #4]
PUSH	36
PUSH	32
PUSH	(R7)
PUSH	(R6)
PUSH	(R5)
PUSH	(R4)
PUSH	(R3)
PUSH	(R2)
;UART0.c,517 :: 		sprintf(BufNum,"%02X%02X%02X%02X%02X%02X%02X%02X\r\n",
PUSH	(R1)
PUSH	(R0)
;UART0.c,518 :: 		RcvBuf[15],RcvBuf[16],RcvBuf[17],RcvBuf[18],RcvBuf[19],RcvBuf[20],RcvBuf[21],RcvBuf[22]); // IP address (last 8 bytes)
BL	_sprintf+0
ADD	SP, SP, #40
LDR	R10, [SP, #4]
;UART0.c,519 :: 		USB_PutQueue(BufNum);
MOV	R0, R10
; BufNum end address is: 40 (R10)
BL	_USB_PutQueue+0
;UART0.c,521 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
; BufNum start address is: 40 (R10)
MOV	R10, R0
;UART0.c,523 :: 		RcvBuf[23],RcvBuf[24],RcvBuf[25],RcvBuf[26],RcvBuf[27],RcvBuf[28],RcvBuf[29],RcvBuf[30]); // Network mask (first 8 bytes)
MOVW	R1, #lo_addr(_RcvBuf+30)
MOVT	R1, #hi_addr(_RcvBuf+30)
LDRB	R9, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+29)
MOVT	R1, #hi_addr(_RcvBuf+29)
LDRB	R8, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+28)
MOVT	R1, #hi_addr(_RcvBuf+28)
LDRB	R7, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+27)
MOVT	R1, #hi_addr(_RcvBuf+27)
LDRB	R6, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+26)
MOVT	R1, #hi_addr(_RcvBuf+26)
LDRB	R5, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+25)
MOVT	R1, #hi_addr(_RcvBuf+25)
LDRB	R4, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+24)
MOVT	R1, #hi_addr(_RcvBuf+24)
LDRB	R3, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+23)
MOVT	R1, #hi_addr(_RcvBuf+23)
LDRB	R2, [R1, #0]
;UART0.c,522 :: 		sprintf(BufNum,"Network mask: %02X%02X%02X%02X%02X%02X%02X%02X",
MOVW	R1, #lo_addr(?lstr_64_UART0+0)
MOVT	R1, #hi_addr(?lstr_64_UART0+0)
;UART0.c,523 :: 		RcvBuf[23],RcvBuf[24],RcvBuf[25],RcvBuf[26],RcvBuf[27],RcvBuf[28],RcvBuf[29],RcvBuf[30]); // Network mask (first 8 bytes)
STR	R10, [SP, #4]
PUSH	36
PUSH	32
PUSH	(R7)
PUSH	(R6)
PUSH	(R5)
PUSH	(R4)
PUSH	(R3)
PUSH	(R2)
;UART0.c,522 :: 		sprintf(BufNum,"Network mask: %02X%02X%02X%02X%02X%02X%02X%02X",
PUSH	(R1)
PUSH	(R0)
;UART0.c,523 :: 		RcvBuf[23],RcvBuf[24],RcvBuf[25],RcvBuf[26],RcvBuf[27],RcvBuf[28],RcvBuf[29],RcvBuf[30]); // Network mask (first 8 bytes)
BL	_sprintf+0
ADD	SP, SP, #40
LDR	R10, [SP, #4]
;UART0.c,524 :: 		USB_PutQueue(BufNum);
MOV	R0, R10
; BufNum end address is: 40 (R10)
BL	_USB_PutQueue+0
;UART0.c,526 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
; BufNum start address is: 40 (R10)
MOV	R10, R0
;UART0.c,528 :: 		RcvBuf[31],RcvBuf[32],RcvBuf[33],RcvBuf[34],RcvBuf[35],RcvBuf[36],RcvBuf[37],RcvBuf[38]); // Network mask (last 8 bytes)
MOVW	R1, #lo_addr(_RcvBuf+38)
MOVT	R1, #hi_addr(_RcvBuf+38)
LDRB	R9, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+37)
MOVT	R1, #hi_addr(_RcvBuf+37)
LDRB	R8, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+36)
MOVT	R1, #hi_addr(_RcvBuf+36)
LDRB	R7, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+35)
MOVT	R1, #hi_addr(_RcvBuf+35)
LDRB	R6, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+34)
MOVT	R1, #hi_addr(_RcvBuf+34)
LDRB	R5, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+33)
MOVT	R1, #hi_addr(_RcvBuf+33)
LDRB	R4, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+32)
MOVT	R1, #hi_addr(_RcvBuf+32)
LDRB	R3, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+31)
MOVT	R1, #hi_addr(_RcvBuf+31)
LDRB	R2, [R1, #0]
;UART0.c,527 :: 		sprintf(BufNum,"%02X%02X%02X%02X%02X%02X%02X%02X\r\n",
MOVW	R1, #lo_addr(?lstr_65_UART0+0)
MOVT	R1, #hi_addr(?lstr_65_UART0+0)
;UART0.c,528 :: 		RcvBuf[31],RcvBuf[32],RcvBuf[33],RcvBuf[34],RcvBuf[35],RcvBuf[36],RcvBuf[37],RcvBuf[38]); // Network mask (last 8 bytes)
STR	R10, [SP, #4]
PUSH	36
PUSH	32
PUSH	(R7)
PUSH	(R6)
PUSH	(R5)
PUSH	(R4)
PUSH	(R3)
PUSH	(R2)
;UART0.c,527 :: 		sprintf(BufNum,"%02X%02X%02X%02X%02X%02X%02X%02X\r\n",
PUSH	(R1)
PUSH	(R0)
;UART0.c,528 :: 		RcvBuf[31],RcvBuf[32],RcvBuf[33],RcvBuf[34],RcvBuf[35],RcvBuf[36],RcvBuf[37],RcvBuf[38]); // Network mask (last 8 bytes)
BL	_sprintf+0
ADD	SP, SP, #40
LDR	R10, [SP, #4]
;UART0.c,529 :: 		USB_PutQueue(BufNum);
MOV	R0, R10
; BufNum end address is: 40 (R10)
BL	_USB_PutQueue+0
;UART0.c,531 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
; BufNum start address is: 40 (R10)
MOV	R10, R0
;UART0.c,533 :: 		RcvBuf[39],RcvBuf[40],RcvBuf[41],RcvBuf[42],RcvBuf[43],RcvBuf[44],RcvBuf[45],RcvBuf[46]); // Gateway address (first 8 bytes)
MOVW	R1, #lo_addr(_RcvBuf+46)
MOVT	R1, #hi_addr(_RcvBuf+46)
LDRB	R9, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+45)
MOVT	R1, #hi_addr(_RcvBuf+45)
LDRB	R8, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+44)
MOVT	R1, #hi_addr(_RcvBuf+44)
LDRB	R7, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+43)
MOVT	R1, #hi_addr(_RcvBuf+43)
LDRB	R6, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+42)
MOVT	R1, #hi_addr(_RcvBuf+42)
LDRB	R5, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+41)
MOVT	R1, #hi_addr(_RcvBuf+41)
LDRB	R4, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+40)
MOVT	R1, #hi_addr(_RcvBuf+40)
LDRB	R3, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+39)
MOVT	R1, #hi_addr(_RcvBuf+39)
LDRB	R2, [R1, #0]
;UART0.c,532 :: 		sprintf(BufNum,"Gateway addr: %02X%02X%02X%02X%02X%02X%02X%02X",
MOVW	R1, #lo_addr(?lstr_66_UART0+0)
MOVT	R1, #hi_addr(?lstr_66_UART0+0)
;UART0.c,533 :: 		RcvBuf[39],RcvBuf[40],RcvBuf[41],RcvBuf[42],RcvBuf[43],RcvBuf[44],RcvBuf[45],RcvBuf[46]); // Gateway address (first 8 bytes)
STR	R10, [SP, #4]
PUSH	36
PUSH	32
PUSH	(R7)
PUSH	(R6)
PUSH	(R5)
PUSH	(R4)
PUSH	(R3)
PUSH	(R2)
;UART0.c,532 :: 		sprintf(BufNum,"Gateway addr: %02X%02X%02X%02X%02X%02X%02X%02X",
PUSH	(R1)
PUSH	(R0)
;UART0.c,533 :: 		RcvBuf[39],RcvBuf[40],RcvBuf[41],RcvBuf[42],RcvBuf[43],RcvBuf[44],RcvBuf[45],RcvBuf[46]); // Gateway address (first 8 bytes)
BL	_sprintf+0
ADD	SP, SP, #40
LDR	R10, [SP, #4]
;UART0.c,534 :: 		USB_PutQueue(BufNum);
MOV	R0, R10
; BufNum end address is: 40 (R10)
BL	_USB_PutQueue+0
;UART0.c,536 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
; BufNum start address is: 40 (R10)
MOV	R10, R0
;UART0.c,538 :: 		RcvBuf[47],RcvBuf[48],RcvBuf[49],RcvBuf[50],RcvBuf[51],RcvBuf[52],RcvBuf[53],RcvBuf[54]); // Gateway address (last 8 bytes)
MOVW	R1, #lo_addr(_RcvBuf+54)
MOVT	R1, #hi_addr(_RcvBuf+54)
LDRB	R9, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+53)
MOVT	R1, #hi_addr(_RcvBuf+53)
LDRB	R8, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+52)
MOVT	R1, #hi_addr(_RcvBuf+52)
LDRB	R7, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+51)
MOVT	R1, #hi_addr(_RcvBuf+51)
LDRB	R6, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+50)
MOVT	R1, #hi_addr(_RcvBuf+50)
LDRB	R5, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+49)
MOVT	R1, #hi_addr(_RcvBuf+49)
LDRB	R4, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+48)
MOVT	R1, #hi_addr(_RcvBuf+48)
LDRB	R3, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+47)
MOVT	R1, #hi_addr(_RcvBuf+47)
LDRB	R2, [R1, #0]
;UART0.c,537 :: 		sprintf(BufNum,"%02X%02X%02X%02X%02X%02X%02X%02X\r\n",
MOVW	R1, #lo_addr(?lstr_67_UART0+0)
MOVT	R1, #hi_addr(?lstr_67_UART0+0)
;UART0.c,538 :: 		RcvBuf[47],RcvBuf[48],RcvBuf[49],RcvBuf[50],RcvBuf[51],RcvBuf[52],RcvBuf[53],RcvBuf[54]); // Gateway address (last 8 bytes)
STR	R10, [SP, #4]
PUSH	36
PUSH	32
PUSH	(R7)
PUSH	(R6)
PUSH	(R5)
PUSH	(R4)
PUSH	(R3)
PUSH	(R2)
;UART0.c,537 :: 		sprintf(BufNum,"%02X%02X%02X%02X%02X%02X%02X%02X\r\n",
PUSH	(R1)
PUSH	(R0)
;UART0.c,538 :: 		RcvBuf[47],RcvBuf[48],RcvBuf[49],RcvBuf[50],RcvBuf[51],RcvBuf[52],RcvBuf[53],RcvBuf[54]); // Gateway address (last 8 bytes)
BL	_sprintf+0
ADD	SP, SP, #40
LDR	R10, [SP, #4]
;UART0.c,539 :: 		USB_PutQueue(BufNum);
MOV	R0, R10
; BufNum end address is: 40 (R10)
BL	_USB_PutQueue+0
;UART0.c,541 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
; BufNum start address is: 12 (R3)
MOV	R3, R0
;UART0.c,542 :: 		sprintf(BufNum,"Network status: %02X\r\n",RcvBuf[55]); // Network status: 0-Not connected static IP, 1-Connected static IP, 2-Not connected DHCP, 3-Connected DHCP
MOVW	R1, #lo_addr(_RcvBuf+55)
MOVT	R1, #hi_addr(_RcvBuf+55)
LDRB	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_68_UART0+0)
MOVT	R1, #hi_addr(?lstr_68_UART0+0)
STR	R3, [SP, #4]
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
LDR	R3, [SP, #4]
;UART0.c,543 :: 		USB_PutQueue(BufNum);
MOV	R0, R3
; BufNum end address is: 12 (R3)
BL	_USB_PutQueue+0
;UART0.c,544 :: 		break;
IT	AL
BAL	L_UART0_Rx233
;UART0.c,546 :: 		case 0x31: // WPAKEY_RESPONSE_MSG (49 RESPONSE)
L_UART0_Rx2117:
;UART0.c,547 :: 		WiFiEvents.WpaKeyResp = TRUE;
MOVS	R1, #1
MOVW	R0, #lo_addr(_WiFiEvents+19)
MOVT	R0, #hi_addr(_WiFiEvents+19)
STRB	R1, [R0, #0]
;UART0.c,548 :: 		for (i=0;i<32;i++)
; i start address is: 8 (R2)
MOVS	R2, #0
; i end address is: 8 (R2)
L_UART0_Rx2118:
; i start address is: 8 (R2)
CMP	R2, #32
IT	CS
BCS	L_UART0_Rx2119
;UART0.c,549 :: 		myAP_Key[i] = RcvBuf[i];
MOVW	R0, #lo_addr(_myAP_Key+0)
MOVT	R0, #hi_addr(_myAP_Key+0)
ADDS	R1, R0, R2
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
ADDS	R0, R0, R2
LDRB	R0, [R0, #0]
STRB	R0, [R1, #0]
;UART0.c,548 :: 		for (i=0;i<32;i++)
ADDS	R2, R2, #1
UXTH	R2, R2
;UART0.c,549 :: 		myAP_Key[i] = RcvBuf[i];
; i end address is: 8 (R2)
IT	AL
BAL	L_UART0_Rx2118
L_UART0_Rx2119:
;UART0.c,551 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
; BufNum start address is: 40 (R10)
MOV	R10, R0
;UART0.c,552 :: 		sprintf(BufNum,"%02X%02X%02X%02X%02X%02X%02X%02X\r\n",RcvBuf[0],RcvBuf[1],RcvBuf[2],RcvBuf[3],RcvBuf[4],RcvBuf[5],RcvBuf[6],RcvBuf[7]);
MOVW	R1, #lo_addr(_RcvBuf+7)
MOVT	R1, #hi_addr(_RcvBuf+7)
LDRB	R9, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+6)
MOVT	R1, #hi_addr(_RcvBuf+6)
LDRB	R8, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+5)
MOVT	R1, #hi_addr(_RcvBuf+5)
LDRB	R7, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+4)
MOVT	R1, #hi_addr(_RcvBuf+4)
LDRB	R6, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+3)
MOVT	R1, #hi_addr(_RcvBuf+3)
LDRB	R5, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+2)
MOVT	R1, #hi_addr(_RcvBuf+2)
LDRB	R4, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+1)
MOVT	R1, #hi_addr(_RcvBuf+1)
LDRB	R3, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+0)
MOVT	R1, #hi_addr(_RcvBuf+0)
LDRB	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_69_UART0+0)
MOVT	R1, #hi_addr(?lstr_69_UART0+0)
STR	R10, [SP, #4]
PUSH	36
PUSH	32
PUSH	(R7)
PUSH	(R6)
PUSH	(R5)
PUSH	(R4)
PUSH	(R3)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #40
LDR	R10, [SP, #4]
;UART0.c,553 :: 		USB_PutQueue(BufNum);
MOV	R0, R10
; BufNum end address is: 40 (R10)
BL	_USB_PutQueue+0
;UART0.c,554 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
; BufNum start address is: 40 (R10)
MOV	R10, R0
;UART0.c,555 :: 		sprintf(BufNum,"%02X%02X%02X%02X%02X%02X%02X%02X\r\n",RcvBuf[8],RcvBuf[9],RcvBuf[10],RcvBuf[11],RcvBuf[12],RcvBuf[13],RcvBuf[14],RcvBuf[15]);
MOVW	R1, #lo_addr(_RcvBuf+15)
MOVT	R1, #hi_addr(_RcvBuf+15)
LDRB	R9, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+14)
MOVT	R1, #hi_addr(_RcvBuf+14)
LDRB	R8, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+13)
MOVT	R1, #hi_addr(_RcvBuf+13)
LDRB	R7, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+12)
MOVT	R1, #hi_addr(_RcvBuf+12)
LDRB	R6, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+11)
MOVT	R1, #hi_addr(_RcvBuf+11)
LDRB	R5, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+10)
MOVT	R1, #hi_addr(_RcvBuf+10)
LDRB	R4, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+9)
MOVT	R1, #hi_addr(_RcvBuf+9)
LDRB	R3, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+8)
MOVT	R1, #hi_addr(_RcvBuf+8)
LDRB	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_70_UART0+0)
MOVT	R1, #hi_addr(?lstr_70_UART0+0)
STR	R10, [SP, #4]
PUSH	36
PUSH	32
PUSH	(R7)
PUSH	(R6)
PUSH	(R5)
PUSH	(R4)
PUSH	(R3)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #40
LDR	R10, [SP, #4]
;UART0.c,556 :: 		USB_PutQueue(BufNum);
MOV	R0, R10
; BufNum end address is: 40 (R10)
BL	_USB_PutQueue+0
;UART0.c,557 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
; BufNum start address is: 40 (R10)
MOV	R10, R0
;UART0.c,558 :: 		sprintf(BufNum,"%02X%02X%02X%02X%02X%02X%02X%02X\r\n",RcvBuf[16],RcvBuf[17],RcvBuf[18],RcvBuf[19],RcvBuf[20],RcvBuf[21],RcvBuf[22],RcvBuf[23]);
MOVW	R1, #lo_addr(_RcvBuf+23)
MOVT	R1, #hi_addr(_RcvBuf+23)
LDRB	R9, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+22)
MOVT	R1, #hi_addr(_RcvBuf+22)
LDRB	R8, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+21)
MOVT	R1, #hi_addr(_RcvBuf+21)
LDRB	R7, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+20)
MOVT	R1, #hi_addr(_RcvBuf+20)
LDRB	R6, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+19)
MOVT	R1, #hi_addr(_RcvBuf+19)
LDRB	R5, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+18)
MOVT	R1, #hi_addr(_RcvBuf+18)
LDRB	R4, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+17)
MOVT	R1, #hi_addr(_RcvBuf+17)
LDRB	R3, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+16)
MOVT	R1, #hi_addr(_RcvBuf+16)
LDRB	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_71_UART0+0)
MOVT	R1, #hi_addr(?lstr_71_UART0+0)
STR	R10, [SP, #4]
PUSH	36
PUSH	32
PUSH	(R7)
PUSH	(R6)
PUSH	(R5)
PUSH	(R4)
PUSH	(R3)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #40
LDR	R10, [SP, #4]
;UART0.c,559 :: 		USB_PutQueue(BufNum);
MOV	R0, R10
; BufNum end address is: 40 (R10)
BL	_USB_PutQueue+0
;UART0.c,560 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
; BufNum start address is: 40 (R10)
MOV	R10, R0
;UART0.c,561 :: 		sprintf(BufNum,"%02X%02X%02X%02X%02X%02X%02X%02X\r\n",RcvBuf[24],RcvBuf[25],RcvBuf[26],RcvBuf[27],RcvBuf[28],RcvBuf[29],RcvBuf[30],RcvBuf[31]);
MOVW	R1, #lo_addr(_RcvBuf+31)
MOVT	R1, #hi_addr(_RcvBuf+31)
LDRB	R9, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+30)
MOVT	R1, #hi_addr(_RcvBuf+30)
LDRB	R8, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+29)
MOVT	R1, #hi_addr(_RcvBuf+29)
LDRB	R7, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+28)
MOVT	R1, #hi_addr(_RcvBuf+28)
LDRB	R6, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+27)
MOVT	R1, #hi_addr(_RcvBuf+27)
LDRB	R5, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+26)
MOVT	R1, #hi_addr(_RcvBuf+26)
LDRB	R4, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+25)
MOVT	R1, #hi_addr(_RcvBuf+25)
LDRB	R3, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+24)
MOVT	R1, #hi_addr(_RcvBuf+24)
LDRB	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_72_UART0+0)
MOVT	R1, #hi_addr(?lstr_72_UART0+0)
STR	R10, [SP, #4]
PUSH	36
PUSH	32
PUSH	(R7)
PUSH	(R6)
PUSH	(R5)
PUSH	(R4)
PUSH	(R3)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #40
LDR	R10, [SP, #4]
;UART0.c,562 :: 		USB_PutQueue(BufNum);
MOV	R0, R10
; BufNum end address is: 40 (R10)
BL	_USB_PutQueue+0
;UART0.c,563 :: 		break;
IT	AL
BAL	L_UART0_Rx233
;UART0.c,565 :: 		case 0x32: // GPIO_RESPONSE_MSG (50 RESPONSE)
L_UART0_Rx2121:
;UART0.c,566 :: 		WiFiEvents.GpioResp = TRUE;
MOVS	R1, #1
MOVW	R0, #lo_addr(_WiFiEvents+20)
MOVT	R0, #hi_addr(_WiFiEvents+20)
STRB	R1, [R0, #0]
;UART0.c,568 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
; BufNum start address is: 16 (R4)
MOV	R4, R0
;UART0.c,569 :: 		sprintf(BufNum,"%02X,%02X\r\n",RcvBuf[0],RcvBuf[1]);
MOVW	R1, #lo_addr(_RcvBuf+1)
MOVT	R1, #hi_addr(_RcvBuf+1)
LDRB	R3, [R1, #0]
MOVW	R1, #lo_addr(_RcvBuf+0)
MOVT	R1, #hi_addr(_RcvBuf+0)
LDRB	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_73_UART0+0)
MOVT	R1, #hi_addr(?lstr_73_UART0+0)
STR	R4, [SP, #4]
PUSH	(R3)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #16
LDR	R4, [SP, #4]
;UART0.c,570 :: 		USB_PutQueue(BufNum);
MOV	R0, R4
; BufNum end address is: 16 (R4)
BL	_USB_PutQueue+0
;UART0.c,571 :: 		break;
IT	AL
BAL	L_UART0_Rx233
;UART0.c,573 :: 		default:
L_UART0_Rx2122:
;UART0.c,574 :: 		BufNum = GetBuffer(); // In case there is some response not described in the manual
; MT1 start address is: 28 (R7)
; MT0 start address is: 24 (R6)
STRH	R7, [SP, #4]
STRH	R6, [SP, #6]
BL	_GetBuffer+0
LDRH	R6, [SP, #6]
LDRH	R7, [SP, #4]
; BufNum start address is: 16 (R4)
MOV	R4, R0
;UART0.c,575 :: 		sprintf(Bufnum,"Unknown message type: %u %u\r\n",MT0,MT1);
UXTH	R3, R7
; MT1 end address is: 28 (R7)
UXTH	R2, R6
; MT0 end address is: 24 (R6)
MOVW	R1, #lo_addr(?lstr_74_UART0+0)
MOVT	R1, #hi_addr(?lstr_74_UART0+0)
STR	R4, [SP, #4]
PUSH	(R3)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #16
LDR	R4, [SP, #4]
;UART0.c,576 :: 		USB_PutQueue(BufNum);
MOV	R0, R4
; BufNum end address is: 16 (R4)
BL	_USB_PutQueue+0
;UART0.c,577 :: 		break;
IT	AL
BAL	L_UART0_Rx233
;UART0.c,578 :: 		}
L_UART0_Rx232:
; MT1 start address is: 28 (R7)
; MT0 start address is: 24 (R6)
CMP	R6, #1
IT	EQ
BEQ	L_UART0_Rx234
CMP	R6, #22
IT	EQ
BEQ	L_UART0_Rx261
CMP	R6, #23
IT	EQ
BEQ	L_UART0_Rx271
CMP	R6, #24
IT	EQ
BEQ	L_UART0_Rx277
CMP	R6, #25
IT	EQ
BEQ	L_UART0_Rx278
CMP	R6, #26
IT	EQ
BEQ	L_UART0_Rx284
CMP	R6, #27
IT	EQ
BEQ	L_UART0_Rx290
CMP	R6, #28
IT	EQ
BEQ	L_UART0_Rx291
CMP	R6, #29
IT	EQ
BEQ	L_UART0_Rx292
CMP	R6, #30
IT	EQ
BEQ	L_UART0_Rx293
CMP	R6, #31
IT	EQ
BEQ	L_UART0_Rx294
CMP	R6, #32
IT	EQ
BEQ	L_UART0_Rx298
CMP	R6, #48
IT	EQ
BEQ	L_UART0_Rx2104
CMP	R6, #49
IT	EQ
BEQ	L_UART0_Rx2117
CMP	R6, #50
IT	EQ
BEQ	L_UART0_Rx2121
IT	AL
BAL	L_UART0_Rx2122
; MT0 end address is: 24 (R6)
; MT1 end address is: 28 (R7)
L_UART0_Rx233:
;UART0.c,580 :: 		UART0_RxFuncPtr = UART0_Rx1;  // Go back to state 1
MOVW	R1, #lo_addr(_UART0_Rx1+0)
MOVT	R1, #hi_addr(_UART0_Rx1+0)
MOVW	R0, #lo_addr(_UART0_RxFuncPtr+0)
MOVT	R0, #hi_addr(_UART0_RxFuncPtr+0)
STR	R1, [R0, #0]
;UART0.c,581 :: 		}
L_end_UART0_Rx2:
LDR	LR, [SP, #0]
ADD	SP, SP, #12
BX	LR
; end of _UART0_Rx2
_UART0_TxQueueInit:
;UART0.c,590 :: 		void UART0_TxQueueInit(void){
;UART0.c,591 :: 		TxIn = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_TxIn+0)
MOVT	R0, #hi_addr(_TxIn+0)
STRB	R1, [R0, #0]
;UART0.c,592 :: 		TxOut = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_TxOut+0)
MOVT	R0, #hi_addr(_TxOut+0)
STRB	R1, [R0, #0]
;UART0.c,593 :: 		XmtBufPtr = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_XmtBufPtr+0)
MOVT	R0, #hi_addr(_XmtBufPtr+0)
STRH	R1, [R0, #0]
;UART0.c,594 :: 		}
L_end_UART0_TxQueueInit:
BX	LR
; end of _UART0_TxQueueInit
_UART0_PutQueue:
;UART0.c,599 :: 		void UART0_PutQueue(char *msg, unsigned int msgsize) {
; msgsize start address is: 4 (R1)
; msgsize end address is: 4 (R1)
; msgsize start address is: 4 (R1)
;UART0.c,600 :: 		Size[TxIn] = msgsize;     // Put the message Size into FIFO
MOVW	R4, #lo_addr(_TxIn+0)
MOVT	R4, #hi_addr(_TxIn+0)
LDRB	R2, [R4, #0]
LSLS	R3, R2, #1
MOVW	R2, #lo_addr(_Size+0)
MOVT	R2, #hi_addr(_Size+0)
ADDS	R2, R2, R3
STRH	R1, [R2, #0]
; msgsize end address is: 4 (R1)
;UART0.c,601 :: 		TxQueue[TxIn++] = msg;    // Put the message pointer into FIFO
MOV	R2, R4
LDRB	R2, [R2, #0]
LSLS	R3, R2, #2
MOVW	R2, #lo_addr(_TxQueue+0)
MOVT	R2, #hi_addr(_TxQueue+0)
ADDS	R2, R2, R3
STR	R0, [R2, #0]
MOV	R2, R4
LDRB	R2, [R2, #0]
ADDS	R2, R2, #1
UXTB	R2, R2
STRB	R2, [R4, #0]
;UART0.c,602 :: 		if (TxIn > (txqsize-1))   // Adjust FIFO in pointer
CMP	R2, #63
IT	LS
BLS	L_UART0_PutQueue123
;UART0.c,603 :: 		TxIn = 0;
MOVS	R3, #0
MOVW	R2, #lo_addr(_TxIn+0)
MOVT	R2, #hi_addr(_TxIn+0)
STRB	R3, [R2, #0]
L_UART0_PutQueue123:
;UART0.c,604 :: 		}
L_end_UART0_PutQueue:
BX	LR
; end of _UART0_PutQueue
_UART0_Tx:
;UART0.c,608 :: 		void UART0_Tx(void) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;UART0.c,609 :: 		UART0_TxFuncPtr();    // Use the function pointer to go to a state
MOVW	R4, #lo_addr(_UART0_TxFuncPtr+0)
MOVT	R4, #hi_addr(_UART0_TxFuncPtr+0)
LDR	R4, [R4, #0]
BLX	R4
;UART0.c,610 :: 		}
L_end_UART0_Tx:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _UART0_Tx
_UART0_Tx1:
;UART0.c,614 :: 		void UART0_Tx1(void) {
;UART0.c,615 :: 		if (TxIn != TxOut) {
MOVW	R0, #lo_addr(_TxOut+0)
MOVT	R0, #hi_addr(_TxOut+0)
LDRB	R1, [R0, #0]
MOVW	R0, #lo_addr(_TxIn+0)
MOVT	R0, #hi_addr(_TxIn+0)
LDRB	R0, [R0, #0]
CMP	R0, R1
IT	EQ
BEQ	L_UART0_Tx1124
;UART0.c,616 :: 		TxMsgLength = Size[TxOut];    // Get message size
MOVW	R2, #lo_addr(_TxOut+0)
MOVT	R2, #hi_addr(_TxOut+0)
LDRB	R0, [R2, #0]
LSLS	R1, R0, #1
MOVW	R0, #lo_addr(_Size+0)
MOVT	R0, #hi_addr(_Size+0)
ADDS	R0, R0, R1
LDRH	R1, [R0, #0]
MOVW	R0, #lo_addr(_TxMsgLength+0)
MOVT	R0, #hi_addr(_TxMsgLength+0)
STRH	R1, [R0, #0]
;UART0.c,617 :: 		XmtBuf = TxQueue[TxOut++];    // Get message pointer
MOV	R0, R2
LDRB	R0, [R0, #0]
LSLS	R1, R0, #2
MOVW	R0, #lo_addr(_TxQueue+0)
MOVT	R0, #hi_addr(_TxQueue+0)
ADDS	R0, R0, R1
LDR	R1, [R0, #0]
MOVW	R0, #lo_addr(_XmtBuf+0)
MOVT	R0, #hi_addr(_XmtBuf+0)
STR	R1, [R0, #0]
MOV	R0, R2
LDRB	R0, [R0, #0]
ADDS	R0, R0, #1
UXTB	R0, R0
STRB	R0, [R2, #0]
;UART0.c,618 :: 		if (TxOut > (txqsize-1))      // Update FIFO out pointer
CMP	R0, #63
IT	LS
BLS	L_UART0_Tx1125
;UART0.c,619 :: 		TxOut = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_TxOut+0)
MOVT	R0, #hi_addr(_TxOut+0)
STRB	R1, [R0, #0]
L_UART0_Tx1125:
;UART0.c,620 :: 		XmtBufPtr = 0;                // Reset byte pointer to 0
MOVS	R1, #0
MOVW	R0, #lo_addr(_XmtBufPtr+0)
MOVT	R0, #hi_addr(_XmtBufPtr+0)
STRH	R1, [R0, #0]
;UART0.c,621 :: 		UART0_TxFuncPtr = UART0_Tx2;  // Go to state 2
MOVW	R1, #lo_addr(_UART0_Tx2+0)
MOVT	R1, #hi_addr(_UART0_Tx2+0)
MOVW	R0, #lo_addr(_UART0_TxFuncPtr+0)
MOVT	R0, #hi_addr(_UART0_TxFuncPtr+0)
STR	R1, [R0, #0]
;UART0.c,622 :: 		}
L_UART0_Tx1124:
;UART0.c,623 :: 		}
L_end_UART0_Tx1:
BX	LR
; end of _UART0_Tx1
_UART0_Tx2:
;UART0.c,626 :: 		void UART0_Tx2(void) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;UART0.c,627 :: 		if (UART0_Tx_Idle()) {                     // If transmitter ready
BL	_UART0_Tx_Idle+0
CMP	R0, #0
IT	EQ
BEQ	L_UART0_Tx2126
;UART0.c,628 :: 		UART0_Write(XmtBuf[XmtBufPtr++]);      // Put 1 byte in transmit register
MOVW	R0, #lo_addr(_XmtBufPtr+0)
MOVT	R0, #hi_addr(_XmtBufPtr+0)
LDRH	R1, [R0, #0]
MOVW	R0, #lo_addr(_XmtBuf+0)
MOVT	R0, #hi_addr(_XmtBuf+0)
LDR	R0, [R0, #0]
ADDS	R0, R0, R1
LDRB	R0, [R0, #0]
BL	_UART0_Write+0
MOVW	R2, #lo_addr(_XmtBufPtr+0)
MOVT	R2, #hi_addr(_XmtBufPtr+0)
LDRH	R0, [R2, #0]
ADDS	R1, R0, #1
UXTH	R1, R1
STRH	R1, [R2, #0]
;UART0.c,629 :: 		if (XmtBufPtr == TxMsgLength) {        // Check if at end of message
MOVW	R0, #lo_addr(_TxMsgLength+0)
MOVT	R0, #hi_addr(_TxMsgLength+0)
LDRH	R0, [R0, #0]
CMP	R1, R0
IT	NE
BNE	L_UART0_Tx2127
;UART0.c,630 :: 		USB_PutQueue("Message sent\r\n");
MOVW	R0, #lo_addr(?lstr75_UART0+0)
MOVT	R0, #hi_addr(?lstr75_UART0+0)
BL	_USB_PutQueue+0
;UART0.c,631 :: 		UART0_TxFuncPtr = UART0_Tx1;       // Go back to state 1
MOVW	R1, #lo_addr(_UART0_Tx1+0)
MOVT	R1, #hi_addr(_UART0_Tx1+0)
MOVW	R0, #lo_addr(_UART0_TxFuncPtr+0)
MOVT	R0, #hi_addr(_UART0_TxFuncPtr+0)
STR	R1, [R0, #0]
;UART0.c,632 :: 		}
L_UART0_Tx2127:
;UART0.c,633 :: 		}
L_UART0_Tx2126:
;UART0.c,634 :: 		}
L_end_UART0_Tx2:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _UART0_Tx2
