_USB0_Interrupt:
;USB_Driver.c,60 :: 		void USB0_Interrupt() iv IVT_INT_USB0 ics ICS_AUTO {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;USB_Driver.c,61 :: 		USB_Interrupt_Proc();
BL	_USB_Interrupt_Proc+0
;USB_Driver.c,62 :: 		}
L_end_USB0_Interrupt:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _USB0_Interrupt
_USB_Init:
;USB_Driver.c,66 :: 		void USB_Init(void) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;USB_Driver.c,70 :: 		HID_Enable(&readbuff,&writebuff);
MOVW	R1, #lo_addr(_writebuff+0)
MOVT	R1, #hi_addr(_writebuff+0)
MOVW	R0, #lo_addr(_readbuff+0)
MOVT	R0, #hi_addr(_readbuff+0)
BL	_HID_Enable+0
;USB_Driver.c,71 :: 		USB_TxQueueInit();
BL	_USB_TxQueueInit+0
;USB_Driver.c,72 :: 		}
L_end_USB_Init:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _USB_Init
_USB_TxQueueInit:
;USB_Driver.c,76 :: 		void USB_TxQueueInit(void) {
;USB_Driver.c,77 :: 		txqueue0.in = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_txqueue0+0)
MOVT	R0, #hi_addr(_txqueue0+0)
STRH	R1, [R0, #0]
;USB_Driver.c,78 :: 		txqueue0.out = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_txqueue0+2)
MOVT	R0, #hi_addr(_txqueue0+2)
STRH	R1, [R0, #0]
;USB_Driver.c,79 :: 		}
L_end_USB_TxQueueInit:
BX	LR
; end of _USB_TxQueueInit
_USB_PutQueue:
;USB_Driver.c,84 :: 		void USB_PutQueue(char *msg) {
;USB_Driver.c,85 :: 		txqueue0.q[txqueue0.in++] = msg;
MOVW	R3, #lo_addr(_txqueue0+0)
MOVT	R3, #hi_addr(_txqueue0+0)
LDRH	R1, [R3, #0]
LSLS	R2, R1, #2
MOVW	R1, #lo_addr(_txqueue0+4)
MOVT	R1, #hi_addr(_txqueue0+4)
ADDS	R1, R1, R2
STR	R0, [R1, #0]
MOV	R1, R3
LDRH	R1, [R1, #0]
ADDS	R1, R1, #1
UXTH	R1, R1
STRH	R1, [R3, #0]
;USB_Driver.c,86 :: 		if (txqueue0.in > (txqsize0-1))
CMP	R1, #31
IT	LS
BLS	L_USB_PutQueue0
;USB_Driver.c,87 :: 		txqueue0.in = 0;
MOVS	R2, #0
MOVW	R1, #lo_addr(_txqueue0+0)
MOVT	R1, #hi_addr(_txqueue0+0)
STRH	R2, [R1, #0]
L_USB_PutQueue0:
;USB_Driver.c,88 :: 		}
L_end_USB_PutQueue:
BX	LR
; end of _USB_PutQueue
_USB_CheckOut:
;USB_Driver.c,96 :: 		void USB_CheckOut(void) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;USB_Driver.c,99 :: 		if (txqueue0.in != txqueue0.out) {          // Look for a pointer in the FIFO
MOVW	R0, #lo_addr(_txqueue0+2)
MOVT	R0, #hi_addr(_txqueue0+2)
LDRH	R1, [R0, #0]
MOVW	R0, #lo_addr(_txqueue0+0)
MOVT	R0, #hi_addr(_txqueue0+0)
LDRH	R0, [R0, #0]
CMP	R0, R1
IT	EQ
BEQ	L_USB_CheckOut1
;USB_Driver.c,103 :: 		if (HID_Write(txqueue0.q[txqueue0.out],64) != 0) {
MOVW	R0, #lo_addr(_txqueue0+2)
MOVT	R0, #hi_addr(_txqueue0+2)
LDRH	R0, [R0, #0]
LSLS	R1, R0, #2
MOVW	R0, #lo_addr(_txqueue0+4)
MOVT	R0, #hi_addr(_txqueue0+4)
ADDS	R0, R0, R1
LDR	R0, [R0, #0]
MOVS	R1, #64
BL	_HID_Write+0
CMP	R0, #0
IT	EQ
BEQ	L_USB_CheckOut2
;USB_Driver.c,104 :: 		txqueue0.out++;
MOVW	R1, #lo_addr(_txqueue0+2)
MOVT	R1, #hi_addr(_txqueue0+2)
LDRH	R0, [R1, #0]
ADDS	R0, R0, #1
UXTH	R0, R0
STRH	R0, [R1, #0]
;USB_Driver.c,105 :: 		if (txqueue0.out > (txqsize0-1))   // If past the end of array
CMP	R0, #31
IT	LS
BLS	L_USB_CheckOut3
;USB_Driver.c,106 :: 		txqueue0.out = 0;              // set pointer to start of array
MOVS	R1, #0
MOVW	R0, #lo_addr(_txqueue0+2)
MOVT	R0, #hi_addr(_txqueue0+2)
STRH	R1, [R0, #0]
L_USB_CheckOut3:
;USB_Driver.c,112 :: 		}
L_USB_CheckOut2:
;USB_Driver.c,113 :: 		}
L_USB_CheckOut1:
;USB_Driver.c,114 :: 		}
L_end_USB_CheckOut:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _USB_CheckOut
_USB_CheckIn:
;USB_Driver.c,120 :: 		void USB_CheckIn(void) {
SUB	SP, SP, #28
STR	LR, [SP, #0]
;USB_Driver.c,125 :: 		if (HID_Read() != 0) {
BL	_HID_Read+0
CMP	R0, #0
IT	EQ
BEQ	L_USB_CheckIn4
;USB_Driver.c,126 :: 		switch (readbuff[0]) {
IT	AL
BAL	L_USB_CheckIn5
;USB_Driver.c,128 :: 		case 'a':  // Show date/time
L_USB_CheckIn7:
;USB_Driver.c,129 :: 		Year = ts1.yy;    // MikroE sprintf has trouble with char type
MOVW	R0, #lo_addr(_ts1+6)
MOVT	R0, #hi_addr(_ts1+6)
; Year start address is: 4 (R1)
LDRH	R1, [R0, #0]
;USB_Driver.c,130 :: 		Month = ts1.mo;
MOVW	R0, #lo_addr(_ts1+5)
MOVT	R0, #hi_addr(_ts1+5)
; Month start address is: 8 (R2)
LDRB	R2, [R0, #0]
;USB_Driver.c,131 :: 		Day = ts1.md;
MOVW	R0, #lo_addr(_ts1+3)
MOVT	R0, #hi_addr(_ts1+3)
; Day start address is: 12 (R3)
LDRB	R3, [R0, #0]
;USB_Driver.c,132 :: 		Hour = ts1.hh;
MOVW	R0, #lo_addr(_ts1+2)
MOVT	R0, #hi_addr(_ts1+2)
; Hour start address is: 16 (R4)
LDRB	R4, [R0, #0]
;USB_Driver.c,133 :: 		Minute = ts1.mn;
MOVW	R0, #lo_addr(_ts1+1)
MOVT	R0, #hi_addr(_ts1+1)
; Minute start address is: 20 (R5)
LDRB	R5, [R0, #0]
;USB_Driver.c,134 :: 		Second = ts1.ss;
MOVW	R0, #lo_addr(_ts1+0)
MOVT	R0, #hi_addr(_ts1+0)
; Second start address is: 24 (R6)
LDRB	R6, [R0, #0]
;USB_Driver.c,136 :: 		BufNum = GetBuffer();     // Get a free buffer
STRH	R6, [SP, #4]
STRH	R5, [SP, #6]
STRH	R4, [SP, #8]
STRH	R3, [SP, #10]
STRH	R2, [SP, #12]
STRH	R1, [SP, #14]
BL	_GetBuffer+0
LDRSH	R1, [SP, #14]
LDRSH	R2, [SP, #12]
LDRSH	R3, [SP, #10]
LDRSH	R4, [SP, #8]
LDRSH	R5, [SP, #6]
LDRSH	R6, [SP, #4]
; BufNum start address is: 32 (R8)
MOV	R8, R0
;USB_Driver.c,137 :: 		sprintf(BufNum,"%04d/%02d/%02d %02d:%02d:%02d\r\n",Year,Month,Day,Hour,Minute,Second);
SXTH	R7, R6
; Second end address is: 24 (R6)
SXTH	R6, R5
; Minute end address is: 20 (R5)
SXTH	R5, R4
; Hour end address is: 16 (R4)
SXTH	R4, R3
; Day end address is: 12 (R3)
SXTH	R3, R2
; Month end address is: 8 (R2)
SXTH	R2, R1
; Year end address is: 4 (R1)
MOVW	R1, #lo_addr(?lstr_1_USB_Driver+0)
MOVT	R1, #hi_addr(?lstr_1_USB_Driver+0)
STR	R8, [SP, #4]
PUSH	(R7)
PUSH	(R6)
PUSH	(R5)
PUSH	(R4)
PUSH	(R3)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #32
LDR	R8, [SP, #4]
;USB_Driver.c,138 :: 		USB_PutQueue(BufNum);
MOV	R0, R8
; BufNum end address is: 32 (R8)
BL	_USB_PutQueue+0
;USB_Driver.c,139 :: 		break;
IT	AL
BAL	L_USB_CheckIn6
;USB_Driver.c,141 :: 		case 'b':  // Set clock/calendar from data in message
L_USB_CheckIn8:
;USB_Driver.c,145 :: 		if (strlen(readbuff) == 24) {
MOVW	R0, #lo_addr(_readbuff+0)
MOVT	R0, #hi_addr(_readbuff+0)
BL	_strlen+0
CMP	R0, #24
IT	NE
BNE	L_USB_CheckIn9
;USB_Driver.c,146 :: 		USB_PutQueue("Setting date/time \r\n");
MOVW	R0, #lo_addr(?lstr2_USB_Driver+0)
MOVT	R0, #hi_addr(?lstr2_USB_Driver+0)
BL	_USB_PutQueue+0
;USB_Driver.c,147 :: 		String[2] = 0;
ADD	R2, SP, #16
STR	R2, [SP, #24]
ADDS	R1, R2, #2
MOVS	R0, #0
STRB	R0, [R1, #0]
;USB_Driver.c,149 :: 		String[0] = readbuff[2];
MOVW	R0, #lo_addr(_readbuff+2)
MOVT	R0, #hi_addr(_readbuff+2)
LDRB	R0, [R0, #0]
STRB	R0, [R2, #0]
;USB_Driver.c,150 :: 		String[1] = readbuff[3];
ADDS	R1, R2, #1
MOVW	R0, #lo_addr(_readbuff+3)
MOVT	R0, #hi_addr(_readbuff+3)
LDRB	R0, [R0, #0]
STRB	R0, [R1, #0]
;USB_Driver.c,151 :: 		ts1.yy = 2000 + atoi(String);   // Year
MOV	R0, R2
BL	_atoi+0
ADD	R1, R0, #2000
MOVW	R0, #lo_addr(_ts1+6)
MOVT	R0, #hi_addr(_ts1+6)
STRH	R1, [R0, #0]
;USB_Driver.c,153 :: 		String[0] = readbuff[5];
MOVW	R0, #lo_addr(_readbuff+5)
MOVT	R0, #hi_addr(_readbuff+5)
LDRB	R0, [R0, #0]
LDR	R2, [SP, #24]
STRB	R0, [R2, #0]
;USB_Driver.c,154 :: 		String[1] = readbuff[6];
ADDS	R1, R2, #1
MOVW	R0, #lo_addr(_readbuff+6)
MOVT	R0, #hi_addr(_readbuff+6)
LDRB	R0, [R0, #0]
STRB	R0, [R1, #0]
;USB_Driver.c,155 :: 		ts1.mo = atoi(String);          // Month
MOV	R0, R2
BL	_atoi+0
MOVW	R1, #lo_addr(_ts1+5)
MOVT	R1, #hi_addr(_ts1+5)
STRB	R0, [R1, #0]
;USB_Driver.c,157 :: 		String[0] = readbuff[8];
MOVW	R0, #lo_addr(_readbuff+8)
MOVT	R0, #hi_addr(_readbuff+8)
LDRB	R0, [R0, #0]
LDR	R2, [SP, #24]
STRB	R0, [R2, #0]
;USB_Driver.c,158 :: 		String[1] = readbuff[9];
ADDS	R1, R2, #1
MOVW	R0, #lo_addr(_readbuff+9)
MOVT	R0, #hi_addr(_readbuff+9)
LDRB	R0, [R0, #0]
STRB	R0, [R1, #0]
;USB_Driver.c,159 :: 		ts1.md = atoi(String);          // Day of month
MOV	R0, R2
BL	_atoi+0
MOVW	R1, #lo_addr(_ts1+3)
MOVT	R1, #hi_addr(_ts1+3)
STRB	R0, [R1, #0]
;USB_Driver.c,161 :: 		String[0] = readbuff[11];
MOVW	R0, #lo_addr(_readbuff+11)
MOVT	R0, #hi_addr(_readbuff+11)
LDRB	R0, [R0, #0]
LDR	R2, [SP, #24]
STRB	R0, [R2, #0]
;USB_Driver.c,162 :: 		String[1] = readbuff[12];
ADDS	R1, R2, #1
MOVW	R0, #lo_addr(_readbuff+12)
MOVT	R0, #hi_addr(_readbuff+12)
LDRB	R0, [R0, #0]
STRB	R0, [R1, #0]
;USB_Driver.c,163 :: 		DoW = atoi(String);             // Day of week
MOV	R0, R2
BL	_atoi+0
;USB_Driver.c,165 :: 		switch (DoW) {                  // Translate between Delphi7 and mikroC
IT	AL
BAL	L_USB_CheckIn10
;USB_Driver.c,166 :: 		case 1: ts1.wd = 6; break;  // Sunday
L_USB_CheckIn12:
MOVS	R1, #6
MOVW	R0, #lo_addr(_ts1+4)
MOVT	R0, #hi_addr(_ts1+4)
STRB	R1, [R0, #0]
IT	AL
BAL	L_USB_CheckIn11
;USB_Driver.c,167 :: 		case 2: ts1.wd = 0; break;  // Monday
L_USB_CheckIn13:
MOVS	R1, #0
MOVW	R0, #lo_addr(_ts1+4)
MOVT	R0, #hi_addr(_ts1+4)
STRB	R1, [R0, #0]
IT	AL
BAL	L_USB_CheckIn11
;USB_Driver.c,168 :: 		case 3: ts1.wd = 1; break;  // Tuesday
L_USB_CheckIn14:
MOVS	R1, #1
MOVW	R0, #lo_addr(_ts1+4)
MOVT	R0, #hi_addr(_ts1+4)
STRB	R1, [R0, #0]
IT	AL
BAL	L_USB_CheckIn11
;USB_Driver.c,169 :: 		case 4: ts1.wd = 2; break;  // Wednesday
L_USB_CheckIn15:
MOVS	R1, #2
MOVW	R0, #lo_addr(_ts1+4)
MOVT	R0, #hi_addr(_ts1+4)
STRB	R1, [R0, #0]
IT	AL
BAL	L_USB_CheckIn11
;USB_Driver.c,170 :: 		case 5: ts1.wd = 3; break;  // Thursday
L_USB_CheckIn16:
MOVS	R1, #3
MOVW	R0, #lo_addr(_ts1+4)
MOVT	R0, #hi_addr(_ts1+4)
STRB	R1, [R0, #0]
IT	AL
BAL	L_USB_CheckIn11
;USB_Driver.c,171 :: 		case 6: ts1.wd = 4; break;  // Friday
L_USB_CheckIn17:
MOVS	R1, #4
MOVW	R0, #lo_addr(_ts1+4)
MOVT	R0, #hi_addr(_ts1+4)
STRB	R1, [R0, #0]
IT	AL
BAL	L_USB_CheckIn11
;USB_Driver.c,172 :: 		case 7: ts1.wd = 5; break;  // Saturday
L_USB_CheckIn18:
MOVS	R1, #5
MOVW	R0, #lo_addr(_ts1+4)
MOVT	R0, #hi_addr(_ts1+4)
STRB	R1, [R0, #0]
IT	AL
BAL	L_USB_CheckIn11
;USB_Driver.c,173 :: 		}
L_USB_CheckIn10:
CMP	R0, #1
IT	EQ
BEQ	L_USB_CheckIn12
CMP	R0, #2
IT	EQ
BEQ	L_USB_CheckIn13
CMP	R0, #3
IT	EQ
BEQ	L_USB_CheckIn14
CMP	R0, #4
IT	EQ
BEQ	L_USB_CheckIn15
CMP	R0, #5
IT	EQ
BEQ	L_USB_CheckIn16
CMP	R0, #6
IT	EQ
BEQ	L_USB_CheckIn17
CMP	R0, #7
IT	EQ
BEQ	L_USB_CheckIn18
L_USB_CheckIn11:
;USB_Driver.c,175 :: 		String[0] = readbuff[14];
ADD	R2, SP, #16
STR	R2, [SP, #24]
MOVW	R0, #lo_addr(_readbuff+14)
MOVT	R0, #hi_addr(_readbuff+14)
LDRB	R0, [R0, #0]
STRB	R0, [R2, #0]
;USB_Driver.c,176 :: 		String[1] = readbuff[15];
ADDS	R1, R2, #1
MOVW	R0, #lo_addr(_readbuff+15)
MOVT	R0, #hi_addr(_readbuff+15)
LDRB	R0, [R0, #0]
STRB	R0, [R1, #0]
;USB_Driver.c,177 :: 		ts1.hh = atoi(String);          // Hours
MOV	R0, R2
BL	_atoi+0
MOVW	R1, #lo_addr(_ts1+2)
MOVT	R1, #hi_addr(_ts1+2)
STRB	R0, [R1, #0]
;USB_Driver.c,179 :: 		String[0] = readbuff[17];
MOVW	R0, #lo_addr(_readbuff+17)
MOVT	R0, #hi_addr(_readbuff+17)
LDRB	R0, [R0, #0]
LDR	R2, [SP, #24]
STRB	R0, [R2, #0]
;USB_Driver.c,180 :: 		String[1] = readbuff[18];
ADDS	R1, R2, #1
MOVW	R0, #lo_addr(_readbuff+18)
MOVT	R0, #hi_addr(_readbuff+18)
LDRB	R0, [R0, #0]
STRB	R0, [R1, #0]
;USB_Driver.c,181 :: 		ts1.mn = atoi(String);          // Minutes
MOV	R0, R2
BL	_atoi+0
MOVW	R1, #lo_addr(_ts1+1)
MOVT	R1, #hi_addr(_ts1+1)
STRB	R0, [R1, #0]
;USB_Driver.c,183 :: 		String[0] = readbuff[20];
MOVW	R0, #lo_addr(_readbuff+20)
MOVT	R0, #hi_addr(_readbuff+20)
LDRB	R0, [R0, #0]
LDR	R2, [SP, #24]
STRB	R0, [R2, #0]
;USB_Driver.c,184 :: 		String[1] = readbuff[21];
ADDS	R1, R2, #1
MOVW	R0, #lo_addr(_readbuff+21)
MOVT	R0, #hi_addr(_readbuff+21)
LDRB	R0, [R0, #0]
STRB	R0, [R1, #0]
;USB_Driver.c,185 :: 		ts1.ss = atoi(String);          // Seconds
MOV	R0, R2
BL	_atoi+0
MOVW	R1, #lo_addr(_ts1+0)
MOVT	R1, #hi_addr(_ts1+0)
STRB	R0, [R1, #0]
;USB_Driver.c,187 :: 		Epoch = Time_dateToEpoch(&ts1);
MOVW	R0, #lo_addr(_ts1+0)
MOVT	R0, #hi_addr(_ts1+0)
BL	_Time_dateToEpoch+0
MOVW	R1, #lo_addr(_Epoch+0)
MOVT	R1, #hi_addr(_Epoch+0)
STR	R0, [R1, #0]
;USB_Driver.c,188 :: 		}
IT	AL
BAL	L_USB_CheckIn19
L_USB_CheckIn9:
;USB_Driver.c,190 :: 		BufNum = GetBuffer();     // Get a free buffer
BL	_GetBuffer+0
; BufNum start address is: 12 (R3)
MOV	R3, R0
;USB_Driver.c,191 :: 		sprintf(BufNum,"Incorrect length: %d \r\n",strlen(readbuff));
STR	R3, [SP, #4]
MOVW	R0, #lo_addr(_readbuff+0)
MOVT	R0, #hi_addr(_readbuff+0)
BL	_strlen+0
LDR	R3, [SP, #4]
MOVW	R2, #lo_addr(?lstr_3_USB_Driver+0)
MOVT	R2, #hi_addr(?lstr_3_USB_Driver+0)
MOV	R1, R3
STR	R3, [SP, #4]
PUSH	(R0)
PUSH	(R2)
PUSH	(R1)
BL	_sprintf+0
ADD	SP, SP, #12
LDR	R3, [SP, #4]
;USB_Driver.c,192 :: 		USB_PutQueue(BufNum);   // Display the buffer
MOV	R0, R3
; BufNum end address is: 12 (R3)
BL	_USB_PutQueue+0
;USB_Driver.c,193 :: 		}
L_USB_CheckIn19:
;USB_Driver.c,194 :: 		break;
IT	AL
BAL	L_USB_CheckIn6
;USB_Driver.c,196 :: 		case 'c':
L_USB_CheckIn20:
;USB_Driver.c,197 :: 		WiFiPlusInit();     // Initialize
BL	_WiFiPlusInit+0
;USB_Driver.c,198 :: 		break;
IT	AL
BAL	L_USB_CheckIn6
;USB_Driver.c,199 :: 		case 'd':
L_USB_CheckIn21:
;USB_Driver.c,200 :: 		WiFiSwReset();      // Software reset
BL	_WiFiSwReset+0
;USB_Driver.c,201 :: 		break;
IT	AL
BAL	L_USB_CheckIn6
;USB_Driver.c,202 :: 		case 'e':
L_USB_CheckIn22:
;USB_Driver.c,203 :: 		WiFiPingSend();     // Send ping
BL	_WiFiPingSend+0
;USB_Driver.c,204 :: 		break;
IT	AL
BAL	L_USB_CheckIn6
;USB_Driver.c,205 :: 		case 'f':
L_USB_CheckIn23:
;USB_Driver.c,206 :: 		WiFiGetVersion();   // Get version
BL	_WiFiGetVersion+0
;USB_Driver.c,207 :: 		break;
IT	AL
BAL	L_USB_CheckIn6
;USB_Driver.c,208 :: 		case 'g':
L_USB_CheckIn24:
;USB_Driver.c,209 :: 		WiFiGetWpaKey();    // Get WPA key
BL	_WiFiGetWpaKey+0
;USB_Driver.c,210 :: 		break;
IT	AL
BAL	L_USB_CheckIn6
;USB_Driver.c,211 :: 		case 'h':
L_USB_CheckIn25:
;USB_Driver.c,212 :: 		break;
IT	AL
BAL	L_USB_CheckIn6
;USB_Driver.c,213 :: 		case 'i':
L_USB_CheckIn26:
;USB_Driver.c,214 :: 		break;
IT	AL
BAL	L_USB_CheckIn6
;USB_Driver.c,215 :: 		case 'j':
L_USB_CheckIn27:
;USB_Driver.c,216 :: 		break;
IT	AL
BAL	L_USB_CheckIn6
;USB_Driver.c,217 :: 		case 'k':
L_USB_CheckIn28:
;USB_Driver.c,218 :: 		WiFiStateFuncPtr = WiFiState80; // UDP server
MOVW	R1, #lo_addr(_WiFiState80+0)
MOVT	R1, #hi_addr(_WiFiState80+0)
MOVW	R0, #lo_addr(_WiFiStateFuncPtr+0)
MOVT	R0, #hi_addr(_WiFiStateFuncPtr+0)
STR	R1, [R0, #0]
;USB_Driver.c,219 :: 		break;
IT	AL
BAL	L_USB_CheckIn6
;USB_Driver.c,220 :: 		case 'l':
L_USB_CheckIn29:
;USB_Driver.c,221 :: 		WiFiStateFuncPtr = WiFiState74; // Receive from socket
MOVW	R1, #lo_addr(_WiFiState74+0)
MOVT	R1, #hi_addr(_WiFiState74+0)
MOVW	R0, #lo_addr(_WiFiStateFuncPtr+0)
MOVT	R0, #hi_addr(_WiFiStateFuncPtr+0)
STR	R1, [R0, #0]
;USB_Driver.c,222 :: 		break;
IT	AL
BAL	L_USB_CheckIn6
;USB_Driver.c,223 :: 		case 'm':
L_USB_CheckIn30:
;USB_Driver.c,224 :: 		break;
IT	AL
BAL	L_USB_CheckIn6
;USB_Driver.c,225 :: 		case 'n':
L_USB_CheckIn31:
;USB_Driver.c,226 :: 		break;
IT	AL
BAL	L_USB_CheckIn6
;USB_Driver.c,227 :: 		case 'o':
L_USB_CheckIn32:
;USB_Driver.c,228 :: 		break;
IT	AL
BAL	L_USB_CheckIn6
;USB_Driver.c,229 :: 		case 'p':
L_USB_CheckIn33:
;USB_Driver.c,230 :: 		break;
IT	AL
BAL	L_USB_CheckIn6
;USB_Driver.c,231 :: 		case 'q':
L_USB_CheckIn34:
;USB_Driver.c,232 :: 		break;
IT	AL
BAL	L_USB_CheckIn6
;USB_Driver.c,233 :: 		case 'r':
L_USB_CheckIn35:
;USB_Driver.c,234 :: 		WiFiStateFuncPtr = WiFiState55; // Connect a socket
MOVW	R1, #lo_addr(_WiFiState55+0)
MOVT	R1, #hi_addr(_WiFiState55+0)
MOVW	R0, #lo_addr(_WiFiStateFuncPtr+0)
MOVT	R0, #hi_addr(_WiFiStateFuncPtr+0)
STR	R1, [R0, #0]
;USB_Driver.c,235 :: 		break;
IT	AL
BAL	L_USB_CheckIn6
;USB_Driver.c,236 :: 		case 's':
L_USB_CheckIn36:
;USB_Driver.c,237 :: 		WiFiStateFuncPtr = WiFiState50; // Bind a socket
MOVW	R1, #lo_addr(_WiFiState50+0)
MOVT	R1, #hi_addr(_WiFiState50+0)
MOVW	R0, #lo_addr(_WiFiStateFuncPtr+0)
MOVT	R0, #hi_addr(_WiFiStateFuncPtr+0)
STR	R1, [R0, #0]
;USB_Driver.c,238 :: 		break;
IT	AL
BAL	L_USB_CheckIn6
;USB_Driver.c,239 :: 		case 't':
L_USB_CheckIn37:
;USB_Driver.c,240 :: 		WiFiStateFuncPtr = WiFiState45; // Close a socket
MOVW	R1, #lo_addr(_WiFiState45+0)
MOVT	R1, #hi_addr(_WiFiState45+0)
MOVW	R0, #lo_addr(_WiFiStateFuncPtr+0)
MOVT	R0, #hi_addr(_WiFiStateFuncPtr+0)
STR	R1, [R0, #0]
;USB_Driver.c,241 :: 		break;
IT	AL
BAL	L_USB_CheckIn6
;USB_Driver.c,242 :: 		case 'u':
L_USB_CheckIn38:
;USB_Driver.c,243 :: 		WiFiStateFuncPtr = WiFiState40; // Create UDP socket
MOVW	R1, #lo_addr(_WiFiState40+0)
MOVT	R1, #hi_addr(_WiFiState40+0)
MOVW	R0, #lo_addr(_WiFiStateFuncPtr+0)
MOVT	R0, #hi_addr(_WiFiStateFuncPtr+0)
STR	R1, [R0, #0]
;USB_Driver.c,244 :: 		break;
IT	AL
BAL	L_USB_CheckIn6
;USB_Driver.c,245 :: 		case 'v':
L_USB_CheckIn39:
;USB_Driver.c,246 :: 		WiFiStateFuncPtr = WiFiState35; // Disconnect from access point
MOVW	R1, #lo_addr(_WiFiState35+0)
MOVT	R1, #hi_addr(_WiFiState35+0)
MOVW	R0, #lo_addr(_WiFiStateFuncPtr+0)
MOVT	R0, #hi_addr(_WiFiStateFuncPtr+0)
STR	R1, [R0, #0]
;USB_Driver.c,247 :: 		break;
IT	AL
BAL	L_USB_CheckIn6
;USB_Driver.c,248 :: 		case 'w':
L_USB_CheckIn40:
;USB_Driver.c,249 :: 		WiFiStateFuncPtr = WiFiState30; // Connect to access point
MOVW	R1, #lo_addr(_WiFiState30+0)
MOVT	R1, #hi_addr(_WiFiState30+0)
MOVW	R0, #lo_addr(_WiFiStateFuncPtr+0)
MOVT	R0, #hi_addr(_WiFiStateFuncPtr+0)
STR	R1, [R0, #0]
;USB_Driver.c,250 :: 		break;
IT	AL
BAL	L_USB_CheckIn6
;USB_Driver.c,251 :: 		case 'x':
L_USB_CheckIn41:
;USB_Driver.c,252 :: 		WiFiStateFuncPtr = WiFiState15; // Set Wi-Fi parameters
MOVW	R1, #lo_addr(_WiFiState15+0)
MOVT	R1, #hi_addr(_WiFiState15+0)
MOVW	R0, #lo_addr(_WiFiStateFuncPtr+0)
MOVT	R0, #hi_addr(_WiFiStateFuncPtr+0)
STR	R1, [R0, #0]
;USB_Driver.c,253 :: 		break;
IT	AL
BAL	L_USB_CheckIn6
;USB_Driver.c,254 :: 		case 'y':
L_USB_CheckIn42:
;USB_Driver.c,255 :: 		WiFiStateFuncPtr = WiFiState4;  // Scan for access points
MOVW	R1, #lo_addr(_WiFiState4+0)
MOVT	R1, #hi_addr(_WiFiState4+0)
MOVW	R0, #lo_addr(_WiFiStateFuncPtr+0)
MOVT	R0, #hi_addr(_WiFiStateFuncPtr+0)
STR	R1, [R0, #0]
;USB_Driver.c,256 :: 		break;
IT	AL
BAL	L_USB_CheckIn6
;USB_Driver.c,257 :: 		case 'z':
L_USB_CheckIn43:
;USB_Driver.c,258 :: 		WiFiStateFuncPtr = WiFiState1;  // Get network status
MOVW	R1, #lo_addr(_WiFiState1+0)
MOVT	R1, #hi_addr(_WiFiState1+0)
MOVW	R0, #lo_addr(_WiFiStateFuncPtr+0)
MOVT	R0, #hi_addr(_WiFiStateFuncPtr+0)
STR	R1, [R0, #0]
;USB_Driver.c,259 :: 		break;
IT	AL
BAL	L_USB_CheckIn6
;USB_Driver.c,266 :: 		default:
L_USB_CheckIn44:
;USB_Driver.c,267 :: 		USB_PutQueue("Unknown command\r\n");
MOVW	R0, #lo_addr(?lstr4_USB_Driver+0)
MOVT	R0, #hi_addr(?lstr4_USB_Driver+0)
BL	_USB_PutQueue+0
;USB_Driver.c,269 :: 		BufNum = GetBuffer();         // Get a free buffer
BL	_GetBuffer+0
; BufNum start address is: 12 (R3)
MOV	R3, R0
;USB_Driver.c,270 :: 		(void)sprintf(BufNum,"%c\r\n",readbuff[0]);
MOVW	R1, #lo_addr(_readbuff+0)
MOVT	R1, #hi_addr(_readbuff+0)
LDRB	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_5_USB_Driver+0)
MOVT	R1, #hi_addr(?lstr_5_USB_Driver+0)
STR	R3, [SP, #4]
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
LDR	R3, [SP, #4]
;USB_Driver.c,271 :: 		USB_PutQueue(BufNum);
MOV	R0, R3
; BufNum end address is: 12 (R3)
BL	_USB_PutQueue+0
;USB_Driver.c,272 :: 		break;
IT	AL
BAL	L_USB_CheckIn6
;USB_Driver.c,273 :: 		}
L_USB_CheckIn5:
MOVW	R0, #lo_addr(_readbuff+0)
MOVT	R0, #hi_addr(_readbuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #97
IT	EQ
BEQ	L_USB_CheckIn7
MOVW	R0, #lo_addr(_readbuff+0)
MOVT	R0, #hi_addr(_readbuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #98
IT	EQ
BEQ	L_USB_CheckIn8
MOVW	R0, #lo_addr(_readbuff+0)
MOVT	R0, #hi_addr(_readbuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #99
IT	EQ
BEQ	L_USB_CheckIn20
MOVW	R0, #lo_addr(_readbuff+0)
MOVT	R0, #hi_addr(_readbuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #100
IT	EQ
BEQ	L_USB_CheckIn21
MOVW	R0, #lo_addr(_readbuff+0)
MOVT	R0, #hi_addr(_readbuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #101
IT	EQ
BEQ	L_USB_CheckIn22
MOVW	R0, #lo_addr(_readbuff+0)
MOVT	R0, #hi_addr(_readbuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #102
IT	EQ
BEQ	L_USB_CheckIn23
MOVW	R0, #lo_addr(_readbuff+0)
MOVT	R0, #hi_addr(_readbuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #103
IT	EQ
BEQ	L_USB_CheckIn24
MOVW	R0, #lo_addr(_readbuff+0)
MOVT	R0, #hi_addr(_readbuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #104
IT	EQ
BEQ	L_USB_CheckIn25
MOVW	R0, #lo_addr(_readbuff+0)
MOVT	R0, #hi_addr(_readbuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #105
IT	EQ
BEQ	L_USB_CheckIn26
MOVW	R0, #lo_addr(_readbuff+0)
MOVT	R0, #hi_addr(_readbuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #106
IT	EQ
BEQ	L_USB_CheckIn27
MOVW	R0, #lo_addr(_readbuff+0)
MOVT	R0, #hi_addr(_readbuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #107
IT	EQ
BEQ	L_USB_CheckIn28
MOVW	R0, #lo_addr(_readbuff+0)
MOVT	R0, #hi_addr(_readbuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #108
IT	EQ
BEQ	L_USB_CheckIn29
MOVW	R0, #lo_addr(_readbuff+0)
MOVT	R0, #hi_addr(_readbuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #109
IT	EQ
BEQ	L_USB_CheckIn30
MOVW	R0, #lo_addr(_readbuff+0)
MOVT	R0, #hi_addr(_readbuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #110
IT	EQ
BEQ	L_USB_CheckIn31
MOVW	R0, #lo_addr(_readbuff+0)
MOVT	R0, #hi_addr(_readbuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #111
IT	EQ
BEQ	L_USB_CheckIn32
MOVW	R0, #lo_addr(_readbuff+0)
MOVT	R0, #hi_addr(_readbuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #112
IT	EQ
BEQ	L_USB_CheckIn33
MOVW	R0, #lo_addr(_readbuff+0)
MOVT	R0, #hi_addr(_readbuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #113
IT	EQ
BEQ	L_USB_CheckIn34
MOVW	R0, #lo_addr(_readbuff+0)
MOVT	R0, #hi_addr(_readbuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #114
IT	EQ
BEQ	L_USB_CheckIn35
MOVW	R0, #lo_addr(_readbuff+0)
MOVT	R0, #hi_addr(_readbuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #115
IT	EQ
BEQ	L_USB_CheckIn36
MOVW	R0, #lo_addr(_readbuff+0)
MOVT	R0, #hi_addr(_readbuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #116
IT	EQ
BEQ	L_USB_CheckIn37
MOVW	R0, #lo_addr(_readbuff+0)
MOVT	R0, #hi_addr(_readbuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #117
IT	EQ
BEQ	L_USB_CheckIn38
MOVW	R0, #lo_addr(_readbuff+0)
MOVT	R0, #hi_addr(_readbuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #118
IT	EQ
BEQ	L_USB_CheckIn39
MOVW	R0, #lo_addr(_readbuff+0)
MOVT	R0, #hi_addr(_readbuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #119
IT	EQ
BEQ	L_USB_CheckIn40
MOVW	R0, #lo_addr(_readbuff+0)
MOVT	R0, #hi_addr(_readbuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #120
IT	EQ
BEQ	L_USB_CheckIn41
MOVW	R0, #lo_addr(_readbuff+0)
MOVT	R0, #hi_addr(_readbuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #121
IT	EQ
BEQ	L_USB_CheckIn42
MOVW	R0, #lo_addr(_readbuff+0)
MOVT	R0, #hi_addr(_readbuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #122
IT	EQ
BEQ	L_USB_CheckIn43
IT	AL
BAL	L_USB_CheckIn44
L_USB_CheckIn6:
;USB_Driver.c,274 :: 		}
L_USB_CheckIn4:
;USB_Driver.c,275 :: 		}
L_end_USB_CheckIn:
LDR	LR, [SP, #0]
ADD	SP, SP, #28
BX	LR
; end of _USB_CheckIn
