#line 1 "C:/Users/Public/Projects/ARM/Projects/WiFiClick/WiFiTEst_Code/mikroC PRO for ARM/WiFiPlus.c"
#line 1 "c:/users/public/projects/arm/projects/wificlick/wifitest_code/mikroc pro for arm/wifiplus.h"
#line 22 "c:/users/public/projects/arm/projects/wificlick/wifitest_code/mikroc pro for arm/wifiplus.h"
typedef struct {
 char MACAddress[6];
 char IPAddress[4];
 char NetworkMask[4];
 char GatewayAddress[4];
 char NetworkStatus;
} WiFi_Properties;

typedef struct {

 char ConStatChng;
 char ScnRsltRdy;
 char IPAddrAss;
 char PingResp;
 char StartUp;
 char Error;
 char Unknown;

 char ScnRsltMsg;
 char SockCreaResp;
 char SockBindResp;
 char SockConnResp;
 char SockListenResp;
 char SockAccptResp;
 char SockSendResp;
 char SockRcvResp;
 char SockSendToResp;
 char SockRcvFromResp;
 char SockAllocResp;
 char NetStatResp;
 char WpaKeyResp;
 char GpioResp;
} WiFi_Events;


typedef struct {
 char BSSID[6];
 char SSIDLength;
 char SSID[32];
 char APConfig;
#line 78 "c:/users/public/projects/arm/projects/wificlick/wifitest_code/mikroc pro for arm/wifiplus.h"
 int beaconPeriod;
 int ATIMWindow;
 char basicRates[8];
#line 86 "c:/users/public/projects/arm/projects/wificlick/wifitest_code/mikroc pro for arm/wifiplus.h"
 char RSSI;
 char basicRatesListLength;
 char DTIMPeriod;
 char BSSType;
 char Channel;
} WiFi_ScanResult;



void WiFiPlusInit(void);
void WiFiPlusHwReset(void);
void WiFiSwReset(void);
void WiFiSetIpAddr(void);
void WiFiSetNetworkMask(void);
void WiFiSetGatewayAddr(void);
void WiFiSetMacAddr(void);
void WiFiSetArpTime(void);
void WiFiSetNetworkMode(void);
void WiFiSetCpSsid(void);
void WiFiSetRegionalDomain(void);
void WiFiSetChannelList(void);
void WiFiSetListRetryCount(void);
void WiFiSetSecurityWpa(void);
void WiFiSetSecurityWpaBinary(void);
void WiFiScanStart(void);
void WiFiConnect(void);
void WiFiDisconnect(void);
void WiFiPingSend(void);

void WiFiSocketCreate(char SocType);
void WiFiSocketClose(char Handle);
void WiFiSocketBind(char Handle, unsigned int LocalPort);
void WiFiSocketConnect(char Handle);
void WiFiSocketListen(char Handle);
void WiFiSocketAccept(char Handle);
void WiFiSocketSend(char Handle, unsigned short *Data);
void WiFiSocketReceive(char Handle, unsigned int DataLength);
void WiFiSocketSendTo(char Handle, char *Data);
void WiFiSocketReceiveFrom(char Handle, unsigned int DataLength);


void WiFiGetVersion(void);
void WiFiGetNetworkStatus(void);
void WiFiGetWpaKey(void);
void WiFiScanGetResult(unsigned short int Index);



void WiFiApp(void);
void WiFiState0(void);


void WiFiState1(void);
void WiFiState2(void);


void WiFiState4(void);
void WiFiState5(void);
void WiFiState6(void);
void WiFiState7(void);
void WiFiState8(void);
void WiFiState9(void);
void WiFiState10(void);


void WiFiState15(void);
void WiFiState16(void);
void WiFiState17(void);
void WiFiState18(void);
void WiFiState19(void);
void WiFiState20(void);
void WiFiState21(void);
void WiFiState22(void);
void WiFiState23(void);
void WiFiState24(void);
void WiFiState25(void);

void WiFiState30(void);
void WiFiState31(void);

void WiFiState35(void);
void WiFiState36(void);

void WiFiState40(void);
void WiFiState41(void);

void WiFiState45(void);
void WiFiState46(void);

void WiFiState50(void);
void WiFiState51(void);

void WiFiState55(void);
void WiFiState56(void);

void WiFiState60(void);
void WiFiState61(void);

void WiFiState65(void);
void WiFiState66(void);

void WiFiState67(void);
void WiFiState68(void);

void WiFiState70(void);
void WiFiState71(void);

void WiFiState74(void);
void WiFiState75(void);

void WiFiState80(void);
void WiFiState81(void);
void WiFiState82(void);

void WiFiState90(void);
void WiFiState91(void);
void WiFiState92(void);
void WiFiState93(void);
void WiFiState94(void);
void WiFiState95(void);
void WiFiState96(void);
void WiFiState97(void);

void WiFiState100(void);
void WiFiState101(void);
void WiFiState102(void);
void WiFiState103(void);
void WiFiState104(void);
void WiFiState105(void);
void WiFiState106(void);
void WiFiState107(void);
void WiFiState108(void);
void WiFiState109(void);
void WiFiState110(void);
void WiFiState111(void);
void WiFiState112(void);
void WiFiState113(void);

void WiFiState120(void);
void WiFiState121(void);
void WiFiState122(void);
void WiFiState123(void);
void WiFiState124(void);

void WiFiState130(void);
void WiFiState131(void);
void WiFiState132(void);
void WiFiState133(void);


void WiFiState666(void);

void TimeoutCheck(unsigned int TimeoutState);



void ClearAllLabels(void);
void UpdateLabel4(char *msg);
void UpdateLabel5(char *msg);
void UpdateLabel6(char *msg);
void UpdateLabel7(char *msg);
void UpdateLabel8(char *msg);
void UpdateLabel9(char *msg);
void UpdateLabel10(char *msg);
void UpdateLabel11(char *msg);
void UpdateLabel12(char *msg);
void UpdateLabel13(char *msg);
void UpdateLabel14(char *msg);
void UpdateLabel15(char *msg);
void UpdateLabel16(char *msg);
void UpdateLabel17(char *msg);
void UpdateLabel18(char *msg);
void UpdateLabel19(char *msg, unsigned int Color);

void EnableButton2(void);
void EnableButton3(void);
void EnableButton4(void);

void EraseButton2(void);
void EraseButton3(void);
void EraseButton4(void);
#line 1 "c:/users/public/projects/arm/projects/wificlick/wifitest_code/mikroc pro for arm/buffers.h"
#line 13 "c:/users/public/projects/arm/projects/wificlick/wifitest_code/mikroc pro for arm/buffers.h"
char* GetBuffer(void);
#line 1 "c:/users/public/projects/arm/projects/wificlick/wifitest_code/mikroc pro for arm/common.h"
#line 1 "c:/users/public/projects/arm/projects/wificlick/wifitest_code/mikroc pro for arm/uart0.h"
#line 20 "c:/users/public/projects/arm/projects/wificlick/wifitest_code/mikroc pro for arm/uart0.h"
typedef void (*tPointerFcn)(void);





void UART0Init(void);
void UART0_Initialize(void);
void UART0_RxQueueInit(void);
void UART0_Receive_Char(void);
char UART0_GetChar(char *rxbyte);

void UART0_Rx(void);
void UART0_Rx1(void);
void UART0_Rx2(void);


void UART0_TxQueueInit(void);
void UART0_PutQueue(char *msg, unsigned int msgsize);

void UART0_Tx(void);
void UART0_Tx1(void);
void UART0_Tx2(void);
#line 1 "c:/users/public/projects/arm/projects/wificlick/wifitest_code/mikroc pro for arm/usb_driver.h"
#line 11 "c:/users/public/projects/arm/projects/wificlick/wifitest_code/mikroc pro for arm/usb_driver.h"
typedef char *pnt;


typedef struct tx_q0_struct {
 unsigned int in;
 unsigned int out;
 pnt q[ 32 ];
}tx_q0_struct;



void USB_Init(void);
void USB_TxQueueInit(void);
void USB_PutQueue(char *msg);
void USB_CheckOut(void);
void USB_CheckIn(void);
#line 1 "c:/users/public/projects/arm/projects/wificlick/wifitest_code/mikroc pro for arm/timer0.h"
#line 9 "c:/users/public/projects/arm/projects/wificlick/wifitest_code/mikroc pro for arm/timer0.h"
void TimerInit();
void TimerCheck();
#line 31 "c:/users/public/projects/arm/projects/wificlick/wifitest_code/mikroc pro for arm/timer0.h"
struct timers {
 unsigned long int TimerField;
 unsigned short int Free;
};
#line 43 "c:/users/public/projects/arm/projects/wificlick/wifitest_code/mikroc pro for arm/timer0.h"
void init_timerpool(void);
#line 52 "c:/users/public/projects/arm/projects/wificlick/wifitest_code/mikroc pro for arm/timer0.h"
unsigned short int get_timer(void);
#line 61 "c:/users/public/projects/arm/projects/wificlick/wifitest_code/mikroc pro for arm/timer0.h"
void free_timer(unsigned short int nbr);
#line 71 "c:/users/public/projects/arm/projects/wificlick/wifitest_code/mikroc pro for arm/timer0.h"
void set_timer(unsigned short int nbr, unsigned long int tout);
#line 80 "c:/users/public/projects/arm/projects/wificlick/wifitest_code/mikroc pro for arm/timer0.h"
unsigned long int check_timer(unsigned short int nbr);
#line 89 "c:/users/public/projects/arm/projects/wificlick/wifitest_code/mikroc pro for arm/timer0.h"
void irqhandler_timer(void);
#line 1 "c:/users/public/projects/arm/projects/wificlick/wifitest_code/mikroc pro for arm/wifitest_objects.h"
typedef enum {_taLeft, _taCenter, _taRight} TTextAlign;

typedef struct Screen TScreen;

typedef struct Button_Round {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 char Pen_Width;
 unsigned int Pen_Color;
 char Visible;
 char Active;
 char Transparent;
 char *Caption;
 TTextAlign TextAlign;
 const char *FontName;
 unsigned int Font_Color;
 char Gradient;
 char Gradient_Orientation;
 unsigned int Gradient_Start_Color;
 unsigned int Gradient_End_Color;
 unsigned int Color;
 char Corner_Radius;
 char PressColEnabled;
 unsigned int Press_Color;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TButton_Round;

typedef struct Label {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 char *Caption;
 const char *FontName;
 unsigned int Font_Color;
 char Visible;
 char Active;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TLabel;

typedef struct Image {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 const char *Picture_Name;
 char Visible;
 char Active;
 char Picture_Type;
 char Picture_Ratio;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TImage;

typedef struct Box {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 char Pen_Width;
 unsigned int Pen_Color;
 char Visible;
 char Active;
 char Transparent;
 char Gradient;
 char Gradient_Orientation;
 unsigned int Gradient_Start_Color;
 unsigned int Gradient_End_Color;
 unsigned int Color;
 char PressColEnabled;
 unsigned int Press_Color;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TBox;

typedef struct Box_Round {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 char Pen_Width;
 unsigned int Pen_Color;
 char Visible;
 char Active;
 char Transparent;
 char Gradient;
 char Gradient_Orientation;
 unsigned int Gradient_Start_Color;
 unsigned int Gradient_End_Color;
 unsigned int Color;
 char Corner_Radius;
 char PressColEnabled;
 unsigned int Press_Color;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TBox_Round;

typedef struct Line {
 TScreen* OwnerScreen;
 char Order;
 unsigned int First_Point_X;
 unsigned int First_Point_Y;
 unsigned int Second_Point_X;
 unsigned int Second_Point_Y;
 char Pen_Width;
 char Visible;
 unsigned int Color;
} TLine;

struct Screen {
 unsigned int Color;
 unsigned int Width;
 unsigned int Height;
 unsigned int ObjectsCount;
 unsigned int Buttons_RoundCount;
 TButton_Round * const code *Buttons_Round;
 unsigned int LabelsCount;
 TLabel * const code *Labels;
 unsigned int ImagesCount;
 TImage * const code *Images;
 unsigned int BoxesCount;
 TBox * const code *Boxes;
 unsigned int Boxes_RoundCount;
 TBox_Round * const code *Boxes_Round;
 unsigned int LinesCount;
 TLine * const code *Lines;
};

extern TScreen Screen1;
extern TImage Image1;
extern TBox Box1;
extern TLabel Label1;
extern TLabel Label2;
extern TLabel Label3;
extern TLine Line1;
extern TLabel Label5;
extern TLabel Label6;
extern TLabel Label7;
extern TLabel Label8;
extern TLabel Label9;
extern TLabel Label10;
extern TLabel Label11;
extern TLabel Label12;
extern TLabel Label13;
extern TLabel Label14;
extern TLabel Label15;
extern TLabel Label16;
extern TLabel Label17;
extern TLabel Label18;
extern TLabel Label4;
extern TLabel Label19;
extern TButton_Round ButtonRound1;
extern TButton_Round ButtonRound2;
extern TButton_Round ButtonRound3;
extern TButton_Round ButtonRound4;
extern TButton_Round * const code Screen1_Buttons_Round[4];
extern TLabel * const code Screen1_Labels[19];
extern TImage * const code Screen1_Images[1];
extern TBox * const code Screen1_Boxes[1];
extern TLine * const code Screen1_Lines[1];


extern TScreen Screen2;
extern TBox_Round Qwerty_BoxRound1;
extern TButton_Round Qwerty_ButtonRound1;
extern TButton_Round Qwerty_ButtonRound2;
extern TButton_Round Qwerty_ButtonRound3;
extern TButton_Round Qwerty_ButtonRound4;
extern TButton_Round Qwerty_ButtonRound5;
extern TButton_Round Qwerty_ButtonRound6;
extern TButton_Round Qwerty_ButtonRound7;
extern TButton_Round Qwerty_ButtonRound8;
extern TButton_Round Qwerty_ButtonRound9;
extern TButton_Round Qwerty_ButtonRound10;
extern TButton_Round Qwerty_ButtonRound11;
extern TButton_Round Qwerty_ButtonRound12;
extern TButton_Round Qwerty_ButtonRound13;
extern TButton_Round Qwerty_ButtonRound14;
extern TButton_Round Qwerty_ButtonRound15;
extern TButton_Round Qwerty_ButtonRound16;
extern TButton_Round Qwerty_ButtonRound17;
extern TButton_Round Qwerty_ButtonRound18;
extern TButton_Round Qwerty_ButtonRound19;
extern TButton_Round Qwerty_ButtonRound20;
extern TButton_Round Qwerty_ButtonRound21;
extern TButton_Round Qwerty_ButtonRound22;
extern TButton_Round Qwerty_ButtonRound23;
extern TButton_Round Qwerty_ButtonRound24;
extern TButton_Round Qwerty_ButtonRound25;
extern TButton_Round Qwerty_ButtonRound26;
extern TButton_Round Qwerty_ButtonRound27;
extern TButton_Round Qwerty_ButtonRound28;
extern TButton_Round Qwerty_ButtonRound29;
extern TButton_Round Qwerty_ButtonRound30;
extern TButton_Round Qwerty_ButtonRound31;
extern TButton_Round Qwerty_ButtonRound32;
extern TButton_Round Qwerty_ButtonRound33;
extern TButton_Round Qwerty_ButtonRound34;
extern TButton_Round Qwerty_ButtonRound35;
extern TButton_Round Qwerty_ButtonRound36;
extern TButton_Round Qwerty_ButtonRound37;
extern TButton_Round Qwerty_ButtonRound38;
extern TButton_Round Qwerty_ButtonRound39;
extern TButton_Round Qwerty_ButtonRound40;
extern TButton_Round Qwerty_ButtonRound41;
extern TButton_Round Qwerty_ButtonRound42;
extern TButton_Round Qwerty_ButtonRound43;
extern TButton_Round Qwerty_ButtonRound44;
extern TLabel Qwerty_Label1;
extern TLabel Qwerty_Label2;
extern TButton_Round * const code Screen2_Buttons_Round[44];
extern TLabel * const code Screen2_Labels[2];
extern TBox_Round * const code Screen2_Boxes_Round[1];





void ButtonRound1OnClick();
void ButtonRound2OnClick();
void ButtonRound3OnClick();
void ButtonRound4OnClick();
void Label10OnClick();
void Label13OnClick();
void Label16OnClick();
void Label4OnClick();
void Label7OnClick();
void Qwerty_ButtonRound10OnClick();
void Qwerty_ButtonRound11OnClick();
void Qwerty_ButtonRound12OnClick();
void Qwerty_ButtonRound13OnClick();
void Qwerty_ButtonRound14OnClick();
void Qwerty_ButtonRound15OnClick();
void Qwerty_ButtonRound16OnClick();
void Qwerty_ButtonRound17OnClick();
void Qwerty_ButtonRound18OnClick();
void Qwerty_ButtonRound19OnClick();
void Qwerty_ButtonRound1OnClick();
void Qwerty_ButtonRound20OnClick();
void Qwerty_ButtonRound21OnClick();
void Qwerty_ButtonRound22OnClick();
void Qwerty_ButtonRound23OnClick();
void Qwerty_ButtonRound24OnClick();
void Qwerty_ButtonRound25OnClick();
void Qwerty_ButtonRound26OnClick();
void Qwerty_ButtonRound27OnClick();
void Qwerty_ButtonRound28OnClick();
void Qwerty_ButtonRound29OnClick();
void Qwerty_ButtonRound2OnClick();
void Qwerty_ButtonRound30OnClick();
void Qwerty_ButtonRound31OnClick();
void Qwerty_ButtonRound32OnClick();
void Qwerty_ButtonRound33OnClick();
void Qwerty_ButtonRound34OnClick();
void Qwerty_ButtonRound35OnClick();
void Qwerty_ButtonRound36OnClick();
void Qwerty_ButtonRound37OnClick();
void Qwerty_ButtonRound38OnClick();
void Qwerty_ButtonRound39OnClick();
void Qwerty_ButtonRound3OnClick();
void Qwerty_ButtonRound40OnClick();
void Qwerty_ButtonRound41OnClick();
void Qwerty_ButtonRound42OnClick();
void Qwerty_ButtonRound43OnClick();
void Qwerty_ButtonRound44OnClick();
void Qwerty_ButtonRound4OnClick();
void Qwerty_ButtonRound5OnClick();
void Qwerty_ButtonRound6OnClick();
void Qwerty_ButtonRound7OnClick();
void Qwerty_ButtonRound8OnClick();
void Qwerty_ButtonRound9OnClick();




extern char Image1_Caption[];
extern char Box1_Caption[];
extern char Label1_Caption[];
extern char Label2_Caption[];
extern char Label3_Caption[];
extern char Line1_Caption[];
extern char Label5_Caption[];
extern char Label6_Caption[];
extern char Label7_Caption[];
extern char Label8_Caption[];
extern char Label9_Caption[];
extern char Label10_Caption[];
extern char Label11_Caption[];
extern char Label12_Caption[];
extern char Label13_Caption[];
extern char Label14_Caption[];
extern char Label15_Caption[];
extern char Label16_Caption[];
extern char Label17_Caption[];
extern char Label18_Caption[];
extern char Label4_Caption[];
extern char Label19_Caption[];
extern char ButtonRound1_Caption[];
extern char ButtonRound2_Caption[];
extern char ButtonRound3_Caption[];
extern char ButtonRound4_Caption[];
extern char Qwerty_BoxRound1_Caption[];
extern char Qwerty_ButtonRound1_Caption[];
extern char Qwerty_ButtonRound2_Caption[];
extern char Qwerty_ButtonRound3_Caption[];
extern char Qwerty_ButtonRound4_Caption[];
extern char Qwerty_ButtonRound5_Caption[];
extern char Qwerty_ButtonRound6_Caption[];
extern char Qwerty_ButtonRound7_Caption[];
extern char Qwerty_ButtonRound8_Caption[];
extern char Qwerty_ButtonRound9_Caption[];
extern char Qwerty_ButtonRound10_Caption[];
extern char Qwerty_ButtonRound11_Caption[];
extern char Qwerty_ButtonRound12_Caption[];
extern char Qwerty_ButtonRound13_Caption[];
extern char Qwerty_ButtonRound14_Caption[];
extern char Qwerty_ButtonRound15_Caption[];
extern char Qwerty_ButtonRound16_Caption[];
extern char Qwerty_ButtonRound17_Caption[];
extern char Qwerty_ButtonRound18_Caption[];
extern char Qwerty_ButtonRound19_Caption[];
extern char Qwerty_ButtonRound20_Caption[];
extern char Qwerty_ButtonRound21_Caption[];
extern char Qwerty_ButtonRound22_Caption[];
extern char Qwerty_ButtonRound23_Caption[];
extern char Qwerty_ButtonRound24_Caption[];
extern char Qwerty_ButtonRound25_Caption[];
extern char Qwerty_ButtonRound26_Caption[];
extern char Qwerty_ButtonRound27_Caption[];
extern char Qwerty_ButtonRound28_Caption[];
extern char Qwerty_ButtonRound29_Caption[];
extern char Qwerty_ButtonRound30_Caption[];
extern char Qwerty_ButtonRound31_Caption[];
extern char Qwerty_ButtonRound32_Caption[];
extern char Qwerty_ButtonRound33_Caption[];
extern char Qwerty_ButtonRound34_Caption[];
extern char Qwerty_ButtonRound35_Caption[];
extern char Qwerty_ButtonRound36_Caption[];
extern char Qwerty_ButtonRound37_Caption[];
extern char Qwerty_ButtonRound38_Caption[];
extern char Qwerty_ButtonRound39_Caption[];
extern char Qwerty_ButtonRound40_Caption[];
extern char Qwerty_ButtonRound41_Caption[];
extern char Qwerty_ButtonRound42_Caption[];
extern char Qwerty_ButtonRound43_Caption[];
extern char Qwerty_ButtonRound44_Caption[];
extern char Qwerty_Label1_Caption[];
extern char Qwerty_Label2_Caption[];


void DrawScreen(TScreen *aScreen);
void DrawRoundButton(TButton_Round *Around_button);
void DrawLabel(TLabel *ALabel);
void DrawImage(TImage *AImage);
void DrawBox(TBox *ABox);
void DrawRoundBox(TBox_Round *Around_box);
void DrawLine(TLine *Aline);
void Check_TP();
void Start_TP();
#line 1 "c:/users/public/projects/arm/projects/wificlick/wifitest_code/mikroc pro for arm/wifitest_resources.h"
const code char Tahoma11x13_Regular[];
const code char Tahoma13x13_Bold[];
const code char wireless_bmp[4614];
#line 24 "C:/Users/Public/Projects/ARM/Projects/WiFiClick/WiFiTEst_Code/mikroC PRO for ARM/WiFiPlus.c"
char myIpAdd[4] = {0,0,0,0};
char myNetMask[4] = {0,0,0,0};
char gatewayAdd[4] = {0,0,0,0};
#line 32 "C:/Users/Public/Projects/ARM/Projects/WiFiClick/WiFiTEst_Code/mikroC PRO for ARM/WiFiPlus.c"
char myMacAdd[6] = {0x00,0x14,0xA5,0x76,0x19,0x3F};
char myProfileID = 1;
char mySSID[32] = "MySSID";
char myPassword[20] = "MyPassword";
char myAP_Key[32];


char UDP_RemoteHandle;
char UDP_RemoteIP[4] = {10,0,1,3};
unsigned int UDP_RemPort;
unsigned int UDP_LocPort = 6060;
unsigned int UDP_RemByteCount;
char UDP_Buf[128];

char TCP_ServerSocketCount = 0;
char TCP_ClientSocketCount = 0;
unsigned int TCP_ServerRcvBufSize = 0;
unsigned int TCP_ServerXmtBufSize = 0;
unsigned int TCP_ClientRcvBufSize = 0;
unsigned int TCP_ClientXmtBufSize = 0;


unsigned short int WiFiTimerHandle;
unsigned short int NumScanRslts;
unsigned short int SocketHandle;
unsigned short int HandleValid =  0 ;
unsigned short int BindResult;
unsigned short int ConnectResult;
unsigned short int BacklogCount;
unsigned short int ConnectStatus;


tPointerFcn WiFiStateFuncPtr = WiFiState0;
WiFi_Properties WiFiParam;
WiFi_Events WiFiEvents;

char AssignedIP[4];
char ErrorType[2];
char DataBuffer[128];
char CurrentSSID[32];
char Config[8];
char ChanNumStr[8];
unsigned short int ScanIndex;
unsigned short int BlinkTimer;

extern char ACK_Received;


char DIY_MSG[528];



char RESET_MSG[7] = {0x55,0xAA,0xAA,0x00,0x00,0x00,0x45};
char GPIO_MSG[9] = {0x55,0xAA,0xAC,0x00,0x02,0x00,0x01,0x02,0x45};



const code char GET_VERSION_MSG[7] = {0x55,0xAA,0x17,0x00,0x00,0x00,0x45};





const code char SET_IP_ADDRESS_MSG[25] = {0x55,0xAA,0x29,0x00,0x12,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x45};
#line 101 "C:/Users/Public/Projects/ARM/Projects/WiFiClick/WiFiTEst_Code/mikroC PRO for ARM/WiFiPlus.c"
const code char SET_NETWORK_MASK_MSG[23] = {0x55,0xAA,0x2A,0x00,0x10,0x00,0xFF,0xFF,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x45};

const code char SET_GATEWAY_IP_ADDRESS_MSG[23] = {0x55,0xAA,0x2C,0x00,0x10,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x45};

const code char SET_MACADDRESS_MSG[13] = {0x55,0xAA,0x31,0x00,0x06,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x45};

const code char SET_ARP_TIME_MSG[9] = {0x55,0xAA,0xAD,0x00,0x02,0x00,0x1E,0x00,0x45};

const code char GET_NETWORK_STATUS[7] = {0x55,0xAA,0x30,0x00,0x00,0x00,0x45};




const code char SET_CP_NETWORK_MODE_MSG[9] = {0x55,0xAA,0x37,0x00,0x02,0x00,0x01,0x01,0x45};

const code char SET_CP_SSID_MSG[29] = {0x55,0xAA,0x39,0x00,0x16,0x00,0x01,0x14,0x4A,0x65,0x61,0x6E,0x27,0x73,0x20,0x57,0x69,0x2D,0x46,0x69,0x20,0x4E,0x65,0x74,0x77,0x6F,0x72,0x6B,0x45};

const code char SET_REGIONAL_DOMAIN_MSG[9] = {0x55,0xAA,0x38,0x00,0x02,0x00,0x01,0x00,0x45};

const code char SET_CHANNEL_LIST_MSG[20] = {0x55,0xAA,0x3A,0x00,0x0D,0x00,0x0B,0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,0x08,0x09,0x0A,0x0B,0x45};

const code char SET_LIST_RETRY_COUNT_MSG[9] = {0x55,0xAA,0x3B,0x00,0x02,0x00,0x05,0x05,0x45};
#line 141 "C:/Users/Public/Projects/ARM/Projects/WiFiClick/WiFiTEst_Code/mikroC PRO for ARM/WiFiPlus.c"
const code char SET_CP_SECURITY_WPA_MSG[21] = {0x55,0xAA,0x44,0x00,0x0E,0x00,0x01,0x06,0x00,0x0A,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x45};

const code char SET_CP_SECURITY_WPA_MSG_BINARY[43] = {0x55,0xAA,0x44,0x00,0x24,0x00,0x01,0x05,0x00,0x20,0xD6,0x19,0x23,0x50,0xD2,0x26,0xF2,0x06,

 0x12,0x85,0x8B,0x47,0x17,0x35,0x07,0x06,0x68,0x07,0x6A,0xED,0xBF,0xC6,0xEA,0xD0,0x7E,0x3B,0x47,0x4A,0xE0,0x3F,0xE9,0x09,0x45};








const code char GET_CP_WPAKEY_MSG[9] = {0x55,0xAA,0x47,0x00,0x02,0x00,0x01,0x00,0x45};



const code char SCAN_START_MSG[9] = {0x55,0xAA,0x50,0x00,0x02,0x00,0xFF,0x00,0x45};

const code char SCAN_GET_RESULTS_MSG[9] = {0x55,0xAA,0x51,0x00,0x02,0x00,0x00,0x00,0x45};



const code char WIFI_CONNECT_MSG[9] = {0x55,0xAA,0x5A,0x00,0x02,0x00,0x01,0x00,0x45};

const code char WIFI_DISCONNECT_MSG[7] = {0x55,0xAA,0x5B,0x00,0x00,0x00,0x45};





const code char SET_POWER_MODE_MSG[11] = {0x55,0xAA,0x66,0x00,0x04,0x00,0x01,0x00,0x0A,0x00,0x45};



const char char PING_SEND_MSG[23] = {0x55,0xAA,0x79,0x00,0x10,0x00,0x0A,0x00,0x01,0x01,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x45};



const code char SOCKET_CREATE_MSG[9] = {0x55,0xAA,0x6E,0x00,0x02,0x00,0x00,0x00,0x45};

const code char SOCKET_CLOSE_MSG[9] = {0x55,0xAA,0x6F,0x00,0x02,0x00,0x00,0x00,0x45};

const code char SOCKET_BIND_MSG[11] = {0x55,0xAA,0x70,0x00,0x04,0x00,0x00,0x00,0x00,0x00,0x45};

const code char SOCKET_CONNECT_MSG[27] = {0x55,0xAA,0x71,0x00,0x14,0x00,0x00,0x00,0x00,0x40,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x45};

const code char SOCKET_LISTEN_MSG[9] = {0x55,0xAA,0x72,0x00,0x02,0x00,0x00,0x05,0x45};

const code char SOCKET_ACCEPT_MSG[9] = {0x55,0xAA,0x73,0x00,0x02,0x00,0x00,0x00,0x45};

const code char SOCKET_SEND_MSG[15] = {0x55,0xAA,0x74,0x00,0x08,0x00,0x00,0x00,0x04,0x00,0x00,0x00,0x00,0x00,0x45};

const code char SOCKET_RECEIVE_MSG[11] = {0x55,0xAA,0x75,0x00,0x04,0x00,0x00,0x00,0x00,0x00,0x45};

const code char SOCKET_SEND_TO_MSG[33] = {0x55,0xAA,0x76,0x00,0x1A,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x04,0x00,0x00,0x00,0x00,0x00,0x45};

const code char SOCKET_RECV_FROM_MSG[11] = {0x55,0xAA,0x77,0x00,0x04,0x00,0x00,0x00,0x00,0x00,0x45};

const code char SOCKET_ALLOCATE_MSG[17] = {0x55,0xAA,0x7A,0x00,0x0A,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x45};





void WiFiPlusInit(void) {
 WiFiPlusHwReset();
 WiFiEvents.NetStatResp =  0 ;
 WiFiTimerHandle = get_timer();
}


void WiFiPlusHwReset(void) {
 GPIO_PORTC_DATA5_bit = 1;
 GPIO_PORTC_DATA5_bit = 0;
 Delay_ms(50);
 GPIO_PORTC_DATA5_bit = 1;
 Delay_ms(100);
}





void WiFiSwReset(void) {
 USB_PutQueue("\r\nSending software reset command\r\n");
 WiFiEvents.NetStatResp =  0 ;
 UART0_PutQueue(RESET_MSG,sizeof(RESET_MSG));
}

void WiFiSetIpAddr(void) {
 unsigned int i;

 USB_PutQueue("\r\nSending set IP address command\r\n");

 memset(DIY_MSG,0,528);
 for (i=0;i<sizeof(SET_IP_ADDRESS_MSG);i++)
 DIY_MSG[i] = SET_IP_ADDRESS_MSG[i];
 DIY_MSG[8] = myIpAdd[0];
 DIY_MSG[9] = myIpAdd[1];
 DIY_MSG[10] = myIpAdd[2];
 DIY_MSG[11] = myIpAdd[3];
 UART0_PutQueue(DIY_MSG,sizeof(SET_IP_ADDRESS_MSG));
}

void WiFiSetNetworkMask(void) {
 unsigned int i;

 USB_PutQueue("\r\nSending set network mask command\r\n");

 memset(DIY_MSG,0,528);
 for (i=0;i<sizeof(SET_NETWORK_MASK_MSG);i++)
 DIY_MSG[i] = SET_NETWORK_MASK_MSG[i];
 DIY_MSG[6] = myNetMask[0];
 DIY_MSG[7] = myNetMask[1];
 DIY_MSG[8] = myNetMask[2];
 DIY_MSG[9] = myNetMask[3];
 UART0_PutQueue(DIY_MSG,sizeof(SET_NETWORK_MASK_MSG));
}

void WiFiSetGatewayAddr(void) {
 unsigned int i;

 USB_PutQueue("\r\nSending set gateway IP address command\r\n");

 memset(DIY_MSG,0,528);
 for (i=0;i<sizeof(SET_GATEWAY_IP_ADDRESS_MSG);i++)
 DIY_MSG[i] = SET_GATEWAY_IP_ADDRESS_MSG[i];
 DIY_MSG[6] = gatewayAdd[0];
 DIY_MSG[7] = gatewayAdd[1];
 DIY_MSG[8] = gatewayAdd[2];
 DIY_MSG[9] = gatewayAdd[3];
 UART0_PutQueue(DIY_MSG,sizeof(SET_GATEWAY_IP_ADDRESS_MSG));
}

void WiFiSetMacAddr(void) {
 unsigned int i;

 USB_PutQueue("\r\nSending set MAC address command\r\n");

 memset(DIY_MSG,0,528);
 for (i=0;i<sizeof(SET_MACADDRESS_MSG);i++)
 DIY_MSG[i] = SET_MACADDRESS_MSG[i];
 DIY_MSG[6] = myMacAdd[0];
 DIY_MSG[7] = myMacAdd[1];
 DIY_MSG[8] = myMacAdd[2];
 DIY_MSG[9] = myMacAdd[3];
 DIY_MSG[10] = myMacAdd[4];
 DIY_MSG[11] = myMacAdd[5];
 UART0_PutQueue(DIY_MSG,sizeof(SET_MACADDRESS_MSG));
}

void WiFiSetArpTime(void) {
 unsigned int i;

 USB_PutQueue("\r\nSending set ARP time command\r\n");

 memset(DIY_MSG,0,528);
 for (i=0;i<sizeof(SET_ARP_TIME_MSG);i++)
 DIY_MSG[i] = SET_ARP_TIME_MSG[i];
 UART0_PutQueue(DIY_MSG,sizeof(SET_ARP_TIME_MSG));
}

void WiFiSetNetworkMode(void) {
 unsigned int i;

 USB_PutQueue("\r\nSending set network mode command\r\n");

 memset(DIY_MSG,0,528);
 for (i=0;i<sizeof(SET_CP_NETWORK_MODE_MSG);i++)
 DIY_MSG[i] = SET_CP_NETWORK_MODE_MSG[i];
 UART0_PutQueue(DIY_MSG,sizeof(SET_CP_NETWORK_MODE_MSG));
}

void WiFiSetCpSsid(void) {
 unsigned int i;
 unsigned int DataLength;
 unsigned int MsgLength;


 USB_PutQueue("\r\nSending set CP SSID command\r\n");

 memset(DIY_MSG,0,528);
 for (i=0;i<6;i++)
 DIY_MSG[i] = SET_CP_SSID_MSG[i];
 DIY_MSG[6] = myProfileID;
 DataLength = strlen(mySSID);
 DIY_MSG[7] = DataLength;
 for (i=0;i<DataLength;i++)
 DIY_MSG[i+8] = mySSID[i];
 MsgLength = DataLength+2;
 DIY_MSG[4] = MsgLength;
 DIY_MSG[5] = (MsgLength >> 8);
 DIY_MSG[MsgLength+6] = 0x45;
 UART0_PutQueue(DIY_MSG,MsgLength+7);
#line 361 "C:/Users/Public/Projects/ARM/Projects/WiFiClick/WiFiTEst_Code/mikroC PRO for ARM/WiFiPlus.c"
}

void WiFiSetRegionalDomain(void) {
 unsigned int i;

 USB_PutQueue("\r\nSending set regional domain command\r\n");

 memset(DIY_MSG,0,528);
 for (i=0;i<sizeof(SET_REGIONAL_DOMAIN_MSG);i++)
 DIY_MSG[i] = SET_REGIONAL_DOMAIN_MSG[i];
 UART0_PutQueue(DIY_MSG,sizeof(SET_REGIONAL_DOMAIN_MSG));
}

void WiFiSetChannelList(void) {
 unsigned int i;

 USB_PutQueue("\r\nSending set channel list command\r\n");

 memset(DIY_MSG,0,528);
 for (i=0;i<sizeof(SET_CHANNEL_LIST_MSG);i++)
 DIY_MSG[i] = SET_CHANNEL_LIST_MSG[i];
 UART0_PutQueue(DIY_MSG,sizeof(SET_CHANNEL_LIST_MSG));
}

void WiFiSetListRetryCount(void) {
 unsigned int i;

 USB_PutQueue("\r\nSending set list retry count command\r\n");

 memset(DIY_MSG,0,528);
 for (i=0;i<sizeof(SET_LIST_RETRY_COUNT_MSG);i++)
 DIY_MSG[i] = SET_LIST_RETRY_COUNT_MSG[i];
 UART0_PutQueue(DIY_MSG,sizeof(SET_LIST_RETRY_COUNT_MSG));
}

void WiFiSetSecurityWpa(void) {
 unsigned int i;
 unsigned int DataLength;
 unsigned int MsgLength;

 USB_PutQueue("\r\nSending set security WPA password command\r\n");

 memset(DIY_MSG,0,528);
 for (i=0;i<6;i++)
 DIY_MSG[i] = SET_CP_SECURITY_WPA_MSG[i];
 DIY_MSG[6] = myProfileID;
 DIY_MSG[7] = 0x06;
 DataLength = strlen(myPassword);
 DIY_MSG[9] = DataLength;
 for (i=0;i<DataLength;i++)
 DIY_MSG[i+10] = myPassword[i];
 MsgLength = DataLength+4;
 DIY_MSG[4] = MsgLength;
 DIY_MSG[5] = (MsgLength >> 8);
 DIY_MSG[MsgLength+6] = 0x45;
 UART0_PutQueue(DIY_MSG,MsgLength+7);
}

void WiFiSetSecurityWpaBinary(void) {
 unsigned int i;

 USB_PutQueue("\r\nSending set security WPA binary command\r\n");

 memset(DIY_MSG,0,528);
 for (i=0;i<sizeof(SET_CP_SECURITY_WPA_MSG_BINARY);i++)
 DIY_MSG[i] = SET_CP_SECURITY_WPA_MSG_BINARY[i];
 UART0_PutQueue(DIY_MSG,sizeof(SET_CP_SECURITY_WPA_MSG_BINARY));
}

void WiFiScanStart(void) {
 unsigned int i;

 USB_PutQueue("\r\nSending scan start command\r\n");

 memset(DIY_MSG,0,528);
 for (i=0;i<sizeof(SCAN_START_MSG);i++)
 DIY_MSG[i] = SCAN_START_MSG[i];
 UART0_PutQueue(DIY_MSG,sizeof(SCAN_START_MSG));
}

void WiFiConnect(void) {
 unsigned int i;

 USB_PutQueue("\r\nSending connect command\r\n");

 memset(DIY_MSG,0,528);
 for (i=0;i<sizeof(WIFI_CONNECT_MSG);i++)
 DIY_MSG[i] = WIFI_CONNECT_MSG[i];
 UART0_PutQueue(DIY_MSG,sizeof(WIFI_CONNECT_MSG));
}

void WiFiDisconnect(void) {
 unsigned int i;

 USB_PutQueue("\r\nSending disconnect command\r\n");

 memset(DIY_MSG,0,528);
 for (i=0;i<sizeof(WIFI_DISCONNECT_MSG);i++)
 DIY_MSG[i] = WIFI_DISCONNECT_MSG[i];
 UART0_PutQueue(DIY_MSG,sizeof(WIFI_DISCONNECT_MSG));
}

void WiFiPingSend(void) {
 unsigned int i;

 USB_PutQueue("\r\nSending ping command\r\n");

 memset(DIY_MSG,0,528);
 for (i=0;i<sizeof(PING_SEND_MSG);i++)
 DIY_MSG[i] = PING_SEND_MSG[i];
 UART0_PutQueue(DIY_MSG,sizeof(PING_SEND_MSG));
}


void WiFiSocketCreate(char SocType) {
 unsigned int i;

 if (SocType ==  0 )
 USB_PutQueue("\r\nCreating UDP socket\r\n");
 if (SocType ==  1 )
 USB_PutQueue("\r\nCreating TCP socket\r\n");

 memset(DIY_MSG,0,528);
 for (i=0;i<sizeof(SOCKET_CREATE_MSG);i++)
 DIY_MSG[i] = SOCKET_CREATE_MSG[i];
 DIY_MSG[6] = SocType;
 UART0_PutQueue(DIY_MSG,sizeof(SOCKET_CREATE_MSG));
}

void WiFiSocketClose(char Handle) {
 unsigned int i;

 USB_PutQueue("\r\nSending socket close command\r\n");

 memset(DIY_MSG,0,528);
 for (i=0;i<sizeof(SOCKET_CLOSE_MSG);i++)
 DIY_MSG[i] = SOCKET_CLOSE_MSG[i];
 DIY_MSG[6] = Handle;
 UART0_PutQueue(DIY_MSG,sizeof(SOCKET_CLOSE_MSG));
}

void WiFiSocketBind(char Handle, unsigned int LocalPort) {
 unsigned int i;
 char *BufNum;

 USB_PutQueue("\r\nSending socket bind command\r\n");

 memset(DIY_MSG,0,528);
 for (i=0;i<sizeof(SOCKET_BIND_MSG);i++)
 DIY_MSG[i] = SOCKET_BIND_MSG[i];
 DIY_MSG[8] = Handle;
 DIY_MSG[6] = LocalPort;
 DIY_MSG[7] = (LocalPort >> 8);
#line 519 "C:/Users/Public/Projects/ARM/Projects/WiFiClick/WiFiTEst_Code/mikroC PRO for ARM/WiFiPlus.c"
 UART0_PutQueue(DIY_MSG,sizeof(SOCKET_BIND_MSG));
}

void WiFiSocketConnect(char Handle) {
 unsigned int i;

 USB_PutQueue("\r\nSending socket connect command\r\n");

 memset(DIY_MSG,0,528);
 for (i=0;i<sizeof(SOCKET_CONNECT_MSG);i++)
 DIY_MSG[i] = SOCKET_CONNECT_MSG[i];
 DIY_MSG[6] = Handle;
 DIY_MSG[8] = UDP_RemPort;
 DIY_MSG[9] = (UDP_RemPort >> 8);
 DIY_MSG[10] = UDP_RemoteIP[0];
 DIY_MSG[11] = UDP_RemoteIP[1];
 DIY_MSG[12] = UDP_RemoteIP[2];
 DIY_MSG[13] = UDP_RemoteIP[3];
 UART0_PutQueue(DIY_MSG,sizeof(SOCKET_CONNECT_MSG));
}

void WiFiSocketListen(char Handle) {
 unsigned int i;

 USB_PutQueue("\r\nSending socket Listen command\r\n");

 memset(DIY_MSG,0,528);
 for (i=0;i<sizeof(SOCKET_LISTEN_MSG);i++)
 DIY_MSG[i] = SOCKET_LISTEN_MSG[i];
 DIY_MSG[6] = Handle;
 UART0_PutQueue(DIY_MSG,sizeof(SOCKET_LISTEN_MSG));
}

void WiFiSocketAccept(char Handle) {
 unsigned int i;

 USB_PutQueue("\r\nSending socket accept command\r\n");

 memset(DIY_MSG,0,528);
 for (i=0;i<sizeof(SOCKET_ACCEPT_MSG);i++)
 DIY_MSG[i] = SOCKET_ACCEPT_MSG[i];
 DIY_MSG[6] = Handle;
 UART0_PutQueue(DIY_MSG,sizeof(SOCKET_ACCEPT_MSG));
}

void WiFiSocketSend(char Handle, char *Data) {
 unsigned int i;
 unsigned int DataLength;
 unsigned int MsgLength;


 USB_PutQueue("\r\nSending socket send command\r\n");
 memset(DIY_MSG,0,528);
 for (i=0;i<6;i++)
 DIY_MSG[i] = SOCKET_SEND_MSG[i];
 DIY_MSG[6] = Handle;
 DataLength = strlen(Data);
 DIY_MSG[8] = DataLength;
 DIY_MSG[9] = (DataLength >> 8);
 for (i=0;i<DataLength;i++)
 DIY_MSG[i+10] = Data[i];
 MsgLength = DataLength+4;
 DIY_MSG[4] = MsgLength;
 DIY_MSG[5] = (MsgLength >> 8);
 DIY_MSG[MsgLength+6] = 0x45;
 UART0_PutQueue(DIY_MSG,MsgLength+7);
#line 607 "C:/Users/Public/Projects/ARM/Projects/WiFiClick/WiFiTEst_Code/mikroC PRO for ARM/WiFiPlus.c"
}

void WiFiSocketReceive(char Handle, unsigned int DataLength) {
 unsigned int i;

 USB_PutQueue("\r\nSending socket receive command\r\n");

 memset(DIY_MSG,0,528);
 for (i=0;i<sizeof(SOCKET_RECEIVE_MSG);i++)
 DIY_MSG[i] = SOCKET_RECEIVE_MSG[i];
 DIY_MSG[6] = Handle;
 DIY_MSG[8] = DataLength;
 DIY_MSG[9] = (DataLength >> 8);
 UART0_PutQueue(DIY_MSG,sizeof(SOCKET_RECEIVE_MSG));
}

void WiFiSocketSendTo(char Handle, char *Data) {
 unsigned int i;
 unsigned int DataLength;
 unsigned int MsgLength;
 char *BufNum;

 USB_PutQueue("\r\nSending socket send to command\r\n");
 memset(DIY_MSG,0,528);
 for (i=0;i<6;i++)
 DIY_MSG[i] = SOCKET_SEND_TO_MSG[i];
 DIY_MSG[6] = Handle;
 DIY_MSG[8] = UDP_RemPort;
 DIY_MSG[9] = (UDP_RemPort >> 8);

 DIY_MSG[10] = UDP_RemoteIP[0];
 DIY_MSG[11] = UDP_RemoteIP[1];
 DIY_MSG[12] = UDP_RemoteIP[2];
 DIY_MSG[13] = UDP_RemoteIP[3];

 DataLength = strlen(Data);
 DIY_MSG[26] = DataLength;
 DIY_MSG[27] = (DataLength >> 8);
 for (i=0;i<DataLength;i++)
 DIY_MSG[i+28] = Data[i];
 MsgLength = DataLength+22;
 DIY_MSG[4] = MsgLength;
 DIY_MSG[5] = (MsgLength >> 8);
 DIY_MSG[MsgLength+6] = 0x45;
 UART0_PutQueue(DIY_MSG,MsgLength+7);





 BufNum = GetBuffer();
 sprintf(BufNum,"Header: %02X%02X%02X%02X%02X%02X",DIY_MSG[0],DIY_MSG[1],DIY_MSG[2],DIY_MSG[3],DIY_MSG[4],DIY_MSG[5]);
 USB_PutQueue(BufNum);

 BufNum = GetBuffer();
 sprintf(BufNum,"Handle: %02X, Reserved: %02X, Remote port: %02X%02X",DIY_MSG[6],DIY_MSG[7],DIY_MSG[8],DIY_MSG[9]);
 USB_PutQueue(BufNum);

 BufNum = GetBuffer();
 sprintf(BufNum,"Remote IP address: %02X%02X%02X%02X",DIY_MSG[10],DIY_MSG[11],DIY_MSG[12],DIY_MSG[13]);
 USB_PutQueue(BufNum);

 BufNum = GetBuffer();
 sprintf(BufNum,"Date byte count: %02X%02X",DIY_MSG[26],DIY_MSG[27]);
 USB_PutQueue(BufNum);

 BufNum = GetBuffer();
 sprintf(BufNum,"Data: %02X%02X%02X%02X%02X%02X%02X",DIY_MSG[28],DIY_MSG[29],DIY_MSG[30],DIY_MSG[31],DIY_MSG[32],DIY_MSG[33],DIY_MSG[34]);
 USB_PutQueue(BufNum);

 BufNum = GetBuffer();
 sprintf(BufNum,"Trailer: %02X\r\n",DIY_MSG[35]);
 USB_PutQueue(BufNum);


}

void WiFiSocketReceiveFrom(char Handle, unsigned int DataLength) {
 unsigned int i;

 USB_PutQueue("\r\nSending socket receive from command\r\n");

 memset(DIY_MSG,0,528);
 for (i=0;i<sizeof(SOCKET_RECV_FROM_MSG);i++)
 DIY_MSG[i] = SOCKET_RECV_FROM_MSG[i];
 DIY_MSG[6] = Handle;
 DIY_MSG[8] = DataLength;
 DIY_MSG[9] = (DataLength >> 8);
 UART0_PutQueue(DIY_MSG,sizeof(SOCKET_RECV_FROM_MSG));
}

void WiFiSocketAllocate(void) {
 unsigned int i;

 USB_PutQueue("\r\nSending socket allocate command\r\n");

 memset(DIY_MSG,0,528);
 for (i=0;i<sizeof(SOCKET_ALLOCATE_MSG);i++)
 DIY_MSG[i] = SOCKET_ALLOCATE_MSG[i];
 DIY_MSG[6] = TCP_ServerSocketCount;
 DIY_MSG[7] = TCP_ClientSocketCount;

 DIY_MSG[8] = TCP_ServerRcvBufSize;
 DIY_MSG[9] = (TCP_ServerRcvBufSize >> 8);
 DIY_MSG[10] = TCP_ServerXmtBufSize;
 DIY_MSG[11] = (TCP_ServerXmtBufSize >> 8);

 DIY_MSG[12] = TCP_ClientRcvBufSize;
 DIY_MSG[13] = (TCP_ClientRcvBufSize >> 8);
 DIY_MSG[14] = TCP_ClientXmtBufSize;
 DIY_MSG[15] = (TCP_ClientXmtBufSize >> 8);

 UART0_PutQueue(DIY_MSG,sizeof(SOCKET_ALLOCATE_MSG));
}







void WiFiGetVersion(void) {
 unsigned int i;

 USB_PutQueue("\r\nSending get version command\r\n");

 memset(DIY_MSG,0,528);
 for (i=0;i<sizeof(GET_VERSION_MSG);i++)
 DIY_MSG[i] = GET_VERSION_MSG[i];
 UART0_PutQueue(DIY_MSG,sizeof(GET_VERSION_MSG));
}

void WiFiGetNetworkStatus(void) {
 unsigned int i;


 USB_PutQueue("\r\nSending get network status command\r\n");

 memset(DIY_MSG,0,528);
 for (i=0;i<sizeof(GET_NETWORK_STATUS);i++)
 DIY_MSG[i] = GET_NETWORK_STATUS[i];
 UART0_PutQueue(DIY_MSG,sizeof(GET_NETWORK_STATUS));
#line 761 "C:/Users/Public/Projects/ARM/Projects/WiFiClick/WiFiTEst_Code/mikroC PRO for ARM/WiFiPlus.c"
}

void WiFiGetWpaKey(void) {
 unsigned int i;

 USB_PutQueue("\r\nSending get WPA key command\r\n");

 memset(DIY_MSG,0,528);
 for (i=0;i<sizeof(GET_CP_WPAKEY_MSG);i++)
 DIY_MSG[i] = GET_CP_WPAKEY_MSG[i];
 UART0_PutQueue(DIY_MSG,sizeof(GET_CP_WPAKEY_MSG));
}

void WiFiScanGetResult(unsigned short int Index) {
 unsigned int i;

 USB_PutQueue("\r\nSending get scan result command\r\n");

 memset(DIY_MSG,0,528);
 for (i=0;i<sizeof(SCAN_GET_RESULTS_MSG);i++)
 DIY_MSG[i] = SCAN_GET_RESULTS_MSG[i];
 DIY_MSG[6] = Index;
 UART0_PutQueue(DIY_MSG,sizeof(SCAN_GET_RESULTS_MSG));
}









void WiFiApp(void) {
 WiFiStateFuncPtr();
}


void WiFiState0(void) {
 if (WiFiEvents.Error ==  1 ) WiFiStateFuncPtr = WiFiState666;
}






void WiFiState1(void) {
 WiFiEvents.NetStatResp =  0 ;
 set_timer(WiFiTimerHandle,4);
 WiFiGetNetworkStatus();
 WiFiStateFuncPtr = WiFiState2;
}


void WiFiState2(void) {
 if (WiFiEvents.NetStatResp ==  1 ) {
 USB_PutQueue("Network status available\r\n");
 WiFiStateFuncPtr = WiFiState0;
 }
 TimeoutCheck(2);
}





void WiFiState4(void) {
 if ((WiFiEvents.NetStatResp ==  1 ) && ((WiFiParam.NetworkStatus == 0) || (WiFiParam.NetworkStatus == 2))) {
 USB_PutQueue("Starting access point scan\r\n");
 WiFiStateFuncPtr = WiFiState5;
 }else{
 USB_PutQueue("WiFi not ready\r\n");
 WiFiStateFuncPtr = WiFiState0;
 }
}


void WiFiState5(void) {
 ACK_Received =  0 ;
 set_timer(WiFiTimerHandle,4);
 WiFiScanStart();
 WiFiStateFuncPtr = WiFiState6;
}


void WiFiState6(void) {
 if (ACK_Received ==  1 ) {
 set_timer(WiFiTimerHandle,10);
 WiFiEvents.ScnRsltRdy =  0 ;
 ClearAllLabels();
 WiFiStateFuncPtr = WiFiState7;
 }
 TimeoutCheck(6);
}


void WiFiState7(void) {
 if (WiFiEvents.ScnRsltRdy ==  1 ) {
 ScanIndex = 0;
 WiFiStateFuncPtr = WiFiState8;
 }
 TimeoutCheck(7);
}


void WiFiState8(void) {
 if (NumScanRslts == 0) {
 USB_PutQueue("\r\nNo more scan results\r\n");
 WiFiStateFuncPtr = WiFiState0;
 }else{
 set_timer(WiFiTimerHandle,10);
 WiFiEvents.ScnRsltMsg =  0 ;
 WiFiScanGetResult(ScanIndex);
 WiFiStateFuncPtr = WiFiState9;
 }
}


void WiFiState9(void) {
 if (WiFiEvents.ScnRsltMsg ==  1 ) {

 switch (ScanIndex) {
 case 0:
 UpdateLabel4(&CurrentSSID);
 UpdateLabel5(&Config);
 UpdateLabel6(&ChanNumStr);
 break;
 case 1:
 UpdateLabel7(&CurrentSSID);
 UpdateLabel8(&Config);
 UpdateLabel9(&ChanNumStr);
 break;
 case 2:
 UpdateLabel10(&CurrentSSID);
 UpdateLabel11(&Config);
 UpdateLabel12(&ChanNumStr);
 break;
 case 3:
 UpdateLabel13(&CurrentSSID);
 UpdateLabel14(&Config);
 UpdateLabel15(&ChanNumStr);
 break;
 case 4:
 UpdateLabel16(&CurrentSSID);
 UpdateLabel15(&Config);
 UpdateLabel18(&ChanNumStr);
 break;

 default:
 break;
 }

 ScanIndex += 1;
 NumScanRslts--;
 WiFiStateFuncPtr = WiFiState8;
 }
 TimeoutCheck(9);
}






void WiFiState15(void) {
 ACK_Received =  0 ;
 set_timer(WiFiTimerHandle,4);
 WiFiSetMacAddr();
 WiFiStateFuncPtr = WiFiState16;
}


void WiFiState16(void) {
 if (ACK_Received ==  1 ) {
 ACK_Received =  0 ;
 set_timer(WiFiTimerHandle,4);
 WiFiSetIpAddr();
 WiFiStateFuncPtr = WiFiState17;
 }
 TimeoutCheck(16);
}


void WiFiState17(void) {
 if (ACK_Received ==  1 ) {
 ACK_Received =  0 ;
 set_timer(WiFiTimerHandle,4);
 WiFiSetNetworkMask();
 WiFiStateFuncPtr = WiFiState18;
 }
 TimeoutCheck(17);
}


void WiFiState18(void) {
 if (ACK_Received ==  1 ) {
 ACK_Received =  0 ;
 set_timer(WiFiTimerHandle,4);
 WiFiSetGatewayAddr();
 WiFiStateFuncPtr = WiFiState19;
 }
 TimeoutCheck(18);
}


void WiFiState19(void) {
 if (ACK_Received ==  1 ) {
 ACK_Received =  0 ;
 set_timer(WiFiTimerHandle,4);
 WiFiSetNetworkMode();
 WiFiStateFuncPtr = WiFiState20;
 }
 TimeoutCheck(19);
}


void WiFiState20(void) {
 if (ACK_Received ==  1 ) {
 ACK_Received =  0 ;
 set_timer(WiFiTimerHandle,4);
 WiFiSetCpSsid();
 WiFiStateFuncPtr = WiFiState21;
 }
 TimeoutCheck(20);
}


void WiFiState21(void) {
 if (ACK_Received ==  1 ) {
 ACK_Received =  0 ;
 set_timer(WiFiTimerHandle,4);
 WiFiSetRegionalDomain();
 WiFiStateFuncPtr = WiFiState22;
 }
 TimeoutCheck(21);
}


void WiFiState22(void) {
 if (ACK_Received ==  1 ) {
 ACK_Received =  0 ;
 set_timer(WiFiTimerHandle,4);
 WiFiSetChannelList();
 WiFiStateFuncPtr = WiFiState23;
 }
 TimeoutCheck(22);
}


void WiFiState23(void) {
 if (ACK_Received ==  1 ) {
 ACK_Received =  0 ;
 set_timer(WiFiTimerHandle,4);
 WiFiSetListRetryCount();
 WiFiStateFuncPtr = WiFiState24;
 }
 TimeoutCheck(23);
}



void WiFiState24(void) {
 if (ACK_Received ==  1 ) {
 ACK_Received =  0 ;
 set_timer(WiFiTimerHandle,4);
 WiFiSetSecurityWpa();
 WiFiStateFuncPtr = WiFiState25;
 }
 TimeoutCheck(24);
}
#line 1046 "C:/Users/Public/Projects/ARM/Projects/WiFiClick/WiFiTEst_Code/mikroC PRO for ARM/WiFiPlus.c"
void WiFiState25(void) {
 if (ACK_Received ==  1 ) {
 WiFiStateFuncPtr = WiFiState0;
 }
 TimeoutCheck(25);
}





void WiFiState30(void) {
 ACK_Received =  0 ;
 set_timer(WiFiTimerHandle,4);
 WiFiConnect();
 WiFiStateFuncPtr = WiFiState31;
}

void WiFiState31(void) {
 if (ACK_Received ==  1 ) {
 WiFiStateFuncPtr = WiFiState0;
 }
 TimeoutCheck(31);
}





void WiFiState35(void) {
 ACK_Received =  0 ;
 set_timer(WiFiTimerHandle,4);
 WiFiDisconnect();
 WiFiStateFuncPtr = WiFiState36;
}

void WiFiState36(void) {
 if (ACK_Received ==  1 ) {
 WiFiStateFuncPtr = WiFiState0;
 }
 TimeoutCheck(36);
}






void WiFiState40(void) {
 WiFiEvents.SockCreaResp =  0 ;
 set_timer(WiFiTimerHandle,4);
 WiFiSocketCreate( 0 );
 WiFiStateFuncPtr = WiFiState41;
}


void WiFiState41(void) {
 if (WiFiEvents.SockCreaResp ==  1 ) {
 if (SocketHandle < 254) HandleValid =  1 ;
 else HandleValid =  0 ;
 WiFiStateFuncPtr = WiFiState0;
 }
 TimeoutCheck(41);
}





void WiFiState45(void) {
 if (HandleValid ==  1 ) {
 ACK_Received =  0 ;
 set_timer(WiFiTimerHandle,4);
 WiFiSocketClose(SocketHandle);
 WiFiStateFuncPtr = WiFiState46;
 }else{
 USB_PutQueue("No valid socket open\r\n");
 WiFiStateFuncPtr = WiFiState0;
 }
}

void WiFiState46(void) {
 if (ACK_Received ==  1 ) {
 WiFiStateFuncPtr = WiFiState0;
 }
 TimeoutCheck(46);
}





void WiFiState50(void) {
 if (HandleValid ==  1 ) {
 WiFiEvents.SockBindResp =  0 ;
 BindResult = 255;
 set_timer(WiFiTimerHandle,4);
 WiFiSocketBind(SocketHandle,UDP_LocPort);
 WiFiStateFuncPtr = WiFiState51;
 }else{
 USB_PutQueue("No valid socket open\r\n");
 WiFiStateFuncPtr = WiFiState0;
 }
}

void WiFiState51(void) {
 if (WiFiEvents.SockBindResp ==  1 ) {
 if (BindResult == 0)
 USB_PutQueue("Bind successful\r\n");
 else
 USB_PutQueue("Bind failed\r\n");
 WiFiStateFuncPtr = WiFiState0;
 }
 TimeoutCheck(51);
}




void WiFiState55(void) {
 if (HandleValid ==  1 ) {
 WiFiEvents.SockConnResp =  0 ;
 ConnectResult = 255;
 set_timer(WiFiTimerHandle,4);
 WiFiSocketConnect(SocketHandle);
 WiFiStateFuncPtr = WiFiState56;
 }else{
 USB_PutQueue("No valid socket open\r\n");
 WiFiStateFuncPtr = WiFiState0;
 }
}

void WiFiState56(void) {
 if (WiFiEvents.SockConnResp ==  1 ) {
 WiFiStateFuncPtr = WiFiState0;
 }
 TimeoutCheck(56);
}





void WiFiState60(void) {
 if (HandleValid ==  1 ) {
 WiFiEvents.SockListenResp =  0 ;
 set_timer(WiFiTimerHandle,4);
 WiFiSocketListen(SocketHandle);
 WiFiStateFuncPtr = WiFiState61;
 }else{
 USB_PutQueue("No valid socket open\r\n");
 WiFiStateFuncPtr = WiFiState0;
 }
}

void WiFiState61(void) {
 if (WiFiEvents.SockListenResp ==  1 ) {
 WiFiStateFuncPtr = WiFiState0;
 }
 TimeoutCheck(61);
}




void WiFiState62(void) {
 if (HandleValid ==  1 ) {
 WiFiEvents.SockAccptResp =  0 ;
 set_timer(WiFiTimerHandle,4);
 WiFiSocketAccept(SocketHandle);
 WiFiStateFuncPtr = WiFiState62;
 }else{
 USB_PutQueue("No valid socket open\r\n");
 WiFiStateFuncPtr = WiFiState0;
 }
}

void WiFiState63(void) {
 if (WiFiEvents.SockListenResp ==  1 ) {
 WiFiStateFuncPtr = WiFiState0;
 }
 TimeoutCheck(63);
}




void WiFiState65(void) {
 if (HandleValid ==  1 ) {
 WiFiEvents.SockSendResp =  0 ;
 set_timer(WiFiTimerHandle,4);
 WiFiSocketSend(SocketHandle,&DataBuffer);
 WiFiStateFuncPtr = WiFiState66;
 }
}

void WiFiState66(void) {
 if (WiFiEvents.SockSendResp ==  1 ) {
 WiFiStateFuncPtr = WiFiState0;
 }
 TimeoutCheck(66);
}




void WiFiState67(void) {
 if (HandleValid ==  1 ) {
 WiFiEvents.SockRcvResp =  0 ;
 set_timer(WiFiTimerHandle,4);
 WiFiSocketReceive(SocketHandle,128);
 WiFiStateFuncPtr = WiFiState68;
 }
}

void WiFiState68(void) {
 if (WiFiEvents.SockRcvResp ==  1 ) {
 WiFiStateFuncPtr = WiFiState0;
 }
 TimeoutCheck(68);
}




void WiFiState70(void) {
 if (HandleValid ==  1 ) {
 WiFiEvents.SockSendToResp =  0 ;
 set_timer(WiFiTimerHandle,4);
 WiFiSocketSendTo(SocketHandle,&DataBuffer);
 WiFiStateFuncPtr = WiFiState71;
 }
}

void WiFiState71(void) {
 if (WiFiEvents.SockSendToResp ==  1 ) {
 WiFiStateFuncPtr = WiFiState0;
 }
 TimeoutCheck(71);
}




void WiFiState74(void) {
 if (HandleValid ==  1 ) {
 WiFiEvents.SockRcvFromResp =  0 ;
 set_timer(WiFiTimerHandle,120);
 WiFiSocketReceiveFrom(SocketHandle,128);
 WiFiStateFuncPtr = WiFiState75;
 }
}

void WiFiState75(void) {
 if (WiFiEvents.SockRcvFromResp ==  1 ) {
 WiFiStateFuncPtr = WiFiState74;
 }
 TimeoutCheck(75);
}




void WiFiState80(void) {
 if (HandleValid ==  1 ) {
 WiFiEvents.SockRcvFromResp =  0 ;
 WiFiSocketReceiveFrom(SocketHandle,128);
 WiFiStateFuncPtr = WiFiState81;
 }
}

void WiFiState81(void) {
 if (WiFiEvents.SockRcvFromResp ==  1 ) {
 switch (UDP_Buf[0]) {
 case 'A':
 strcpy(DataBuffer,"Command A received\r\n");
 break;

 case 'B':
 strcpy(DataBuffer,"Command B received\r\n");
 break;

 default:
 strcpy(DataBuffer,"Unimplemented command\r\n");
 break;
 }

 WiFiEvents.SockSendToResp =  0 ;
 WiFiSocketSendTo(SocketHandle,&DataBuffer);
 WiFiStateFuncPtr = WiFiState82;
 }
}

void WiFiState82(void) {
 if (WiFiEvents.SockSendToResp ==  1 ) {
 WiFiEvents.SockRcvFromResp =  0 ;
 WiFiSocketReceiveFrom(SocketHandle,128);
 WiFiStateFuncPtr = WiFiState81;
 }
}







void WiFiState90(void) {
 WiFiEvents.NetStatResp =  0 ;
 set_timer(WiFiTimerHandle,4);
 WiFiGetNetworkStatus();
 WiFiStateFuncPtr = WiFiState91;
}


void WiFiState91(void) {
 if (WiFiEvents.NetStatResp ==  1 ) {
 USB_PutQueue("Network status available\r\n");

 if ((WiFiParam.NetworkStatus == 0) || (WiFiParam.NetworkStatus == 2)) {
 WiFiStateFuncPtr = WiFiState93;
 }else{
 USB_PutQueue("Disconnecting WiFi\r\n");
 ACK_Received =  0 ;
 set_timer(WiFiTimerHandle,4);
 WiFiDisconnect();
 WiFiStateFuncPtr = WiFiState92;
 }
 }
 TimeoutCheck(91);
}


void WiFiState92(void) {
 if (ACK_Received ==  1 ) {
 WiFiStateFuncPtr = WiFiState93;
 }
 TimeoutCheck(92);
}


void WiFiState93(void) {
 USB_PutQueue("\r\nStarting access point scan\r\n");
 ACK_Received =  0 ;
 set_timer(WiFiTimerHandle,4);
 WiFiScanStart();
 WiFiStateFuncPtr = WiFiState94;
}


void WiFiState94(void) {
 if (ACK_Received ==  1 ) {
 set_timer(WiFiTimerHandle,10);
 WiFiEvents.ScnRsltRdy =  0 ;
 ClearAllLabels();
 WiFiStateFuncPtr = WiFiState95;
 }
 TimeoutCheck(94);
}


void WiFiState95(void) {
 if (WiFiEvents.ScnRsltRdy ==  1 ) {
 ScanIndex = 0;
 WiFiStateFuncPtr = WiFiState96;
 }
 TimeoutCheck(95);
}


void WiFiState96(void) {
 if (NumScanRslts == 0) {
 USB_PutQueue("\r\nNo more scan results\r\n");
 EnableButton2();
 WiFiStateFuncPtr = WiFiState0;
 }else{
 set_timer(WiFiTimerHandle,10);
 WiFiEvents.ScnRsltMsg =  0 ;
 WiFiScanGetResult(ScanIndex);
 WiFiStateFuncPtr = WiFiState97;
 }
}


void WiFiState97(void) {
 if (WiFiEvents.ScnRsltMsg ==  1 ) {

 switch (ScanIndex) {
 case 0:
 UpdateLabel4(&CurrentSSID);
 UpdateLabel5(&Config);
 UpdateLabel6(&ChanNumStr);
 break;
 case 1:
 UpdateLabel7(&CurrentSSID);
 UpdateLabel8(&Config);
 UpdateLabel9(&ChanNumStr);
 break;
 case 2:
 UpdateLabel10(&CurrentSSID);
 UpdateLabel11(&Config);
 UpdateLabel12(&ChanNumStr);
 break;
 case 3:
 UpdateLabel13(&CurrentSSID);
 UpdateLabel14(&Config);
 UpdateLabel15(&ChanNumStr);
 break;
 case 4:
 UpdateLabel16(&CurrentSSID);
 UpdateLabel17(&Config);
 UpdateLabel18(&ChanNumStr);
 break;

 default:
 break;
 }
 ScanIndex += 1;
 NumScanRslts--;
 WiFiStateFuncPtr = WiFiState96;
 }
 TimeoutCheck(97);
}







void WiFiState100(void) {
 ACK_Received =  0 ;
 set_timer(WiFiTimerHandle,4);
 WiFiSetMacAddr();
 WiFiStateFuncPtr = WiFiState101;
}


void WiFiState101(void) {
 if (ACK_Received ==  1 ) {
 ACK_Received =  0 ;
 set_timer(WiFiTimerHandle,4);
 WiFiSetIpAddr();
 WiFiStateFuncPtr = WiFiState102;
 }
 TimeoutCheck(101);
}


void WiFiState102(void) {
 if (ACK_Received ==  1 ) {
 ACK_Received =  0 ;
 set_timer(WiFiTimerHandle,4);
 WiFiSetNetworkMask();
 WiFiStateFuncPtr = WiFiState103;
 }
 TimeoutCheck(102);
}


void WiFiState103(void) {
 if (ACK_Received ==  1 ) {
 ACK_Received =  0 ;
 set_timer(WiFiTimerHandle,4);
 WiFiSetGatewayAddr();
 WiFiStateFuncPtr = WiFiState104;
 }
 TimeoutCheck(103);
}


void WiFiState104(void) {
 if (ACK_Received ==  1 ) {
 ACK_Received =  0 ;
 set_timer(WiFiTimerHandle,4);
 WiFiSetNetworkMode();
 WiFiStateFuncPtr = WiFiState105;
 }
 TimeoutCheck(104);
}


void WiFiState105(void) {
 if (ACK_Received ==  1 ) {
 ACK_Received =  0 ;
 set_timer(WiFiTimerHandle,4);
 WiFiSetCpSsid();
 WiFiStateFuncPtr = WiFiState106;
 }
 TimeoutCheck(105);
}


void WiFiState106(void) {
 if (ACK_Received ==  1 ) {
 ACK_Received =  0 ;
 set_timer(WiFiTimerHandle,4);
 WiFiSetRegionalDomain();
 WiFiStateFuncPtr = WiFiState107;
 }
 TimeoutCheck(106);
}


void WiFiState107(void) {
 if (ACK_Received ==  1 ) {
 ACK_Received =  0 ;
 set_timer(WiFiTimerHandle,4);
 WiFiSetChannelList();
 WiFiStateFuncPtr = WiFiState108;
 }
 TimeoutCheck(107);
}


void WiFiState108(void) {
 if (ACK_Received ==  1 ) {
 ACK_Received =  0 ;
 set_timer(WiFiTimerHandle,4);
 WiFiSetListRetryCount();
 WiFiStateFuncPtr = WiFiState109;
 }
 TimeoutCheck(108);
}



void WiFiState109(void) {
 if (ACK_Received ==  1 ) {
 ACK_Received =  0 ;
 set_timer(WiFiTimerHandle,4);
 WiFiSetSecurityWpa();
 WiFiStateFuncPtr = WiFiState110;
 }
 TimeoutCheck(109);
}
#line 1596 "C:/Users/Public/Projects/ARM/Projects/WiFiClick/WiFiTEst_Code/mikroC PRO for ARM/WiFiPlus.c"
void WiFiState110(void) {
 if (ACK_Received ==  1 ) {
 ACK_Received =  0 ;
 set_timer(WiFiTimerHandle,4);
 WiFiConnect();
 WiFiStateFuncPtr = WiFiState111;
 }
 TimeoutCheck(25);
}


void WiFiState111(void) {
 if (ACK_Received ==  1 ) {
 WiFiEvents.ConStatChng =  0 ;
 BlinkTimer = get_timer();
 set_timer(BlinkTimer,1);

 set_timer(WiFiTimerHandle,60);
#line 1617 "C:/Users/Public/Projects/ARM/Projects/WiFiClick/WiFiTEst_Code/mikroC PRO for ARM/WiFiPlus.c"
 WiFiStateFuncPtr = WiFiState112;
 }
 TimeoutCheck(111);
}


void WiFiState112(void) {
 if (WiFiEvents.ConStatChng ==  1 ) {
 free_timer(BlinkTimer);
 if (ConnectStatus == 0x01) {
 WiFiEvents.IPAddrAss =  0 ;
 set_timer(WiFiTimerHandle,6);
 WiFiStateFuncPtr = WiFiState113;
 }else{
 UpdateLabel19("Connection failed",CL_RED);
 WiFiStateFuncPtr = WiFiState0;
 }
 }

 if ((check_timer(BlinkTimer) == 0) && (Label19.Font_Color == CL_BLACK)) {
 set_timer(BlinkTimer,1);
 UpdateLabel19("Wait",CL_RED);
 }
 if ((check_timer(BlinkTimer) == 0) && (Label19.Font_Color == CL_RED)) {
 set_timer(BlinkTimer,1);
 UpdateLabel19("",CL_BLACK);
 }
 if (check_timer(WiFiTimerHandle) == 0) {
 free_timer(BlinkTimer);

 UpdateLabel19("Timed out after 60 seconds",CL_RED);
#line 1652 "C:/Users/Public/Projects/ARM/Projects/WiFiClick/WiFiTEst_Code/mikroC PRO for ARM/WiFiPlus.c"
 WiFiStateFuncPtr = WiFiState0;
 }
}


void WiFiState113(void) {
 char Message[40];

 if (WiFiEvents.IPAddrAss ==  1 ) {
 sprintf(Message,"IP address: %u.%u.%u.%u",AssignedIP[0],AssignedIP[1],AssignedIP[2],AssignedIP[3]);
 if (strlen(Message) <= 40)
 UpdateLabel19(Message,CL_GREEN);
 else
 UpdateLabel19("IP message too long",CL_RED);
 EnableButton3();
 WiFiStateFuncPtr = WiFiState0;
 }
 TimeoutCheck(113);
}






void WiFiState120(void) {
 WiFiEvents.SockCreaResp =  0 ;
 set_timer(WiFiTimerHandle,4);
 WiFiSocketCreate( 0 );
 WiFiStateFuncPtr = WiFiState121;
}


void WiFiState121(void) {
 if (WiFiEvents.SockCreaResp ==  1 ) {
 if (SocketHandle < 254) {
 WiFiEvents.SockBindResp =  0 ;
 BindResult = 255;
 set_timer(WiFiTimerHandle,4);
 WiFiSocketBind(SocketHandle,UDP_LocPort);
 WiFiStateFuncPtr = WiFiState122;
 }else{
 UpdateLabel19("Failed to create a socket",CL_RED);
 WiFiStateFuncPtr = WiFiState0;
 }
 }
 TimeoutCheck(121);
}


void WiFiState122(void) {
 if (WiFiEvents.SockBindResp ==  1 ) {
 if (BindResult == 0) {
 UpdateLabel19("UDP server socket ready",CL_GREEN);
 EnableButton4();
 WiFiEvents.SockRcvFromResp =  0 ;
 WiFiSocketReceiveFrom(SocketHandle,128);
 WiFiStateFuncPtr = WiFiState123;
 }else{
 UpdateLabel19("Bind failed",CL_RED);
 }
 }
 TimeoutCheck(122);
}


void WiFiState123(void) {
 if (WiFiEvents.SockRcvFromResp ==  1 ) {
 switch (UDP_Buf[0]) {
 case 'A':
 strcpy(DataBuffer,"Command A received\r\n");
 break;

 case 'B':
 strcpy(DataBuffer,"Command B received\r\n");
 break;

 default:
 strcpy(DataBuffer,"Unimplemented command\r\n");
 break;
 }

 WiFiEvents.SockSendToResp =  0 ;
 WiFiSocketSendTo(SocketHandle,&DataBuffer);
 WiFiStateFuncPtr = WiFiState124;
 }
}


void WiFiState124(void) {
 if (WiFiEvents.SockSendToResp ==  1 ) {
 WiFiEvents.SockRcvFromResp =  0 ;
 WiFiSocketReceiveFrom(SocketHandle,128);
 WiFiStateFuncPtr = WiFiState123;
 }
}






void WiFiState130(void) {
 ACK_Received =  0 ;
 set_timer(WiFiTimerHandle,4);
 WiFiSocketClose(SocketHandle);
 WiFiStateFuncPtr = WiFiState131;

}


void WiFiState131(void) {
 if (ACK_Received ==  1 ) {
 ACK_Received =  0 ;
 set_timer(WiFiTimerHandle,4);
 WiFiDisconnect();
 WiFiStateFuncPtr = WiFiState132;
 }
 TimeoutCheck(131);
}


void WiFiState132(void) {
 if (ACK_Received ==  1 ) {
 WiFiEvents.IPAddrAss =  0 ;
 WiFiStateFuncPtr = WiFiState133;
 }
 TimeoutCheck(132);
}

void WiFiState133(void) {
 if (WiFiEvents.IPAddrAss ==  1 ) {
 EraseButton4();
 EraseButton3();
 EraseButton2();
 UpdateLabel19("Disconnected from access point",CL_BLUE);
 WiFiStateFuncPtr = WiFiState0;
 }
 TimeoutCheck(133);
}
#line 1803 "C:/Users/Public/Projects/ARM/Projects/WiFiClick/WiFiTEst_Code/mikroC PRO for ARM/WiFiPlus.c"
void WiFiState666(void) {
#line 1811 "C:/Users/Public/Projects/ARM/Projects/WiFiClick/WiFiTEst_Code/mikroC PRO for ARM/WiFiPlus.c"
 switch (ErrorType[0]) {
 case 60: USB_PutQueue("Baud rate generator error\r\n"); break;
 case 61: USB_PutQueue("Invalid connection profile ID error\r\n"); break;
 case 62: USB_PutQueue("Wi-Fi already connected error\r\n"); break;
 case 63: USB_PutQueue("Wi-Fi already disconnected error\r\n"); break;
 case 64: USB_PutQueue("Close socket failed error\r\n"); break;
 case 65: USB_PutQueue("Socket send to timeout error\r\n"); break;
 case 66: USB_PutQueue("Scan index out of range error\r\n"); break;
 case 67: USB_PutQueue("ICMP ping flood error\r\n"); break;
 case 68: USB_PutQueue("ICMP ping in use error\r\n"); break;
 case 69: USB_PutQueue("Socket reconfirm failed error\r\n"); break;
 case 71: USB_PutQueue("Serial transmit buffer allocation error\r\n"); break;
 case 72: USB_PutQueue("General assert error\r\n"); break;
 case 73: USB_PutQueue("Invalid power save mode error\r\n"); break;
 case 74: USB_PutQueue("Busy (hibernate mode) error\r\n"); break;
 case 75: USB_PutQueue("Busy (scan mode) error\r\n"); break;
 default: USB_PutQueue("Unknown error\r\n"); break;
 }
 WiFiEvents.Error =  0 ;

 WiFiStateFuncPtr = WiFiState0;
}


void TimeoutCheck(unsigned int TimeoutState) {
 char *BufNum;

 if (check_timer(WiFiTimerHandle) == 0) {

 BufNum = GetBuffer();
 sprintf(BufNum,"Timeout in state %u\r\n",TimeoutState);
 USB_PutQueue(BufNum);

 WiFiStateFuncPtr = WiFiState0;
 }
}
