#line 1 "C:/Users/Public/Projects/ARM/Projects/WiFiClick/WiFiTEst_Code/mikroC PRO for ARM/WiFiTest_main.c"
#line 1 "c:/users/public/projects/arm/projects/wificlick/wifitest_code/mikroc pro for arm/wifitest_objects.h"
typedef enum {_taLeft, _taCenter, _taRight} TTextAlign;

typedef struct Screen TScreen;

typedef struct Button_Round {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 char Pen_Width;
 unsigned int Pen_Color;
 char Visible;
 char Active;
 char Transparent;
 char *Caption;
 TTextAlign TextAlign;
 const char *FontName;
 unsigned int Font_Color;
 char Gradient;
 char Gradient_Orientation;
 unsigned int Gradient_Start_Color;
 unsigned int Gradient_End_Color;
 unsigned int Color;
 char Corner_Radius;
 char PressColEnabled;
 unsigned int Press_Color;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TButton_Round;

typedef struct Label {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 char *Caption;
 const char *FontName;
 unsigned int Font_Color;
 char Visible;
 char Active;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TLabel;

typedef struct Image {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 const char *Picture_Name;
 char Visible;
 char Active;
 char Picture_Type;
 char Picture_Ratio;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TImage;

typedef struct Box {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 char Pen_Width;
 unsigned int Pen_Color;
 char Visible;
 char Active;
 char Transparent;
 char Gradient;
 char Gradient_Orientation;
 unsigned int Gradient_Start_Color;
 unsigned int Gradient_End_Color;
 unsigned int Color;
 char PressColEnabled;
 unsigned int Press_Color;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TBox;

typedef struct Box_Round {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 char Pen_Width;
 unsigned int Pen_Color;
 char Visible;
 char Active;
 char Transparent;
 char Gradient;
 char Gradient_Orientation;
 unsigned int Gradient_Start_Color;
 unsigned int Gradient_End_Color;
 unsigned int Color;
 char Corner_Radius;
 char PressColEnabled;
 unsigned int Press_Color;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TBox_Round;

typedef struct Line {
 TScreen* OwnerScreen;
 char Order;
 unsigned int First_Point_X;
 unsigned int First_Point_Y;
 unsigned int Second_Point_X;
 unsigned int Second_Point_Y;
 char Pen_Width;
 char Visible;
 unsigned int Color;
} TLine;

struct Screen {
 unsigned int Color;
 unsigned int Width;
 unsigned int Height;
 unsigned int ObjectsCount;
 unsigned int Buttons_RoundCount;
 TButton_Round * const code *Buttons_Round;
 unsigned int LabelsCount;
 TLabel * const code *Labels;
 unsigned int ImagesCount;
 TImage * const code *Images;
 unsigned int BoxesCount;
 TBox * const code *Boxes;
 unsigned int Boxes_RoundCount;
 TBox_Round * const code *Boxes_Round;
 unsigned int LinesCount;
 TLine * const code *Lines;
};

extern TScreen Screen1;
extern TImage Image1;
extern TBox Box1;
extern TLabel Label1;
extern TLabel Label2;
extern TLabel Label3;
extern TLine Line1;
extern TLabel Label5;
extern TLabel Label6;
extern TLabel Label7;
extern TLabel Label8;
extern TLabel Label9;
extern TLabel Label10;
extern TLabel Label11;
extern TLabel Label12;
extern TLabel Label13;
extern TLabel Label14;
extern TLabel Label15;
extern TLabel Label16;
extern TLabel Label17;
extern TLabel Label18;
extern TLabel Label4;
extern TLabel Label19;
extern TButton_Round ButtonRound1;
extern TButton_Round ButtonRound2;
extern TButton_Round ButtonRound3;
extern TButton_Round ButtonRound4;
extern TButton_Round * const code Screen1_Buttons_Round[4];
extern TLabel * const code Screen1_Labels[19];
extern TImage * const code Screen1_Images[1];
extern TBox * const code Screen1_Boxes[1];
extern TLine * const code Screen1_Lines[1];


extern TScreen Screen2;
extern TBox_Round Qwerty_BoxRound1;
extern TButton_Round Qwerty_ButtonRound1;
extern TButton_Round Qwerty_ButtonRound2;
extern TButton_Round Qwerty_ButtonRound3;
extern TButton_Round Qwerty_ButtonRound4;
extern TButton_Round Qwerty_ButtonRound5;
extern TButton_Round Qwerty_ButtonRound6;
extern TButton_Round Qwerty_ButtonRound7;
extern TButton_Round Qwerty_ButtonRound8;
extern TButton_Round Qwerty_ButtonRound9;
extern TButton_Round Qwerty_ButtonRound10;
extern TButton_Round Qwerty_ButtonRound11;
extern TButton_Round Qwerty_ButtonRound12;
extern TButton_Round Qwerty_ButtonRound13;
extern TButton_Round Qwerty_ButtonRound14;
extern TButton_Round Qwerty_ButtonRound15;
extern TButton_Round Qwerty_ButtonRound16;
extern TButton_Round Qwerty_ButtonRound17;
extern TButton_Round Qwerty_ButtonRound18;
extern TButton_Round Qwerty_ButtonRound19;
extern TButton_Round Qwerty_ButtonRound20;
extern TButton_Round Qwerty_ButtonRound21;
extern TButton_Round Qwerty_ButtonRound22;
extern TButton_Round Qwerty_ButtonRound23;
extern TButton_Round Qwerty_ButtonRound24;
extern TButton_Round Qwerty_ButtonRound25;
extern TButton_Round Qwerty_ButtonRound26;
extern TButton_Round Qwerty_ButtonRound27;
extern TButton_Round Qwerty_ButtonRound28;
extern TButton_Round Qwerty_ButtonRound29;
extern TButton_Round Qwerty_ButtonRound30;
extern TButton_Round Qwerty_ButtonRound31;
extern TButton_Round Qwerty_ButtonRound32;
extern TButton_Round Qwerty_ButtonRound33;
extern TButton_Round Qwerty_ButtonRound34;
extern TButton_Round Qwerty_ButtonRound35;
extern TButton_Round Qwerty_ButtonRound36;
extern TButton_Round Qwerty_ButtonRound37;
extern TButton_Round Qwerty_ButtonRound38;
extern TButton_Round Qwerty_ButtonRound39;
extern TButton_Round Qwerty_ButtonRound40;
extern TButton_Round Qwerty_ButtonRound41;
extern TButton_Round Qwerty_ButtonRound42;
extern TButton_Round Qwerty_ButtonRound43;
extern TButton_Round Qwerty_ButtonRound44;
extern TLabel Qwerty_Label1;
extern TLabel Qwerty_Label2;
extern TButton_Round * const code Screen2_Buttons_Round[44];
extern TLabel * const code Screen2_Labels[2];
extern TBox_Round * const code Screen2_Boxes_Round[1];





void ButtonRound1OnClick();
void ButtonRound2OnClick();
void ButtonRound3OnClick();
void ButtonRound4OnClick();
void Label10OnClick();
void Label13OnClick();
void Label16OnClick();
void Label4OnClick();
void Label7OnClick();
void Qwerty_ButtonRound10OnClick();
void Qwerty_ButtonRound11OnClick();
void Qwerty_ButtonRound12OnClick();
void Qwerty_ButtonRound13OnClick();
void Qwerty_ButtonRound14OnClick();
void Qwerty_ButtonRound15OnClick();
void Qwerty_ButtonRound16OnClick();
void Qwerty_ButtonRound17OnClick();
void Qwerty_ButtonRound18OnClick();
void Qwerty_ButtonRound19OnClick();
void Qwerty_ButtonRound1OnClick();
void Qwerty_ButtonRound20OnClick();
void Qwerty_ButtonRound21OnClick();
void Qwerty_ButtonRound22OnClick();
void Qwerty_ButtonRound23OnClick();
void Qwerty_ButtonRound24OnClick();
void Qwerty_ButtonRound25OnClick();
void Qwerty_ButtonRound26OnClick();
void Qwerty_ButtonRound27OnClick();
void Qwerty_ButtonRound28OnClick();
void Qwerty_ButtonRound29OnClick();
void Qwerty_ButtonRound2OnClick();
void Qwerty_ButtonRound30OnClick();
void Qwerty_ButtonRound31OnClick();
void Qwerty_ButtonRound32OnClick();
void Qwerty_ButtonRound33OnClick();
void Qwerty_ButtonRound34OnClick();
void Qwerty_ButtonRound35OnClick();
void Qwerty_ButtonRound36OnClick();
void Qwerty_ButtonRound37OnClick();
void Qwerty_ButtonRound38OnClick();
void Qwerty_ButtonRound39OnClick();
void Qwerty_ButtonRound3OnClick();
void Qwerty_ButtonRound40OnClick();
void Qwerty_ButtonRound41OnClick();
void Qwerty_ButtonRound42OnClick();
void Qwerty_ButtonRound43OnClick();
void Qwerty_ButtonRound44OnClick();
void Qwerty_ButtonRound4OnClick();
void Qwerty_ButtonRound5OnClick();
void Qwerty_ButtonRound6OnClick();
void Qwerty_ButtonRound7OnClick();
void Qwerty_ButtonRound8OnClick();
void Qwerty_ButtonRound9OnClick();




extern char Image1_Caption[];
extern char Box1_Caption[];
extern char Label1_Caption[];
extern char Label2_Caption[];
extern char Label3_Caption[];
extern char Line1_Caption[];
extern char Label5_Caption[];
extern char Label6_Caption[];
extern char Label7_Caption[];
extern char Label8_Caption[];
extern char Label9_Caption[];
extern char Label10_Caption[];
extern char Label11_Caption[];
extern char Label12_Caption[];
extern char Label13_Caption[];
extern char Label14_Caption[];
extern char Label15_Caption[];
extern char Label16_Caption[];
extern char Label17_Caption[];
extern char Label18_Caption[];
extern char Label4_Caption[];
extern char Label19_Caption[];
extern char ButtonRound1_Caption[];
extern char ButtonRound2_Caption[];
extern char ButtonRound3_Caption[];
extern char ButtonRound4_Caption[];
extern char Qwerty_BoxRound1_Caption[];
extern char Qwerty_ButtonRound1_Caption[];
extern char Qwerty_ButtonRound2_Caption[];
extern char Qwerty_ButtonRound3_Caption[];
extern char Qwerty_ButtonRound4_Caption[];
extern char Qwerty_ButtonRound5_Caption[];
extern char Qwerty_ButtonRound6_Caption[];
extern char Qwerty_ButtonRound7_Caption[];
extern char Qwerty_ButtonRound8_Caption[];
extern char Qwerty_ButtonRound9_Caption[];
extern char Qwerty_ButtonRound10_Caption[];
extern char Qwerty_ButtonRound11_Caption[];
extern char Qwerty_ButtonRound12_Caption[];
extern char Qwerty_ButtonRound13_Caption[];
extern char Qwerty_ButtonRound14_Caption[];
extern char Qwerty_ButtonRound15_Caption[];
extern char Qwerty_ButtonRound16_Caption[];
extern char Qwerty_ButtonRound17_Caption[];
extern char Qwerty_ButtonRound18_Caption[];
extern char Qwerty_ButtonRound19_Caption[];
extern char Qwerty_ButtonRound20_Caption[];
extern char Qwerty_ButtonRound21_Caption[];
extern char Qwerty_ButtonRound22_Caption[];
extern char Qwerty_ButtonRound23_Caption[];
extern char Qwerty_ButtonRound24_Caption[];
extern char Qwerty_ButtonRound25_Caption[];
extern char Qwerty_ButtonRound26_Caption[];
extern char Qwerty_ButtonRound27_Caption[];
extern char Qwerty_ButtonRound28_Caption[];
extern char Qwerty_ButtonRound29_Caption[];
extern char Qwerty_ButtonRound30_Caption[];
extern char Qwerty_ButtonRound31_Caption[];
extern char Qwerty_ButtonRound32_Caption[];
extern char Qwerty_ButtonRound33_Caption[];
extern char Qwerty_ButtonRound34_Caption[];
extern char Qwerty_ButtonRound35_Caption[];
extern char Qwerty_ButtonRound36_Caption[];
extern char Qwerty_ButtonRound37_Caption[];
extern char Qwerty_ButtonRound38_Caption[];
extern char Qwerty_ButtonRound39_Caption[];
extern char Qwerty_ButtonRound40_Caption[];
extern char Qwerty_ButtonRound41_Caption[];
extern char Qwerty_ButtonRound42_Caption[];
extern char Qwerty_ButtonRound43_Caption[];
extern char Qwerty_ButtonRound44_Caption[];
extern char Qwerty_Label1_Caption[];
extern char Qwerty_Label2_Caption[];


void DrawScreen(TScreen *aScreen);
void DrawRoundButton(TButton_Round *Around_button);
void DrawLabel(TLabel *ALabel);
void DrawImage(TImage *AImage);
void DrawBox(TBox *ABox);
void DrawRoundBox(TBox_Round *Around_box);
void DrawLine(TLine *Aline);
void Check_TP();
void Start_TP();
#line 1 "c:/users/public/projects/arm/projects/wificlick/wifitest_code/mikroc pro for arm/timer0.h"
#line 9 "c:/users/public/projects/arm/projects/wificlick/wifitest_code/mikroc pro for arm/timer0.h"
void TimerInit();
void TimerCheck();
#line 31 "c:/users/public/projects/arm/projects/wificlick/wifitest_code/mikroc pro for arm/timer0.h"
struct timers {
 unsigned long int TimerField;
 unsigned short int Free;
};
#line 43 "c:/users/public/projects/arm/projects/wificlick/wifitest_code/mikroc pro for arm/timer0.h"
void init_timerpool(void);
#line 52 "c:/users/public/projects/arm/projects/wificlick/wifitest_code/mikroc pro for arm/timer0.h"
unsigned short int get_timer(void);
#line 61 "c:/users/public/projects/arm/projects/wificlick/wifitest_code/mikroc pro for arm/timer0.h"
void free_timer(unsigned short int nbr);
#line 71 "c:/users/public/projects/arm/projects/wificlick/wifitest_code/mikroc pro for arm/timer0.h"
void set_timer(unsigned short int nbr, unsigned long int tout);
#line 80 "c:/users/public/projects/arm/projects/wificlick/wifitest_code/mikroc pro for arm/timer0.h"
unsigned long int check_timer(unsigned short int nbr);
#line 89 "c:/users/public/projects/arm/projects/wificlick/wifitest_code/mikroc pro for arm/timer0.h"
void irqhandler_timer(void);
#line 1 "c:/users/public/projects/arm/projects/wificlick/wifitest_code/mikroc pro for arm/usb_driver.h"
#line 11 "c:/users/public/projects/arm/projects/wificlick/wifitest_code/mikroc pro for arm/usb_driver.h"
typedef char *pnt;


typedef struct tx_q0_struct {
 unsigned int in;
 unsigned int out;
 pnt q[ 32 ];
}tx_q0_struct;



void USB_Init(void);
void USB_TxQueueInit(void);
void USB_PutQueue(char *msg);
void USB_CheckOut(void);
void USB_CheckIn(void);
#line 1 "c:/users/public/projects/arm/projects/wificlick/wifitest_code/mikroc pro for arm/uart0.h"
#line 20 "c:/users/public/projects/arm/projects/wificlick/wifitest_code/mikroc pro for arm/uart0.h"
typedef void (*tPointerFcn)(void);





void UART0Init(void);
void UART0_Initialize(void);
void UART0_RxQueueInit(void);
void UART0_Receive_Char(void);
char UART0_GetChar(char *rxbyte);

void UART0_Rx(void);
void UART0_Rx1(void);
void UART0_Rx2(void);


void UART0_TxQueueInit(void);
void UART0_PutQueue(char *msg, unsigned int msgsize);

void UART0_Tx(void);
void UART0_Tx1(void);
void UART0_Tx2(void);
#line 1 "c:/users/public/projects/arm/projects/wificlick/wifitest_code/mikroc pro for arm/wifiplus.h"
#line 22 "c:/users/public/projects/arm/projects/wificlick/wifitest_code/mikroc pro for arm/wifiplus.h"
typedef struct {
 char MACAddress[6];
 char IPAddress[4];
 char NetworkMask[4];
 char GatewayAddress[4];
 char NetworkStatus;
} WiFi_Properties;

typedef struct {

 char ConStatChng;
 char ScnRsltRdy;
 char IPAddrAss;
 char PingResp;
 char StartUp;
 char Error;
 char Unknown;

 char ScnRsltMsg;
 char SockCreaResp;
 char SockBindResp;
 char SockConnResp;
 char SockListenResp;
 char SockAccptResp;
 char SockSendResp;
 char SockRcvResp;
 char SockSendToResp;
 char SockRcvFromResp;
 char SockAllocResp;
 char NetStatResp;
 char WpaKeyResp;
 char GpioResp;
} WiFi_Events;


typedef struct {
 char BSSID[6];
 char SSIDLength;
 char SSID[32];
 char APConfig;
#line 78 "c:/users/public/projects/arm/projects/wificlick/wifitest_code/mikroc pro for arm/wifiplus.h"
 int beaconPeriod;
 int ATIMWindow;
 char basicRates[8];
#line 86 "c:/users/public/projects/arm/projects/wificlick/wifitest_code/mikroc pro for arm/wifiplus.h"
 char RSSI;
 char basicRatesListLength;
 char DTIMPeriod;
 char BSSType;
 char Channel;
} WiFi_ScanResult;



void WiFiPlusInit(void);
void WiFiPlusHwReset(void);
void WiFiSwReset(void);
void WiFiSetIpAddr(void);
void WiFiSetNetworkMask(void);
void WiFiSetGatewayAddr(void);
void WiFiSetMacAddr(void);
void WiFiSetArpTime(void);
void WiFiSetNetworkMode(void);
void WiFiSetCpSsid(void);
void WiFiSetRegionalDomain(void);
void WiFiSetChannelList(void);
void WiFiSetListRetryCount(void);
void WiFiSetSecurityWpa(void);
void WiFiSetSecurityWpaBinary(void);
void WiFiScanStart(void);
void WiFiConnect(void);
void WiFiDisconnect(void);
void WiFiPingSend(void);

void WiFiSocketCreate(char SocType);
void WiFiSocketClose(char Handle);
void WiFiSocketBind(char Handle, unsigned int LocalPort);
void WiFiSocketConnect(char Handle);
void WiFiSocketListen(char Handle);
void WiFiSocketAccept(char Handle);
void WiFiSocketSend(char Handle, unsigned short *Data);
void WiFiSocketReceive(char Handle, unsigned int DataLength);
void WiFiSocketSendTo(char Handle, char *Data);
void WiFiSocketReceiveFrom(char Handle, unsigned int DataLength);


void WiFiGetVersion(void);
void WiFiGetNetworkStatus(void);
void WiFiGetWpaKey(void);
void WiFiScanGetResult(unsigned short int Index);



void WiFiApp(void);
void WiFiState0(void);


void WiFiState1(void);
void WiFiState2(void);


void WiFiState4(void);
void WiFiState5(void);
void WiFiState6(void);
void WiFiState7(void);
void WiFiState8(void);
void WiFiState9(void);
void WiFiState10(void);


void WiFiState15(void);
void WiFiState16(void);
void WiFiState17(void);
void WiFiState18(void);
void WiFiState19(void);
void WiFiState20(void);
void WiFiState21(void);
void WiFiState22(void);
void WiFiState23(void);
void WiFiState24(void);
void WiFiState25(void);

void WiFiState30(void);
void WiFiState31(void);

void WiFiState35(void);
void WiFiState36(void);

void WiFiState40(void);
void WiFiState41(void);

void WiFiState45(void);
void WiFiState46(void);

void WiFiState50(void);
void WiFiState51(void);

void WiFiState55(void);
void WiFiState56(void);

void WiFiState60(void);
void WiFiState61(void);

void WiFiState65(void);
void WiFiState66(void);

void WiFiState67(void);
void WiFiState68(void);

void WiFiState70(void);
void WiFiState71(void);

void WiFiState74(void);
void WiFiState75(void);

void WiFiState80(void);
void WiFiState81(void);
void WiFiState82(void);

void WiFiState90(void);
void WiFiState91(void);
void WiFiState92(void);
void WiFiState93(void);
void WiFiState94(void);
void WiFiState95(void);
void WiFiState96(void);
void WiFiState97(void);

void WiFiState100(void);
void WiFiState101(void);
void WiFiState102(void);
void WiFiState103(void);
void WiFiState104(void);
void WiFiState105(void);
void WiFiState106(void);
void WiFiState107(void);
void WiFiState108(void);
void WiFiState109(void);
void WiFiState110(void);
void WiFiState111(void);
void WiFiState112(void);
void WiFiState113(void);

void WiFiState120(void);
void WiFiState121(void);
void WiFiState122(void);
void WiFiState123(void);
void WiFiState124(void);

void WiFiState130(void);
void WiFiState131(void);
void WiFiState132(void);
void WiFiState133(void);


void WiFiState666(void);

void TimeoutCheck(unsigned int TimeoutState);



void ClearAllLabels(void);
void UpdateLabel4(char *msg);
void UpdateLabel5(char *msg);
void UpdateLabel6(char *msg);
void UpdateLabel7(char *msg);
void UpdateLabel8(char *msg);
void UpdateLabel9(char *msg);
void UpdateLabel10(char *msg);
void UpdateLabel11(char *msg);
void UpdateLabel12(char *msg);
void UpdateLabel13(char *msg);
void UpdateLabel14(char *msg);
void UpdateLabel15(char *msg);
void UpdateLabel16(char *msg);
void UpdateLabel17(char *msg);
void UpdateLabel18(char *msg);
void UpdateLabel19(char *msg, unsigned int Color);

void EnableButton2(void);
void EnableButton3(void);
void EnableButton4(void);

void EraseButton2(void);
void EraseButton3(void);
void EraseButton4(void);
#line 1 "c:/users/public/projects/arm/projects/wificlick/wifitest_code/mikroc pro for arm/io.h"
#line 12 "c:/users/public/projects/arm/projects/wificlick/wifitest_code/mikroc pro for arm/io.h"
void IO_Init(void);
#line 26 "C:/Users/Public/Projects/ARM/Projects/WiFiClick/WiFiTEst_Code/mikroC PRO for ARM/WiFiTest_main.c"
void main() {

 Start_TP();
 TimerInit();
 init_timerpool();
 USB_Init();

 UART0Init();
 IO_Init();
 WiFiPlusInit();

 EnableInterrupts();

 while (1) {
 Check_TP();
 TimerCheck();
 USB_CheckIn();
 USB_CheckOut();

 UART0_Receive_Char();
 UART0_Rx();
 UART0_Tx();

 WiFiApp();
 }
}
